define("io.ox/office/drawinglayer/utils/drawingutils",["io.ox/office/tk/utils","io.ox/office/tk/algorithms","io.ox/office/tk/render/rectangle","io.ox/office/editframework/utils/color","io.ox/office/editframework/utils/border","io.ox/office/editframework/utils/attributeutils","io.ox/office/drawinglayer/view/drawinglabels"],function(t,e,r,n,i,o,a){"use strict";function l(t){return"none"===t.type?null:"solid"===t.type?t.color:n.AUTO}function u(t,e,r,n,i,o){var a=r-t,l=n-e;return{left:t+i*a+o*l,top:e+i*l-o*a}}var s=Math.round,c=Math.abs,f=Math.min,h=Math.max,p=Math.sin,g=Math.cos,d=Math.atan2,m=e.modulo,I=e.radius,b=r.Rectangle,v=Math.PI/180,w={};return w.sortDrawingPositions=function(t){return t.sort(e.compareNumberArrays)},w.optimizeDrawingPositions=function(t){var e=0,r=null,n=null;for(w.sortDrawingPositions(t);e+1<t.length;)r=t[e],n=t[e+1],r.length<n.length&&_.isEqual(r,n.slice(0,r.length))?t.splice(e+1,1):e+=1;return t},w.isTwoPointShape=function(t,e){return"connector"===t||"shape"===t&&_.isObject(e)&&(_.isString(e.presetShape)&&a.isPresetConnector(e.presetShape)||_.isArray(e.pathList)&&_.isObject(e.pathList[0])&&e.pathList[0].lineSelection)},w.isOpenSinglePathShape=function(t){var e=t&&t.pathList||null;return e&&1===e.length&&_.isArray(e[0].commands)&&"close"!==_.last(e[0].commands).c},w.isLineEndingShape=function(t){return a.isPresetConnector(t.presetShape)||w.isOpenSinglePathShape(t)},w.hasVisibleBorder=function(t){return!!t&&"string"==typeof t.type&&"none"!==t.type},w.getPresetBorder=function(t){return w.hasVisibleBorder(t)?t.style+":"+i.getPresetForWidth(t.width):"none:none"},w.resolvePresetBorder=function(e){var r=e.split(":");if(2===r.length&&r[0].length>0&&r[1].length>0){var n=i.getWidthForPreset(r[1]);return"none"===r[0]||0===n?{type:"none"}:{type:"solid",style:r[0],width:n}}return t.warn('DrawingUtils.resolvePresetBorder(): invalid preset style "'+e+'"'),{type:"none"}},w.resolveModelsDeeply=function(t,e,r){var n=[];return t.forEach(function t(i){e.call(r,i)&&n.push(i),"group"===i.getType()&&i.forEachChildModel(t)}),n},w.getMixedValue=function(e,r,n){var i=t.getOption(n,"empty",null);if(0===e.length)return i;var o=t.getFunctionOption(n,"equals",_.isEqual),a=null;return e.every(function(t){var e=r(t);return null===e||(null===a?(a=e,!0):o(a,e))})?null===a?i:a:null},w.getMixedAttributeValue=function(t,e,r,n){return w.getMixedValue(t,function(t){return t.getMergedAttributeSet(!0)[e][r]},n)},w.getMixedPresetBorder=function(t){return w.getMixedValue(t,function(t){return w.getPresetBorder(t.getMergedAttributeSet(!0).line)})},w.getMixedBorderColor=function(t){return w.getMixedValue(t,function(t){return l(t.getMergedAttributeSet(!0).line)},{equals:n.isEqual,empty:n.AUTO})},w.getMixedFillColor=function(t){return w.getMixedValue(t,function(t){return l(t.getMergedAttributeSet(!0).fill)},{equals:n.isEqual,empty:n.AUTO})},w.getCssTransform=function(t,e,r){var n=t?"rotate("+t+"deg)":"";return e&&(n+=n.length?" scaleX(-1)":"scaleX(-1)"),r&&(n+=n.length?" scaleY(-1)":"scaleY(-1)"),n},w.transformAttributeSet=function(t,e,r,n,i){var o=t.rotation,a=t.flipH,l=t.flipV,u=m((o+e)*(r!==n?-1:1),360),s=r!==a,c=n!==l;return t={},o!==u&&(t.rotation=u),a!==s&&(t.flipH=s),l===c||i||(t.flipV=c),i&&n&&(t.rotation=m(u+180,360),t.flipH=!s),_.isEmpty(t)?null:t},w.isAngleInButterflyArea=function(t,e,r){return(t=m(e!==r?-t:t,180))>=45&&t<135},w.hasSwappedDimensions=function(t){return w.isAngleInButterflyArea(t.rotation,t.flipH,t.flipV)},w.rotatePointWithAngle=function(t,e,r,n,i){var o=i*v;return u(t,e,r,n,g(o),p(o))},w.getRotatedDrawingPoints=function(t,e){var r=(t=b.from(t)).centerX(),n=t.centerY(),i=e*v,o=g(i),a=p(i),l=[t.topLeft(),t.topRight(),t.bottomRight(),t.bottomLeft()].map(function(t){return u(r,n,t.x,t.y,o,a)}),s=Number.POSITIVE_INFINITY,c=Number.NEGATIVE_INFINITY,d=Number.POSITIVE_INFINITY,m=Number.NEGATIVE_INFINITY;return l.forEach(function(t){s=f(s,t.left),c=h(c,t.left),d=f(d,t.top),m=h(m,t.top)}),{left:s,top:d,right:c,bottom:m,width:c-s,height:m-d,leftTopPoint:l[0]}},w.createDefaultSizeForShapeId=function(t,e,r){var n=a.getPresetAspectRatio(t);return n<1?e=s(e*n):n>1&&(r=s(r/n)),{width:e,height:r}},w.createDefaultShapeAttributeSet=function(e,r,n){var i=a.getPresetShape(r);if(!i)return null;var l={},u=t.getOption(n,"targets",null),s=t.getOption(n,"connector",null);a.isPresetConnector(r)||(l.fill=i.noFill?{type:"none"}:{type:"solid",color:e.createSchemeColor("accent1",0,u)}),l.geometry={presetShape:i.id},t.getBooleanOption(n,"flipH",!1)&&o.insertAttribute(l,"drawing","flipH",!0),t.getBooleanOption(n,"flipV",!1)&&o.insertAttribute(l,"drawing","flipV",!0),l.line=w.resolvePresetBorder("solid:thin"),l.line.color=e.createSchemeColor("accent1",-50,u,{drawing:!0}),_.extend(l.line,i.lineAttrs);var c=e.getApp().isODF(),f=c||i.outerText?"dark1":"light1";return c?(l.character={},l.character.fontName=e.resolveFontName(o.MINOR_FONT_KEY),l.character.fontSize=11):l.character={color:e.createSchemeColor(f,0,u)},_.isEmpty(s)||(l.connector=s),l},w.getParagraphAttrsForDefaultShape=function(t){return t.getApp().isSpreadsheetApp()?null:{paragraph:{alignment:"center"}}},w.getTrackingRectangle=function(e,r,n,i,o){var a=n-e,l=i-r,u=t.getObjectOption(o,"modifierEvent",null),p=t.getBooleanOption(o,"twoPointMode",!1),g=!p&&t.getBooleanOption(u,_.browser.MacOS?"altKey":"ctrlKey",!1),w=t.getBooleanOption(u,"shiftKey",!1),S=t.getObjectOption(o,"boundRect",null),N=S?e-S.left+1:Number.POSITIVE_INFINITY,y=S?S.right()-e:Number.POSITIVE_INFINITY,P=S?r-S.top+1:Number.POSITIVE_INFINITY,O=S?S.bottom()-r:Number.POSITIVE_INFINITY,T=g?f(N,y):a<0?N:y,A=g?f(P,O):l<0?P:O,x=new b(e,r,0,0);if(x.origShift=I(a,l),x.reverseX=a<0,x.reverseY=l<0,T<=0||A<=0)return x;var M=c(a)+1,E=c(l)+1;if(w){if(p){var F=m(d(E,M)/v,360);F<=22.5||F>=157.5&&F<=202.5||F>=337.5?E=1:M=F>=67.5&&F<=112.5||F>=247.5&&F<=292.5?1:E=h(M,E)}else{var V=t.getNumberOption(o,"aspectRatio",1);E=(M=h(M,E*V))/V}var B=f(1,T/M,A/E);M=s(M*B),E=s(E*B)}else M=f(M,T),E=f(E,A);return x.set(g||a<0?e-M+1:e,g||l<0?r-E+1:r,g?2*M-1:M,g?2*E-1:E),p||(x.width<5&&(g&&N>0&&y>0?(x.left=e-2,x.width=5):a<0&&N>=5?(x.left=e-4,x.width=5):a>=0&&y>=5?(x.left=e,x.width=5):(x.left=e,x.width=0)),x.height<5&&(g&&P>0&&O>0?(x.top=r-2,x.height=5):l<0&&P>=5?(x.top=r-4,x.height=5):l>=0&&O>=5?(x.top=r,x.height=5):(x.top=r,x.height=0))),x},w.pointInsideRect=function(t,e,r){var n=t.x,i=t.y,o=r||10;if(_.isFinite(e.rotation)){var a=w.rotatePointWithAngle(e.centerX(),e.centerY(),n,i,e.rotation);n=a.left,i=a.top}return n>=e.left-o&&n<=e.right()+o&&i>=e.top-o&&i<=e.bottom()+o},w.pointCloseToSnapPoint=function(t,e,r){var n=t.x,i=t.y,o=e.x,a=e.y,l=r||15;return c(n-o)<l&&c(i-a)<l},w.checkConnectorFlip=function(t,e,r,n){return t>e&&t+r<e+n||t<e&&t+r>e+n},w.getUniqueConnections=function(t,e){var r=_.filter(t,function(t){return t.startId===e||t.endId===e||t.parentStartId===e||t.parentEndId===e});return r=_.uniq(r,function(t){return t.attrs.drawing.id})},w.generateRecalcConnectorOptions=function(e,r,n,i,o,a,l,u,s){var c=_.isNumber(e.width)?e.width:t.convertLengthToHmm($(a).width()*s,"px"),f=_.isNumber(e.height)?e.height:t.convertLengthToHmm($(a).height()*s,"px"),h=_.isNumber(r.left)?r.left:e.left,p=_.isNumber(r.top)?r.top:e.top;return{widthScale:(_.isNumber(r.width)?r.width:c)/c,heightScale:(_.isNumber(r.height)?r.height:f)/f,newLeft:h,newTop:p,leftDiff:h-e.left,topDiff:p-e.top,rotation:l,rotationStart:u,activeNode:a,drawingFlipH:i,drawingFlipV:o,type:n}},w.getStrechedCoords=function(t,e,r){var n=t.left||0,i=t.right||0,o=t.top||0,a=e*((100-i-n)/100),l=r*(o/100),u=r*((100-(t.bottom||0)-o)/100);return{left:s(e*(n/100)),top:s(l),width:s(a),height:s(u)}},w});