define("io.ox/office/editframework/app/editapplication",["io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/tk/visibility-api-util","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/scheduler","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/dom/domutils","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/app/applicationlauncher","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/view/editlabels","io.ox/office/editframework/utils/operationutils","io.ox/core/api/tab","gettext!io.ox/office/editframework/main"],function(e,t,n,i,o,r,a,s,l,c,u,d,f,p,g,E,O,h,m,I,R,N,S,A,D,v,y,C,F,T,w){"use strict";function b(e){var t=_.isArray(e.actions)&&e.actions.every(_.isObject);return!t&&"actions"in e&&i.error("EditApplication.getActionsFromData(): invalid actions",e.actions),t?e.actions:void 0}function L(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:C.RELOAD_ICON,label:C.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:C.EDIT_ICON,label:C.EDIT_LABEL};break;default:delete e.action}}var U=o.isFiniteNumber,x=r.roundp,M=r.stringEndsWith,H=r.capitalizeFirst,P=l.seleniumLogger,k=f.LOCAL_STORAGE_SUPPORT,j=30,B=-1,G=w("unnamed");return S.extend(function(o,r,l,f,p){function N(e){var t={},n=_.intersection(_.keys(e),Ot);return _.each(n,function(n){t[n]=e[n]}),t}function C(e){var t=we.getState();we.setRootAttribute("data-app-state",t),we.trigger("docs:state",t,e),we.trigger("docs:state:"+t)}function V(){var e=gt?"error":_.isNumber(Ut)?"preview":ot?ft||!at?"readonly":we.hasUnsavedChangesOffice()?"sending":st?"ready":"initial":"offline",t=null;nt!==e&&(t=nt,nt=e,C(t))}function W(e){at!==e&&(at=e,we.trigger("docs:editmode",at),we.trigger(at?"docs:editmode:enter":"docs:editmode:leave"),ox.trigger("docs:editmode",at),V())}function q(e){Kt=_.isObject(e)&&_.isObject(e.action)&&_.isString(e.action.itemKey)&&"document/reload"===e.action.itemKey}function Y(e,t){if("load"===i.getStringOption(e,"action")&&_.isObject(e.file)){var n=e.file.id+"_"+e.file.folder_id,o=n+"_OSN",r=n+"_FILEVERSION",a=n+"_STORAGEVERSION",s=localStorage.getItem(o),l=localStorage.getItem(r);localStorage.getItem(a)>=St&&s&&l&&(s=parseInt(s,10),l=parseInt(l,10),_.isNumber(s)&&_.isNumber(l)&&(t.storageOSN=s,t.storageVersion=l))}}function Q(){return{wantsToEditUser:It,oldWantsToEditUser:Rt,documentFileLockedByUser:pt,fullFileName:we.getFullFileName(),oldEditUser:rt,isEditor:we.isEditor()}}function z(e,t){var n=w("Read-Only Mode"),i=null,o=null,r=null;_.isString(e)?(o={type:"info",message:e,headline:n},isNaN(t)||(o.duration=t),o=_.extend({},o,{action:"acquireedit"})):(r=Q(),i=we.getErrorState(),_.isObject(i)&&(i.isError()||i.isWarning())?o=I.getMessageData(i,r):(i=we.getInfoState(),_.isString(i)&&(o=R.getMessageData(i,r)))),we.extendMessageData(o),Le.yell(o)}function K(){function e(){en=!0}we.getUserSettingsValue("showToolbars",!0)?we.getView().getToolBarTabs().one("tab:activated",e):we.waitForImportSuccess(e)}function Z(e){var t=g.isErrorCode(e)?e:J(e);if(t.setErrorContext(E.CONNECTION),_.isObject(He)){var n=He.hasPendingActions()||we.hasUnsavedChangesOffice();ft=!0,W(!1),n?we.restoreDocument(t):(f.action="load",delete f.template,we.reloadDocument())}else we.setInternalError(t,E.CONNECTION)}function J(e){var t;switch(e){case"reset":t=new g(h.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new g(h.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new g(h.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}function X(){_t=!0,!ot||gt||we.isInQuit()||(Et=at,ot=!1,kt?He.hasPendingActions()?we.setInternalError(h.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,E.OFFLINE):we.setInternalError(h.ERROR_OFFLINE_WHILE_SYNCHRONIZING,E.OFFLINE):(ft=!0,W(!1),V(),we.setInternalError(h.WARNING_READONLY_DUE_TO_OFFLINE,E.OFFLINE)),v.log("Connection offline handler called by Realtime!"))}function ee(){!_t||ot||gt||we.isInQuit()||(v.log("Connection online handler called by Realtime!"),ot=!0,Pt&&(v.log("Client supports synchronization - starting to sync with server"),Et?(we.setInternalError(h.WARNING_SYNC_AFTER_OFFLINE,E.SYNCHRONIZATION),v.log("Client is editor - synchronizing server with current client state"),kt="editSync",jt=null):(we.setInternalError(h.WARNING_SYNC_FOR_VIEWER,E.SYNCHRONIZATION),v.log("Client is viewer - waiting for server messages to unlock view"),kt="viewSync"),we.executeDelayed(function(){Oe(null,null,null,{cause:"timeout"})},"EditApplication.checkSynchronizationState",1e3*j),we.repeatDelayed(function(){kt&&!je&&He.sync()},"EditApplication.connectionOnlineHandler",{delay:0,repeatDelay:1e3*j/12,cycles:10})),V(),z())}function te(){v.log("Reset for connection called by Realtime!"),we.isLocked()||we.isInQuit()||Xt||(Xt=!0,Z("reset")),kt&&Oe(null,null,null,{cause:"reset"})}function ne(){v.log("Connection time out called by Realtime!"),we.isLocked()||we.isInQuit()||Xt||(Xt=!0,Z("timeout"))}function ie(){v.log("NotMember for connection called by Realtime!"),we.isLocked()||we.isInQuit()||Xt||(Xt=!0,Z("notMember")),kt&&Oe(null,null,null,{cause:"notMember"})}function oe(){var e=null;v.log("Processing Stanza failed called by Realtime!"),we.isLocked()||we.isInQuit()||((e=new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)).setErrorContext(E.CONNECTION),we.restoreDocument(e))}function re(e,t){var n=null;we.isInQuit()||((n=new g(t)).isError()||(n=new g(h.ERROR_CONNECTION_HANGUP)),i.warn('EditApplication.connectionHangupHandler: Error code "'+n.getCodeAsConstant()+'"'),n.setErrorContext(E.SYNCHRONIZATION),we.restoreDocument(n,t)),v.log("Server sent a hangup message due to inconsistency between client/server, client osn = "+be.getOperationStateNumber())}function ae(e,t){function n(){we.hasUnsavedChangesOffice()?we.executeDelayed(n,"EditApplication.handlePrepareLosingEditRights.checkForPendingOperations",2e3):cn().then(function(){He.canLoseEditRights(),rt=It||rt,Rt=It,It="",mt=!1,we.getController().update(),v.log("sent canLoseEditRights")})}we.isInQuit()||(mt=!0,we.repeatDelayed(function(){return mt&&Ue===ht?(He.alive(),!0):i.BREAK},"EditApplication.handlePrepareLosingEditRights",{delay:0,repeatDelay:2e3}),_.isObject(t)&&(It=t.wantsToEditUser),W(!1),we.setCurrentInfoState(m.INFO_PREPARE_LOSING_EDIT_RIGHTS),V(),we.getController().update(),It=le(i.getStringOption(t,"wantsToEditUserId","")),$.when(ze.call(we)).always(function(){v.log("handle PrepareLosingEditRights"),we.executeDelayed(n,"EditApplication.handlePrepareLosingEditRights",1e3)}))}function se(e,t){var n=0;we.isInQuit()||(v.log("handleAlive"),mt&&(n=i.getOptionalInteger("serverOSN",t,0),He.alive(),v.log("handled alive request from backend, osn = "+we.getModel().getOperationStateNumber()+", server osn = "+n)))}function le(e){return(_.find(Tt,function(t){return e===t.clientId})||{}).userName||""}function ce(e){we.trigger("docs:editrights",e).trigger("docs:editrights:"+e)}function ue(){we.isInQuit()||we.setCurrentInfoState(m.INFO_EDITRIGHTS_ARE_TRANSFERED),v.log("handle AccepteAcquireEditRights"),ce("accept")}function de(e,t){var n=null;if(!we.isInQuit()){switch(new g(t).getCodeAsConstant()){case"SWITCHEDITRIGHTS_NOT_POSSIBLE_SAVE_IN_PROGRESS_WARNING":n=m.INFO_EDITRIGHTS_SAVE_IN_PROGRESS;break;case"SWITCHEDITRIGHTS_IN_PROGRESS_WARNING":default:n=m.INFO_ALREADY_TRANSFERING_EDIT_RIGHTS}we.setCurrentInfoState(n)}v.log("handle DeclinedAcquireEditRights"),ce("decline")}function fe(e,t){var n=null,i=null;if(!we.isInQuit()&&(n=new g(t)).isWarning()){switch(n.getCodeAsConstant()){case"SWITCHEDITRIGHTS_NEEDS_MORE_TIME_WARNING":default:i=m.INFO_EDITRIGHTS_PLEASE_WAIT}we.setCurrentInfoState(i)}}function pe(e,t){var n=null,o=null,r={};we.isInQuit()||(new g(t).isError()?$t&&$t.reject(t):(n=i.getStringOption(t,"fileId",null),o=i.getStringOption(t,"fileName",null),n&&o?($t&&$t.resolve(t),r.id=n,r.filename=o,r.title=d.getFileBaseName(o),we.updateFileDescriptor(r),f.action="load",delete f.template,st=!1,we.reloadDocument()):$t&&$t.reject(t)))}function ge(){Qt||(we.isInQuit()||we.setInternalError(h.WARNING_CONNECTION_INSTABLE,E.CONNECTION),v.log("handle NoUpdateFromServer"))}function Ee(e,t){var n=new g(t);!we.isInQuit()&&n.isError()&&we.setInternalError(n,E.FLUSH),v.log("handle flushInfo from server")}function _e(e){var t=i.getStringOption(e,"editUserId",""),n=le(t),o=n||e.editUser,r=at,a=r,s=we.getFileDescriptor(),l=be.getOperationStateNumber(),c=i.getIntegerOption(e,"serverOSN",-1),u=new g(e),f=i.getIntegerOption(e,"lockedByUserId",B),p=i.getBooleanOption(e,"writeProtected",null),O=i.getBooleanOption(e,"rescueDoc",null),I=i.getObjectOption(e,"sync",null);if(!gt&&0!==_.intersection(_.keys(e),Ot).length){if(t!==ht&&(v.log("Edit rights changed, new editing user id: "+t),a=Ue===t,we.setCurrentInfoState(m.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1})),i.getBooleanOption(e,"failSafeSaveDone",!1)&&d.propagateChangeFile(s),i.getBooleanOption(e,"hasErrors",!1))return we.setInternalError(h.ERROR_GENERAL_SYNCHRONIZATION_ERROR,E.SYNCHRONIZATION),void v.error("synchronization to the server has been lost.");ft||(Zt&&_.isBoolean(O)&&O?(ft=!0,W(!1),we.setInternalError(h.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,E.READONLY)):_.isBoolean(p)&&p?(ft=!0,W(!1),we.setInternalError(h.WARNING_NO_PERMISSION_FOR_DOC,E.READONLY)):f!==B&&ox.user_id!==f&&(ft=!0,W(!1),we.setInternalError(h.WARNING_DOC_IS_LOCKED,E.READONLY),pt=i.getStringOption(e,"lockedByUser",""))),ft||(v.log("Edit mode: "+a),W(a),ot&&t&&t!==ht&&(ht=t,rt=o),a&&!1===r&&we.setCurrentInfoState(m.INFO_EDITRIGHTS_RECEIVED),ot&&!a&&r&&-1!==c&&l>c&&(we.setInternalError(h.ERROR_GENERAL_SYNCHRONIZATION_ERROR,E.SYNCHRONIZATION),v.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+a+"Old edit mode: "+r+", Server OSN: "+c+", Client OSN: "+l)),!a&&(!ot||r||o!==rt&&o.length)&&(rt=o,we.setCurrentInfoState(m.INFO_USER_IS_CURRENTLY_EDIT_DOC)),(u.isError()||u.isWarning())&&we.setInternalError(u,E.GENERAL)),Oe(t,l,c,null,I),ot=!0,V()}}function Oe(e,t,n,i,o){var r=null,a=null;if(kt){if(v.log("Checking synchronization state with server"),i){switch(i.cause){case"timeout":v.log("Synchronization not possible - maybe connection instance is gone"),(r=new g(h.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(E.SYNCHRONIZATION),kt=null;break;case"notMember":case"reset":case"error:disposed":v.log("Synchronization not possible - connection instance is gone or rt-state broken"),(r=new g(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(E.SYNCHRONIZATION),kt=null}Z(r)}switch(kt){case"editSync":if(_.isObject(o)&&(jt=o),e===ht&&t!==n)return void v.log("Synchronization in progess server osn != client osn");if(e===ht)if(t===n){if(!_.isObject(jt))return;(a=new g(jt)).isError()?(v.log("Synchronization detected bad document consistency state"),a.setErrorContext(E.SYNCHRONIZATION),we.restoreDocument(a)):(v.log("Synchronization successfully completed"),ft=!1,W(!0),we.setCurrentInfoState(m.INFO_SYNCHRONIZATION_SUCCESSFUL))}else v.log("Synchronization not possible - document has been changed"),(r=new g(h.ERROR_SYNCHRONIZATION_DOC_CHANGED)).setErrorContext(E.SYNCHRONIZATION),we.restoreDocument(r);else v.log("Synchronization not possible - editor changed"),(r=new g(h.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(E.SYNCHRONIZATION),we.restoreDocument(r);break;case"viewSync":v.log("Synchronization for viewer completed"),ft=!1}kt=null}}function he(e){var t=we.getFileDescriptor(),n=i.getStringOption(e,"fileName",""),o=i.getStringOption(e,"fileVersion",""),r={};n.length>0&&n!==i.getStringOption(t,"filename")&&(r.filename=n),o.length>0&&o!==i.getStringOption(t,"version")&&(r.version=o),gt||_.isEmpty(r)||(we.updateFileDescriptor(r),we.getController().update(),V())}function me(e,t){var n=null,i=null;return e.length===t.length&&(n=_.copy(e,!0),i=_.copy(t,!0),_.each(n,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(i,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(n,i))}function Ie(e){if(gt)return v.error("EditApplication.applyRemoteActions(): failed due to internal error"),$.Deferred().reject();if(!_.isObject(e))return i.error("EditApplication.applyRemoteActions(): invalid data, expecting object:",e),$.Deferred().reject();var t=b(e);if(!_.isArray(t)||0===t.length)return $.when();v.log("EditApplication.applyRemoteActions(): last remote action: "+JSON.stringify(_.last(t)));var n=be.applyActions(t,{external:!0});return n.done(function(){lt=!0}),n.fail(function(){we&&!we.isInQuit()&&v.error("EditApplication.applyRemoteActions(): failed")}),n}function Re(e){var t=!1,n=be.getOperationStateNumber();return zt&&_.isArray(e)&&e.length>0&&("editSync"===kt&&He.hasPendingActions()?t=!0:_.isObject(e[0]&&_.isArray(e[0].operations))&&(t=n!==e[0].operations[0].osn)),t}function Ne(e){if(we.isInQuit()&&(e={cause:"quit"}),Ht)return{cause:""};var t=new g(e),n=t.getCodeAsConstant(),i=null;switch(gt=!0,Ye.call(we,e),e=_.clone(e),n){case"GENERAL_FILE_NOT_FOUND_ERROR":dt=!0;break;case"NO_ERROR":if((i=g.extractRealtimeError(e))&&i.code&&"RT_STANZA"===i.prefix)switch(v.log("ImportFailedHandler: RT error detected: RT_STANZA-"+i.code),i.code){case 6:case 1009:case 1014:t=new g(h.ERROR_LOAD_DOC_FAILED_SERVER_TOO_BUSY);break;case 1010:t=new g(h.ERROR_CONNECTIONINSTANCE_DISPOSED);break;case 1016:t=new g(h.ERROR_SERVER_DENIES_CONNECTION);break;default:t=new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)}}if(i=e.cause||e.error,!t.isError()&&_.isString(i)){switch(i){case"bad server component":t=new g(h.ERROR_BAD_SERVER_COMPONENT_DETECTED);break;case"timeout":t=new g(h.ERROR_LOAD_DOC_FAILED_SERVER_TOO_BUSY);break;case"0 simulated fail":t=new g(h.ERROR_CONNECTION_RESET_RECEIVED)}if(!t.isError())switch(_.isString(e.code)?e.code:""){case"0000":t=new g(h.ERROR_CONNECTION_TIMEOUT)}}return t.isError()||(t=new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)),we.isInQuit()||we.setInternalError(t,E.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:we.isViewerMode()}),Ht=!0,e}function Se(e){return{operations:e||[]}}function Ae(){return ke&&ke.operations&&ke.operations.length>0}function De(e){if(nn=_.now(),gt)return $.Deferred().reject();var t=$.when(Qe.call(we,e));return t=t.then(cn),t=t.then(function(){return He.flushDocument()}),t=t.then(function(e){var t=$.Deferred(),n=5e3-(_.now()-Be);return n>0?we.executeDelayed(_.noop,"EditApplication.flushDocumentHandler",n).then(function(){t.resolve(e)},function(){t.reject(e)}):t.resolve(e),t})}function ve(e,t){!0===t.currentHiddenState&&we.hasUnsavedDocumentChanges()&&De("user")}function ye(e){if(v.log("pendingUpdates: updates queued, pending = "+(bt.length+1)),bt.length>1&&Ue!==e.editUserId){v.log("pendingUpdates: pending updates must be changed to user: "+e.editUserId+" now.");var t={editUser:e.editUser,editUserId:e.editUserId};_.each(bt,function(e){_.extend(e,t)})}bt.push(e)}function Ce(e,t){Lt[e]=t}function Fe(e,t){_.each(we.getTimerLogCollector(),function(e,t){rn(t,e)}),rn("launchStart",we.getLaunchStartTime()),we.getDocumentVisibleTime()&&rn("documentVisible",we.getDocumentVisibleTime()),rn("triggerImportSuccess",xt),Ce("LocalStorage",yt),Ce("FastEmptyLoad",Mt),Ce("user-agent",navigator.userAgent),Ce("platform",navigator.platform),Ce("user",ox.user),Ce("version",ox.version),Ce("server",ox.abs),Ce("application",t||""),Ce("filename",e&&e.filename?e.filename:"")}function Te(e){var t=_.indexOf(Gt,e);return t<0&&(t=Gt.length,Gt.push(e)),t}var we=this,be=null,Le=null,Ue=null,xe=null,Me=null,He=null,Pe=[],ke=null,je=!1,Be=0,Ge=i.getFunctionOption(p,"preProcessHandler"),Ve=i.getFunctionOption(p,"postProcessHandler"),We=i.getFunctionOption(p,"postProcessHandlerStorage"),qe=i.getFunctionOption(p,"fastEmptyLoadHandler"),$e=i.getFunctionOption(p,"previewHandler"),Ye=i.getFunctionOption(p,"importFailedHandler",_.noop),Qe=i.getFunctionOption(p,"prepareFlushHandler",_.noop),ze=i.getFunctionOption(p,"prepareLoseEditRightsHandler",_.noop),Ke=i.getFunctionOption(p,"prepareRenameHandler",_.noop),Ze=i.getFunctionOption(p,"optimizeOperationsHandler"),Je=i.getFunctionOption(p,"mergeCachedOperationsHandler"),Xe=i.getNumberOption(p,"sendActionsDelay",0),et=i.getBooleanOption(p,"isMultiSelectionApp",!0),tt=i.getBooleanOption(p,"isSnapshotApp",!0),nt=null,it=null,ot=!1,rt=null,at=null,st=!1,lt=!1,ct=null,ut=!1,dt=!1,ft=!1,pt=null,gt=!1,Et=!1,_t=!1,Ot=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","wantsToEditUser","wantsToEditUserId"],ht=null,mt=!1,It=null,Rt=null,Nt=i.getBooleanOption(p,"localStorageApp",!1),St=i.getIntegerOption(p,"requiredStorageVersion",0),At=i.getIntegerOption(p,"supportedStorageVersion",0),Dt=!1,vt=D.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!f.auth_code,yt=!1,Ct={},Ft=1,Tt=[],wt=[],bt=[],Lt={},Ut=null,xt=0,Mt=!1,Ht=!1,Pt=i.getBooleanOption(p,"supportsOnlineSync",!1),kt=null,jt=null,Bt={},Gt=[],Vt=!0,Wt=!1,qt=[],$t=null,Yt=null,Qt=!1,zt=D.ENABLED_RESTORE_DOCUMENT,Kt=!0,Zt=D.RESCUE_DOCUMENT_READONLY,Jt=i.getFunctionOption(p,"newDocumentInitHandler"),Xt=!1,en=!1,tn=0,nn=0;S.call(this,o,r,l,function(){function e(e,t,n){i.info("EditApplication.importHandler(): "+t+" in "+e+"ms"+(_.isString(n)?" ("+n+")":""))}function t(t,n,o,r){var a=_.now(),s=null;return rn(o+"Start",a),(s=_.isFunction(t)?t.call(we):$.when()).fail(function(){i.warn("EditApplication.importHandler(): "+n+" FAILED!")}),s=s.then(function(t){var i=_.now(),s=i-a,l=r>0?x(s/r,.001):0;return e(s,n,r>0?r+" elements, "+l+"ms per element":null),rn(o+"End",i),we.isInQuit()?$.Deferred().reject({cause:"closing"}):t})}function n(e){if(_.isObject(e))switch(e.type){case"reset":we.setInternalError(h.ERROR_CONNECTION_RESET_RECEIVED,E.LOAD),u.reject(h.ERROR_CONNECTION_RESET_RECEIVED);break;case"offline":we.setInternalError(h.ERROR_OFFLINE_WHILE_LOADING,E.LOAD),u.reject(h.ERROR_OFFLINE_WHILE_LOADING);break;case"timeout":we.setInternalError(h.ERROR_CONNECTION_TIMEOUT,E.LOAD),u.reject(h.ERROR_CONNECTION_TIMEOUT);break;case"error:join":we.setInternalError(h.ERROR_CONNECTION_JOIN_FAILED,E.LOAD),u.reject(h.ERROR_CONNECTION_JOIN_FAILED);break;case"error:disposed":we.setInternalError(h.ERROR_CONNECTIONINSTANCE_DISPOSED,E.LOAD),u.reject(h.ERROR_CONNECTIONINSTANCE_DISPOSED);break;case"error:stanzaProcessingFailed":default:we.setInternalError(h.ERROR_UNKNOWN_REALTIME_FAILURE,E.LOAD),u.reject(h.ERROR_UNKNOWN_REALTIME_FAILURE)}}function o(e,t){t&&t.finalLoadUpdate?t.hasErrors?s.reject(t):(s.resolve(t),v.log("Final load update received for asynchronous load")):(a.push(t),v.log("Update received during document import"))}function r(e){function r(e,t){return He.on({hangup:re,preparelosingeditrights:ae,declinedacquireeditrights:de,acceptedacquireeditrights:ue,noUpdateFromServer:ge,flushinfo:Ee,infomessage:fe,renameandreload:pe}),_e(e),rn("editMode"),Yt=i.getStringOption(e.syncInfo,"restore_id",null),Dt=i.getBooleanOption(e,"renameNeedsReload",!1),we.waitForImportSuccess(function(){v.log("Applying document update messages, count = "+t.length),_.each(t,function(e){ln(e)}),v.log("Applying update messages collected during connect/import, count = "+a.length),_.each(a,function(e){ln(e)}),He.off("update",o).on("update",function(e,t){we.applyUpdateMessageData(t)}),He.off("reset",n).on("reset",te),He.off("offline",n).on("offline",X),He.off("timeout",n).on("timeout",ne),He.off("error:stanzaProcessingFailed",n).on("handleCriticalMsgWhileLoading",oe),V(),s.resolve({action:[]})}),$.when()}function l(){return we.getUserInfo(ox.user_id).done(function(e){Me=i.escapeHTML(e.operationName)})}var c=b(e)||[],u=[],E=N(e),O=new g(e),h=null,m=null;return we.isViewerMode()&&(ft=!0,W(!1)),Ue=i.getStringOption(e,"clientId",""),Ct[Ue]=0,h=function(){var t=null;return i.getBooleanOption(e,"hasErrors",!1)?(i.error("EditApplication.importHandler(): server side error"),t={cause:"server"}):i.getBooleanOption(e,"operationError",!1)?(i.error("EditApplication.importHandler(): operation failure"),t={cause:e.message}):O.isError()?(i.error("EditApplication.importHandler(): server side error, error code = "+O.getCodeAsConstant()),t={cause:"server"}):0===Ue.length?(i.error("EditApplication.importHandler(): missing client identifier"),t={cause:"noclientid"}):Mt||d||_.isArray(c)&&0!==c.length||(i.error("EditApplication.importHandler(): missing actions"),t={cause:"noactions"}),t}(),_.isObject(h)?(h=_.extend(h,Ne(e)),$.Deferred().reject(h)):function(){function t(){_.each(u,function(e){localStorage.removeItem(o+e.extension)}),localStorage.removeItem(a),localStorage.removeItem(r),localStorage.removeItem(l),localStorage.removeItem(s)}var n=!0,o=null,r=null,a=null,s=null,l=null,u=null;return"load"===i.getStringOption(f,"action")&&_.isObject(f.file)?(window.Storage&&Nt&&vt&&k&&e.syncInfo&&e.syncInfo.fileVersion&&U(e.syncInfo["document-osn"])&&e.syncInfo.fileId&&e.syncInfo.folderId&&_.isFunction(be.setFullModelNode)&&_.isFunction(be.getSupportedStorageExtensions)&&(o=e.syncInfo.fileId+"_"+e.syncInfo.folderId,l=o+"_FILEVERSION",r=o+"_STORAGEVERSION",a=o+"_OSN",s=o+"_OPERATIONS",u=be.getSupportedStorageExtensions(),(localStorage.getItem(r)&&parseInt(localStorage.getItem(r),10)||1)>=St?(i.info("EditApplication.importHandler(): document-osn="+e.syncInfo["document-osn"]+", document-rev="+e.syncInfo.fileVersion),localStorage.getItem(l)&&localStorage.getItem(l)===e.syncInfo.fileVersion&&localStorage.getItem(a)&&parseInt(localStorage.getItem(a),10)===parseInt(e.syncInfo["document-osn"],10)?function(){var e=JSON.parse(localStorage.getItem(s)),t={},n=null,i=null;return!!e&&(t.operations=e,c&&c[0]&&c[0].operations&&(n=c[0].operations,_.each(n,function(e){t.operations.push(e)}),be.setExternalLocalStorageOperationsExist(!0)),(c=[]).push(t),i=_.last(c[0].operations),_.isNumber(i.osn)||(i.opl=1,i.osn=parseInt(localStorage.getItem(a),10)-1),!0)}()?u.some(function(e){var n=o+e.extension,r={usedLocalStorage:!0};_.isObject(e.additionalOptions)&&_.extend(r,e.additionalOptions);var s=localStorage.getItem(n);if(s)i.info("EditApplication.importHandler(): loading document from local storage. Key: "+n+" Length: "+localStorage.getItem(n).length),yt=!0,be.setFullModelNode(s,r);else{if(!e.optional)return i.info("EditApplication.importHandler(): key in local storage not found. Key: "+n+". But found OSN key: "+a),t(),yt=!1,!0;i.info("EditApplication.importHandler(): optional local storage value not found. Key: "+n)}}):(i.info("EditApplication.importHandler(): required operations in local storage not found. Key: "+s),t()):(i.info("EditApplication.importHandler(): file in local storage not found. Key: "+o),t())):(i.info("EditApplication.importHandler(): version of file in local storage not supported. Key: "+o),t())),yt&&be.trigger("update:model",{usedLocalStorage:!0}),D.AUTOTEST&&!yt&&e.syncInfo.fileVersion>1&&D.getFlag(we.getDocumentType()+"/debugUseLocalStorage")&&(n=!1),n):n}()?(function(){var t=null,n="",o=i.getBooleanOption(e,"fastLoad",!1);yt||(!e.htmlDoc&&D.DEBUG&&!Mt&&be.setFullModelNode&&o&&we.getFileDescriptor()&&!M(we.getFileDescriptor().filename,"_ox")&&Le.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),e.htmlDoc&&_.isFunction(be.setFullModelNode)&&!Mt&&(i.info("EditApplication.importHandler(): load complete HTML document, osn: ",e.syncInfo["document-osn"]),(t=JSON.parse(e.htmlDoc)).mainDocument&&be.setFullModelNode(t.mainDocument),t.headerFooter&&(_.each(t.headerFooter,function(e){n+=e}),be.setFullModelNode(n,{headerFooterLayer:!0}),be.getPageLayout().headerFooterCollectionUpdate()),t.comments&&(n="",_.each(t.comments,function(e){n+=e}),be.setFullModelNode(n,{commentLayer:!0})),be.trigger("fastload:done")))}(),u.push(E),Mt?r(e,u).then(l):(m=t(Ge,"preprocessing finished","preProcessing"),m=m.then(l).then(function(){var n={external:!0},a=null;return a=t(function(){var e=i.getBooleanOption(p,"applyActionsDetached",!1);return e&&Le.detachAppPane(),be.applyActions(c,n).always(function(){e&&Le&&!Le.destroyed&&Le.attachAppPane()})},"operations applied","applyActions",D.DEBUG?c.reduce(function(e,t){return e+i.getArrayOption(t,"operations",[]).length},0):0),a=a.then(function(){var n=null;return be.getOperationStateNumber()<0?$.Deferred().reject({cause:"applyactions",headline:w("Synchronization Error")}):(n=t(yt&&!be.externalLocalStorageOperationsExist()?We:Ve,"postprocessing finished","postProcessing"),n=n.then(function(){return r(e,u)},function(e){return _.extend({cause:"postprocess"},e)}))},function(e){if(He&&He.off("update",o),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)}))):$.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")})}var a=[],s=we.createDeferred("EditApplication.asynchronousLoadFinished"),l=null,u=c.createDeferred(we,"EditApplication.importHandler@connect"),d=!1;return rn("importDocStart"),be.getUndoManager().on("undogroup:open",function(){ke=Se()}),be.getUndoManager().on("undogroup:close",function(){Ae()&&un(ke),ke=null}),be.on("operations:success",function(e,t,n){n||Wt||(_.isObject(ke)?(v.log("operations:success - push operations into pending action"),ke.operations=ke.operations.concat(t)):un(Se(t)))}),be.on("cacheBuffer:flush",function(){v.log("cacheBuffer:flush received - send cached operations"),_.isFunction(Je)&&qt.length&&(Pe=Je.call(we,Pe,qt),cn())}),be.on("operations:error",function(){we.isImportFinished()?(we.setInternalError(h.ERROR_WHILE_MODIFYING_DOCUMENT,E.GENERAL),v.error("An unrecoverable error occurred while modifying the document")):(we.setInternalError(h.ERROR_WHILE_LOADING_DOCUMENT,E.GENERAL),v.error("An unrecoverable error occurred while loading the document"))}),we.getWindowNode().on("drop",!1),(He=we.isViewerMode()?new y(we,p):new v(we,p)).on({online:ee,offline:n,timeout:n,"error:notMember":ie,reset:n,"error:stanzaProcessingFailed":n,"error:joinFailed":n,"error:disposed":n,update:o,alive:se}),Mt||Le.enterBusy({cancelOnReadOnly:!1,cancelHandler:function(){we.quit()},immediate:!0,topLabel:_.noI18n(we.getFullFileName()),warningLabel:w("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4}),e(0,"initialization finished"),on(),l=t(function(){var e={fastEmpty:Mt,useLocalStorage:vt,app:we.getDocumentType(),newDocument:"new"===i.getStringOption(f,"action")};return f.auth_code&&(e.auth_code=f.auth_code),Mt&&_.extend(e,{osn:be.getOperationStateNumber()}),!Mt&&vt&&k&&Y(f,e),He.connect(e).then(function(t){!t.actions&&t.syncInfo&&e.storageOSN===parseInt(t.syncInfo["document-osn"],10)&&(d=!0),u.resolve(t)},function(e){u.reject(e)}),we.createAbortablePromise(u)},"actions downloaded","connect"),(l=l.then(function(e){var n=new g(e),o=i.getBooleanOption(e,"syncLoad",!1),a=i.getObjectOption(e,"preview"),l=$.when();return a&&_.isArray(a.operations)&&(l=function(){var n=t(Ge,"preview preprocessing finished","previewPreProcessing");return n=n.then(function(){Ge=null;var t=be.applyActions({operations:e.preview.operations},{external:!0});return(t=t.then(function(){return $e.call(we,a)?we.leaveBusyDuringImport():$.when()},function(t){t&&"abort"===t||(e.operationError=!0,e.message=w("An unrecoverable error occurred while modifying the document."),o=!0)})).always(function(){rn("previewEnd")}),t})}()),l=l.then(function(){return o||n.isError()?r(e):t(function(){return s.then(function(e){return r(e)},function(e){throw Ne(_.extend({cause:"asyncload"},e))})},"asynchronous import","asyncLoad")})}).catch(function(e){return we.createRejectedPromise(Ne(e))})).always(function(){Ut=null,V(),rn("leaveBusy")}),l},f,_.extend({},p,{initFileHandler:function(){function e(e){return we.setInternalError(e,E.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}if(!_.isObject(this)||!_.isObject(we)||!_.isObject(f))return i.warn("EditApplication.initFileHandler() called on an already destroyed instance."),$.Deferred().reject();var t={},n=!1;f.cryptoAction&&(t.cryptoAction=f.cryptoAction),f.decrypt_auth_code&&(t.cryptoAuth=f.decrypt_auth_code,t.encrypted_file=!0);var o=be.getFontCollection().importReplacementFonts();switch(i.getStringOption(f,"action","load")){case"load":return o.then(function(){return d.getFile(f.file).done(function(e){f.file=e})});case"convert":n=!0;break;case"new":_.extend(t,i.getObjectOption(p,"newDocumentParams"));break;default:return i.error("EditApplication.initFileHandler(): unsupported launch action"),$.Deferred().reject()}var r=i.getObjectOption(f,"templateFile"),a=i.getBooleanOption(f,"preserveFileName",!1),l=i.getStringOption(f,"target_filename",G),c=i.getStringOption(f,"target_folder_id",""),u=i.getObjectOption(r,"origin");rn("createNewDocStart"),_.extend(t,{action:"createdefaultdocument",document_type:we.getDocumentType(),target_filename:l,target_folder_id:c,preserve_filename:a,convert:n}),f.template&&_.extend(t,{action:"createfromtemplate",file_id:r.id}),_.isObject(r)&&_.extend(t,{file_id:r.id,version:r.version}),we.waitForImportSuccess(function(){var e=!f.template&&c!==i.getStringOption(we.getFileDescriptor(),"folder_id");(n=f.template?we.getFileDescriptor().converted:n)?e?we.setCurrentInfoState(m.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER):we.setCurrentInfoState(m.INFO_DOC_CONVERTED_AND_STORED):e&&we.setCurrentInfoState(m.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});var O=_.url.hash("fields"),h=_.url.hash("fields-source");return(O||h)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),t.fields=O,t.sourcefields=h),o=o.then(function(){return we.sendRequest(s.FILTER_MODULE_NAME,t)}),o=o.then(function(t){rn("createNewDocAfterRequest");var n=new g(t);return n.isError()?e(n):t},function(){return e()}),o=o.then(function(e){return d.getFile(e.file).then(function(t){return e.file=t,e})}),(o=o.then(function(e){function t(e){var t="resolved"===n.state();return(we.isPresentationApp()?we.createResolvedPromise():we.leaveBusyDuringImport(!t,{immediateShow:!0})).then(function(){return rn("afterLeaveBusyEarly"),t?e:$.Deferred().reject(e)},function(){return t?arguments[0]:e})}var n=null;return _.isObject(e.file)?(u&&(e.file.origin=u),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(Mt=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&e.operations.length>0)&&qe?(n=qe.call(we,e.htmlDoc,{operations:e.operations})).then(t,t).then(function(){return e}):e):(i.error("EditApplication.initFileHandler(): missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:De,messageDataHandler:L,printOptionsHandler:function(){return{rtid:_.isObject(He)?He.getUuid():null,app:we.getDocumentType()}}}));var on=D.DEBUG?function(){vt=we.getUserSettingsValue("debugUseLocalStorage",vt)&&!we.isDocumentEncrypted()}:$.noop,rn=D.LOG_PERFORMANCE_DATA?function(e,t){var n=t||_.now(),i=e+"Duration";Ce(e+"Absolute",n),Ce(i,n-we.getLaunchStartTime())}:$.noop,an=D.LOG_PERFORMANCE_DATA?function(){var e=we.getView().getToolBarTabs(),t=0;e.on("tab:activated",function n(i,o){t++,o&&rn(i.type+"_"+H(o)+"_"),2===t&&e.off("tab:activated",n)})}:$.noop,sn=this.createSynchronizedMethod("EditApplication.applyUserData",function(e){var t=wt,n=[];return _.isArray(e.activeUsers)?(e.activeUsers.forEach(function(e){_.isObject(e)&&_.isString(e.userId)&&_.isNumber(e.id)?n.push(we.getUserInfo(e.id).then(function(t){return e.userDisplayName=t.displayName,e.userOperationName=t.operationName,e})):i.warn("EditApplication.applyUserData(): missing identifier")}),we.createResolvedPromise().then(function(){return $.when.apply($,n)}).done(function(){Tt=_.map(arguments,function(e){var t={};return t.clientId=e.userId,t.userId=e.id,t.userName=e.userDisplayName,t.userOperationName=e.userOperationName,t.guest=e.guest,t.active=!0===e.active||_.isNumber(e.durationOfInactivity)&&e.durationOfInactivity<60,t.remote=Ue!==t.clientId,t.editor=ht===t.clientId,_.isObject(e.userData)&&(t.userData=e.userData),t.clientId in Ct||(Ct[t.clientId]=Ft,Ft+=1),t.clientIndex=Ct[t.clientId],t.colorIndex=we.getAuthorColorIndex(t.userOperationName),t}),wt=_.where(Tt,{active:!0}),wt=_.sortBy(wt,"clientIndex"),_.isEqual(t,wt)||(i.info("EditApplication.applyUserData(): activeClients=",wt),me(t,wt)||we.trigger("docs:users",wt),we.trigger("docs:users:selection",wt))})):we.createResolvedPromise()}),ln=this.createSynchronizedMethod("EditApplication.applyUpdateMessageData",function(e,t){v.log("EditApplication.applyUpdateMessageData(): received update message:",e);var n=null;if(!Re(b(e)))return(n=Ie(e)).done(function(){_e(e),he(e),sn(e),bt.shift(),v.log("EditApplication.applyUpdateMessageData(): update processed, pending = "+bt.length),i.getBooleanOption(t,"notify",!1)&&we.trigger("docs:update",e)}),n;we.restoreDocument(new g(h.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS))}),cn=function(){function e(){if(v.debug&&mt&&Pe&&Pe.length>0){var n=Pe[Pe.length-1].operations;n&&n.length>0&&i.log("EditApplication.sendActionsBuffer(): last action:",_.last(n))}Ze&&(Pe=Ze.call(we,Pe)),Pe=F.handleMinifiedActions(Pe),He.sendActions(Pe).done(function(){gt?(v.error("EditApplications.sendActionsBuffer(): sent successfully, but internal error detected!"),t.reject()):0===Pe.length?t.resolve():e()}).fail(function(e){v.error("EditApplications.sendActionsBuffer(): rtConnection.sendActions promise failed!"),t.reject(e)}),Pe=[]}var t=null;return function(){return v.log("EditApplication.sendActions(): entered"),je?(v.log("EditApplication.sendActions(): sending in progress - using current promise"),t.promise()):gt?(v.error("EditApplication.sendActions(): internal error detected - promise rejected!"),$.Deferred().reject()):0===Pe.length?(v.log("EditApplication.sendActions(): no need to send action buffer empty"),$.when()):(t=c.createDeferred(we,"EditApplication.sendActions").always(function(){v.log("EditApplication.sendActions(): current send promise resolved - sendingActions = false"),je=!1,Be=_.now(),V()}),je=!0,V(),e(),t.promise())}}(),un=function(){var e=we.createDebouncedMethod("EditApplication.storeAndSendDebounced",function(e){var t=!1;v.withLogging(function(){var t=e.operations.length>0?JSON.stringify(_.last(e.operations)):null;v.log("EditApplication.storeAction(): "+(t?"last operation: "+t:"no operations provided"))}),Je&&qt.length>0&&(Pe=Je.call(we,Pe,qt),Je=null,qt=[],t=!0),!gt&&(e.operations.length>0||t)&&(e.operations.length>0&&Pe.push(e),st=!0,tn=_.now(),V())},cn,{delay:Xe,maxDelay:5*Xe});return function(t){Vt?e(t):(v.log("evaluateAction: distribute = false, operations must be cached"),qt.push(t))}}();this.isEditor=function(){return Ue===ht},this.getNumOfPendingRemoteUpdates=function(){return bt.length},this.leaveBusyDuringImport=_.once(function(e,t){return Ut=_.now(),rn("previewStart"),V(),Le.showAfterImport(e,t)}),this.createDebouncedActionsMethodFor=function(e,t,n,i,o){var r=!1;return e.createDebouncedMethod(t,n,function(){if(!r){if(!we.isImportFinished()||!be.isProcessingActions())return i.call(e);var t=be.waitForActionsProcessed();r=!0,e.waitForSuccess(t,function(){r=!1,i.call(e)})}},o)},this.getFileFormat=function(){var e;return null===xe&&(e=this.hasFileDescriptor()?this.getFullFileName():f&&f.templateFile?f.templateFile.filename:"",xe=e?A.getFileFormat(e):null),xe||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&A.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&A.isScriptable(this.getFullFileName())},this.getClientId=function(){return Ue},this.getEditClientId=function(){return ht},this.getClientOperationName=function(){return Me},this.getPendingActions=function(){return Pe},this.getActiveClients=function(){return wt},this.isLocallyModified=function(){return st},this.isPrepareLosingEditRights=function(){return mt},this.sendRealTimeQuery=function(e,t){return _.isNumber(t)||(t=2e4),He.sendQuery(e,t)},this.sendActionRequest=function(e,t,n){return n=_.extend({method:"POST"},n),He?this.sendFileRequest(s.FILTER_MODULE_NAME,{action:e,requestdata:JSON.stringify(t),rtdata:JSON.stringify({rtid:He.getUuid(),session:ox.session})},n):$.Deferred().reject()},this.sendQueryRequest=function(e,t,n){return this.sendActionRequest("query",_.extend({},t,{type:e}),n)},this.applyUpdateMessageData=function(e){return _.isObject(e)?(ye(e),ln(e,{notify:!0})):(i.error("EditApplication.applyUpdateMessageData(): invalid response (object expected):",e),this.setInternalError(h.ERROR_WHILE_MODIFYING_DOCUMENT,E.GENERAL),$.Deferred().reject())},this.sendLogMessage=D.LOG_ERROR_DATA?function(e){return He&&He.sendLogMessage(e),this}:i.NOOP,this.rename=function(e){var t=this.getFileDescriptor(),n=i.getStringOption(t,"filename",this.getFullFileName()),o=i.getStringOption(t,"com.openexchange.file.sanitizedFilename",n),r=i.trimAndCleanString(e),a=i.getActiveElement();return ct?(i.warn("EditDocument.rename(): multiple calls, ignoring subsequent call"),ct):0===r.length?$.Deferred().reject():r===this.getShortFileName()?$.when():(r+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(r+=".pgp"),this.updateFileDescriptor({filename:r}),$t=this.createDeferred("EditApplication.renameAndReload",{background:!0}),ct=$.when(Ke.call(we)).then(cn).then(function(){return we.sendActionRequest("renamedocument",{target_filename:r})}),(ct=ct.then(function(e){var t=new g(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?$t.promise():t.isError()?$.Deferred().reject(t):e})).done(function(e){ut=!0,we.updateFileDescriptor({filename:i.getStringOption(e,"fileName",n),"com.openexchange.file.sanitizedFilename":i.getStringOption(e,"com.openexchange.file.sanitizedFilename",o)})}),ct.fail(function(e){var t=null,o=g.isErrorCode(e)?e:new g(e);"abort"!==e&&(o.setErrorContext(E.RENAME),(t=I.getMessageData(o)).onlyOnce=!0,i.warn("EditApplication.rename() error: "+o.getErrorText()),Le.yell(t)),we.updateFileDescriptor({filename:n})}),ct.always(function(){ct=null,_.browser.IE&&a&&!ox.office&&i.setFocus(a)}),ct)},this.hasUnsavedChangesOffice=function(){return je||!!ct||Pe.length>0||Ae()},this.hasUnsavedChanges=function(){var e=ox.tabHandlingEnabled&&"follower"===T.TabHandling.getLoggingOutState(),t=He&&!He.isEmergencyLeavePossible();return!e&&(this.hasUnsavedChangesOffice()||t)},this.saveChanges=function(){return cn()},this.setUserState=function(e){return this.isInternalError()||it===e||(it=e,C()),this},this.getState=function(){return it&&!this.isInternalError()?it:nt},this.isEditable=function(){return at},this.isOffline=function(){return"offline"===nt},this.isInternalError=function(){return"error"===nt},this.setInternalError=function(e,t,n,o){var r=g.isErrorCode(e)?e:new g(e),a=null,s=null,l=null,c=!0,u=i.getObjectOption(o,"additionalData",{}),d=g.isErrorCode(n)?n:_.isString(n)?new g(n):r,f=!1;_.isString(t)&&r.setErrorContext(t),a=we.getErrorState(),_.isObject(a)&&a.isError()?r=a:(we.setErrorState(r),f=!0),l=we.getErrorState(),g.isErrorCode(l)&&i.error("Internal error: "+l.getErrorText()),r.isError()&&f?(gt=!0,ot=!1,ft=!0,W(!1),V()):r.isWarning()&&(c=!_.has(Bt,r.getCodeAsConstant()),Bt[r.getCodeAsConstant()]=!0),s=I.getMessageData(r,_.extend({causeError:d,viewerMode:we.isViewerMode()},Q(),u)),we.extendMessageData(s),q(s),i.getBooleanOption(o,"showMessage",!0)&&c&&Le&&Le.yell&&Le.yell(s)},this.setCurrentInfoState=function(e,t){var n=null,o=i.getBooleanOption(t,"showMessage",!0);we.setInfoState(e),o&&(n=R.getMessageData(e,_.extend({},Q(),t)),we.extendMessageData(n),_.isObject(n)&&Le.yell(n))},this.isLocked=function(){return gt||ft},this.isAcquireEditRightsEnabled=function(){return _.isObject(He)&&!this.isLocked()&&!this.isOffline()&&!at},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&this.getNumOfPendingRemoteUpdates()<=1},this.acquireEditRights=_.throttle(function(){this.isAcquireEditRightsEnabled()&&(He.acquireEditRights(),ce("acquire"))},3e3),this.isReloadEnabled=function(){return Kt},this.isAutoSaveEnabled=function(){return!0},this.doesRenameNeedReload=function(){return Dt},this.toggleAutoSave=function(){return Le.yell({type:"info",headline:w("What is AutoSave?"),message:w("In OX Documents all your changes are saved automatically through AutoSave. It is not necessary to save your work manually.")}),this},this.saveDocumentAs=function(t,n,o){var r=_.isString(t)?i.trimAndCleanString(t):"",a=null,s=null;if(0===r.length)return $.Deferred().reject();if("pdf"===o){r+=".pdf";var l=we.getFileDescriptor();s=(s=(s=we.flushDocument("download")).then(function(){return d.propagateChangeFile(l)})).then(function(){return d.getFileModelFromDescriptor(l).then(function(t){return e.sendConverterRequest(t,{documentformat:o,saveas_filename:r,saveas_folder_id:n})})})}else s="encrypted"===o?(s=d.authorizeGuard().then(function(e){return f.auth_code=e,De("copy")})).then(function(){var e=we.getFileDescriptor(),t=e.file_options||{},i=t.params||{};return _.extend(i,{cryptoAction:"Encrypt",filedisplay:r+"."+we.getFileExtension()+".pgp",ignoreWarnings:!1}),e.file_options=_.extend(t,{params:i}),d.copyFile(e,n)}):we.sendActionRequest("copydocument",{file_id:we.getFileParameters().id,target_filename:r,asTemplate:"template"===o,target_folder_id:n});return s=s.then(function(e){var t=new g(e);return t.isError()?$.Deferred().reject(t):e}),s=s.then(function(e){return d.deleteFromCache(n),d.getPath(n).then(function(t){return a=d.preparePath(t),e})}),(s="pdf"===o?s.then(function(e){if("cause"in e)throw e;var t=i.getStringOption(e,"filename",r);return we.setCurrentInfoState(m.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:t,fullPathName:a,type:"success",duration:1e4}),e}):s.then(function(e){var t=i.getStringOption(e,"folder_id",null),s=i.getStringOption(e,"filename",r);W(!1),"template"===o&&we.setCurrentInfoState(m.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:s,fullPathName:a,type:"success",duration:1e4});var l=i.getStringOption(e,"id",null);l||"encrypted"!==o||(l=_.isArray(e)?i.getStringOption(_.first(e),"data",null):e);var c=n||t;return d.getFile({id:l,folder_id:c}).done(function(e){e.title=d.getFileBaseName(e.filename),we.updateFileDescriptor(e),f.action="load",delete f.template,we.reloadDocument()})})).fail(function(e){if("cancel"!==e){(e=g.isErrorCode(e)?e:new g(g.GENERAL_ERROR)).setErrorContext(E.SAVEAS);var t=I.getMessageData(e,Q());i.warn('EditApplication.saveDocumentAs(): Error code "'+e.getCodeAsConstant()+'"'),Le.yell({type:t.type,headline:t.headline,message:t.message})}}),s},this.reloadDocument=function(){var e=this.getFileDescriptor(),t=this.getFullFileName(),n=A.getEditModule(t);if(!n)return i.error("EditApplication.reloadDocument(): unknown application type"),this;if(!A.isNative(t))return i.error("EditApplication.reloadDocument(): unsupported document type"),this;var o={action:"load",file:e};return f.auth_code&&(o.auth_code=f.auth_code),this.quit("reload").done(function(){_.delay(function(){ox.launch(n+"/main",o)},1e3)})},this.restoreDocument=function(e,t){var n=i.getArrayOption(t,"actions",null),o=we.getFileDescriptor(),r=null;if(zt){if(!Qt){Qt=!0,r=_.isNull(n)?function(e,t){var n=F.getActionsArray(e),i=F.getActionsArray(t);return _.isArray(n)&&_.isArray(i)?n.concat(i):n}(He.getPendingActions(),we.getPendingActions()):n,ft=!0,W(!1),V(),gt=!0;var a={action:"saveaswithbackup",file_id:o.id,target_filename:o.filename,target_folder_id:o.folder_id,restore_id:Yt,operations:_.isNull(r)?r:JSON.stringify(r)};we.sendFileRequest(s.FILTER_MODULE_NAME,a,{method:"POST"}).then(function(t){var n=new g(t),o=c.createDeferred(we,"EditApplication.restoreDoc"),r=i.getStringOption(t,O.RESTORED_FILEID,null),a=i.getStringOption(t,O.RESTORED_FILENAME,null),s=i.getStringOption(t,O.RESTORED_FOLDERID,null),l=null,u={};_.isObject(t)&&_.isString(a)&&_.isString(s)?d.getPath(s).always(function(e){l=d.preparePath(e),o.resolve(l)}):o.resolve(null),o.always(function(t){var i=_.isString(t);n.isError()||(n=new g({errorClass:g.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),u[O.RESTORED_FILENAME]=a,u[O.RESTORED_PATHNAME]=l,u[O.ORIGINAL_FILEID]=we.getFileDescriptor().id,i&&we.updateFileDescriptor({id:r,folder_id:s}),we.setInternalError(n,e.getErrorContext(),e,{additionalData:u})})},function(){we.setInternalError(e)})}}else we.setInternalError(e)},this.rejectEditAttempt=function(e){if(we.isViewerMode())return this;switch(e){case"image":Le.yell({type:"info",message:w("The image could not be inserted.")});break;case"siri":we.setInternalError(h.ERROR_SIRI_NOT_SUPPORTED,E.GENERAL);break;case"loadingInProgress":we.setCurrentInfoState(m.INFO_LOADING_IN_PROGRESS);break;case"android-ime":we.setInternalError(h.ERROR_ANDROID_IME_NOT_SUPPORTED_KEYBOARD,E.GENERAL);break;default:we.isImportFinished()?z():we.setCurrentInfoState(m.INFO_LOADING_IN_PROGRESS)}return this},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return t.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),i=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name+" "+e.last_name):e.last_name?_.noI18n(e.last_name):e.first_name?_.noI18n(e.first_name):n;return{id:e.user_id,displayName:n,operationName:i,guest:t}})},this.updateUserData=function(){var e=null;return we.createDebouncedMethod("EditApplication.updateUserData",function(t){return e=t,this},function(){!He||gt||we.isInQuit()||He.updateUserData("updateuserdata",e)},{delay:500,maxDelay:1e3})}(),this.getAuthorColorIndex=function(e){return a.getSchemeColor(Te(e))},this.addAuthors=function(e){return Gt=_.union(Gt,e),this},this.stopOperationDistribution=function(e){Vt=!1,(_.isFunction(e)?we.convertToPromise(e.call(we)):$.when()).always(function(){Vt=!0})},this.isOperationsBlockActive=function(){return Wt},this.enterBlockOperationsMode=function(e){Wt=!0,Ae()&&(we.trigger("docs:operations:remove",ke.operations.length),ke=Se()),_.isFunction(e)&&e.call(we),Wt=!1},this.isMultiSelectionApplication=function(){return et},this.isSnapshotApp=function(){return tt},this.isFirstTabActivated=function(){return en},this.debugTriggerRealtimeEvent=D.DEBUG?function(e){return He.trigger(e),this}:$.noop,this.debugSendInvalidOperation=D.DEBUG?function(e){var t=i.getBooleanOption(e,"badOsn",!1),n=[],o=t?be.getOperationStateNumber()+1e3:be.getOperationStateNumber(),r=i.getObjectOption(e,"operation",null),a=null;return r&&(r=_.extend(r,{osn:o,opl:1}),n.push(r),t||be.setOperationStateNumber(o+1),a=[{operations:n}],a=F.handleMinifiedActions(a),He.sendActions(a)),this}:$.noop,this.debugQuit=D.DEBUG?function(e){switch(e){case"unsaved":var t=this.hasUnsavedChangesOffice;return this.hasUnsavedChangesOffice=_.constant(!0),this.quit().fail(function(){we.hasUnsavedChangesOffice=t});case"error":return He.closeDocument=function(){return $.Deferred(function(e){window.setTimeout(function(){e.reject({error:{errorClass:g.ERRORCLASS_FATAL_ERROR}})},2e3)})},this.quit()}}:$.noop,this.hasUnsavedDocumentChanges=function(){return 0!==tn&&tn>=nn},this.onInit(function(){be=this.getModel(),Le=this.getView(),this.waitForImport(function(){xt=_.now()}),V(),an(),K(),this.on("operations:error",function(){W(!1)}),A.supportsEditMode(we.getDocumentType())||(ft=!0,W(!1),V(),z(A.DOM_TEXT_EDIT_ALERT,-1)),Nt&&vt&&(i.info("EditApplication.onInit(): saving document to local storage is active"),k?i.info("EditApplication.onInit(): current browser supports local storage"):i.warn("EditApplication.onInit(): current browser does not support local storage")),Jt&&"new"===f.action&&_.isEmpty(f.templateFile)&&we.waitForEvent(we,"docs:state:initial").done(function(){Jt.call(we)}),u.BROWSER_TAB_SUPPORT&&$(n).on("visibility-changed",ve)},this),this.registerBeforeUnloadHandler(function(e){if(W(!1),e)we.executeDelayed(function(){Ue!==ht||ft||W(!0),we.isOffline()||gt||Xt||cn().always(V)},"EditApplication.handleUnsavedBeforeUnload",10);else{var t={};if("spreadsheet"===we.getDocumentType()){var n=be.createSheetOperationGenerator();be.generateChangedViewAttributeOperations(n);var i=n.getOperations(),o=F.handleMinifiedActions([{operations:i}]);o&&(t.operations=o),t.recalcFlag=be.getDependencyManager().getDocDirtyFlag()}He&&He.emergencyLeave(t)}}),this.registerBeforeQuitHandler(function(){var e=c.createDeferred(we,"EditApplication.beforeQuit");if(we.isOffline()||gt||Xt)return e.resolve(),e.promise();var t=$.when(Qe.call(we,"quit"));return(t=t.then(function(){var t=cn();if("pending"===t.state()){var n=we.executeDelayed(function(){"pending"===t.state()&&e.resolve({cause:"timeout"})},"EditApplication.beforeQuitHandler",5e3);t.always(function(){n.abort()})}return t})).fail(function(){e.resolve()}),t.done(function(){if(we.hasUnsavedChangesOffice()&&Ue===ht){var t=Le.showQueryDialog(null,w("This document contains unsaved changes. Do you really want to close?"));t.done(e.resolve.bind(e)),t.fail(e.reject.bind(e))}else e.resolve()}),e.promise()}),this.registerQuitHandler(function(e){function t(t){var n=we.createDeferred("EditApplication.checkCloseDocumentResult"),o=new g(t),r={},a=null,s=null,l=null,c=null;return o.isError()||o.isWarning()?(a=i.getStringOption(t,O.RESTORED_FILEID,null),s=i.getStringOption(t,O.RESTORED_FILENAME,null),l=i.getStringOption(t,O.RESTORED_FOLDERID,null),c=i.getStringOption(t,O.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(a)&&_.isString(s)&&_.isString(l)?(c=new g(c===g.CONSTANT_NO_ERROR?{errorClass:g.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}:{errorClass:g.ERRORCLASS_ERROR,error:c}),r[O.RESTORED_FILENAME]=s,d.getPath(l).always(function(e){r[O.RESTORED_PATHNAME]=d.preparePath(e),r[O.ORIGINAL_FILEID]=we.getFileDescriptor().id,we.updateFileDescriptor({id:a,folder_id:l}),we.setInternalError(c,E.CLOSE,o,{additionalData:r})})):we.setInternalError(o,E.CLOSE,null,{additionalData:r}),be&&Le?(we.registerQuitHandler(function(){n.reject()}),we.quit=function(e){return function(){return n.reject(),e.call(we)}}(we.quit),h.idle(),n.always(function(){h.busy()}),"logout"===e&&n.reject()):n.reject(),o.getDescription()&&i.log(o.getDescription()),n.promise()):t}function o(e){return t(e)}function r(e){I&&Le.updateBusyProgress(e)}function a(e){function t(){return _.pluck(be.getSupportedStorageExtensions({allApps:!0}),"extension").concat(N)}var n=localStorage.getItem("appsuiteDocsExpiryDates"),i=_.now();n&&(n=JSON.parse(n),_.isObject(n)?_.each(n,function(o,r){if(r!==e&&i>o){var a=a||t();_.each(a,function(e){var t=r+e;localStorage.removeItem(t)}),delete n[r]}}):n=null),(n=n||{})[e]=i+6048e5,localStorage.setItem("appsuiteDocsExpiryDates",JSON.stringify(n))}function l(){return d.propagateChangeFile(m)}var p=null,h=we.getWindow(),m=we.getFileDescriptor(),I=!1,R=null,N=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],S="logout"===e;h&&h.busy();var A=st||ut||lt||dt,v="new"===i.getStringOption(f,"action")||f.template;if(m&&(A||D.LOG_PERFORMANCE_DATA||!v&&Tt.length<=1)){var y=we.getDocumentType();R={file:_.extend({last_opened:Date.now()},m),app:y},D.LOG_PERFORMANCE_DATA&&(Fe(m,y),we.sendRequest(s.FILTER_MODULE_NAME,{action:"logperformancedata",performanceData:JSON.stringify(Lt)},{method:"POST"}))}return(p=!m||!He||we.isOffline()||gt||Xt?$.when():u.BROWSER_TAB_SUPPORT?He.closeDocument(R).then(t,o).progress(r):He.closeDocument(R).then(t,o).then(function(e){function t(t){var n=i.getBooleanOption(t,"migration",!1);_.each(N,function(e){localStorage.removeItem(o+e)}),n&&(U(e.syncInfo.fileVersion)?_.each(_.range(e.syncInfo.fileVersion>E?e.syncInfo.fileVersion-E:0,e.syncInfo.fileVersion),function(e){_.each(N,function(t){localStorage.removeItem(o+"_"+e+t)})}):(localStorage.removeItem(o+"_"+e.syncInfo.fileVersion),localStorage.removeItem(o+"_CURRENTVERSION")))}var n=null,o=null,r=null,s=null,l=null,u=null,d=null,f=st||ut||lt,p=be.getOperationStateNumber(),g=0,E=20;return on(),(f||!yt)&&e&&e.syncInfo&&!S&&window.Storage&&!we.isDocumentEncrypted()&&Nt&&vt&&k&&_.isFunction(be.getFullModelDescription)&&e.syncInfo.fileVersion&&e.syncInfo.fileId&&e.syncInfo.folderId&&U(e.syncInfo["document-osn"])&&p===e.syncInfo["document-osn"]&&(a(o=e.syncInfo.fileId+"_"+e.syncInfo.folderId),d=c.createDeferred(we,"EditApplication.saveLocalStorage"),we.executeDelayed(function(){I=!0},"EditApplication.saveFileInStorage",1500),we.executeDelayed(function(){d.notify(.1),n=_.now(),be.getFullModelDescription(d,.1,.9).always(function(){_.isFunction(be.getSupportedStorageExtensions)&&_.each(be.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&N.push(e.extension)}),t({migration:!0})}).done(function(a){function c(e){return t(),i.info("quitHandler(): "+e),!1}a.every(function(t){var a=t.htmlString,d=o+t.extension,f=null,p=null;i.info("quitHandler, created document string with size: "+a.length+". Time for conversion: "+(_.now()-n)+" ms.");try{if(0===g){if(r=o+"_OSN",s=o+"_FILEVERSION",l=o+"_STORAGEVERSION",u=o+"_OPERATIONS",localStorage.setItem(r,e.syncInfo["document-osn"]),localStorage.setItem(l,At),localStorage.setItem(s,e.syncInfo.fileVersion),f=be.getStorageOperationCollector(),_.each(f,function(e){delete e.osn,delete e.opl}),p=JSON.stringify(f),localStorage.setItem(u,p),!localStorage.getItem(u)||localStorage.getItem(u).length!==p.length)return c("failed to save document operations in local storage");i.info("quitHandler(): successfully saved document operations in local storage with key: "+u)}localStorage.setItem(d,a);var E=localStorage.getItem(d);if(!E||E.length!==a.length)return c("failed to save document in local storage");if(i.info("quitHandler(): successfully saved document in local storage with key: "+d),0===g){var O=localStorage.getItem(r),h=O?parseInt(O,10):-1;if(h!==e.syncInfo["document-osn"])return c("failed to save OSN for document in local storage");i.info("quitHandler(): successfully saved OSN for document in local storage with key: "+r+" : "+h)}return g++,!0}catch(e){return c("failed to save document and/or document OSN in local storage")}})}).always(function(){d.notify(1),d.resolve(e)})},"EditApplication.saveFileInStorage")),null===d?e:d.promise()}).progress(r)).always(function(){He&&(He.destroy(),He=null)}),u.BROWSER_TAB_SUPPORT&&p.always(function(){$(n).off("visibility-changed",ve)}),m&&(A?p=p.then(l,l):"reload"!==e&&("new"===i.getStringOption(f,"action")||f.template)&&Tt.length<=1&&!f.keepFile&&(p=p.then(function(){return d.purgeFile(m)}))),p}),this.waitForImportStart(function(){P.log("app/loading","pending")}),this.once("docs:state:preview",function(){P.log("app/preview","pending")}),this.waitForImport(function(){P.log("app/preview","resolved"),P.log("app/loading","resolved")}),this.registerDestructor(function(){f=p=we=be=Le=null,He=Pe=ke=qt=null,Ge=Ve=We=null,qe=$e=Ye=null,Qe=ze=Ze=Je=null,ct=Ct=Tt=wt=null,bt=Lt=null})})});