define("io.ox/office/editframework/model/editmodel",["io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/scheduler","io.ox/office/baseframework/model/basemodel","io.ox/office/editframework/utils/operations","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/model/operationcontext","io.ox/office/editframework/model/operationgenerator","io.ox/office/editframework/model/modelattributesmixin","io.ox/office/editframework/model/undomanager"],function(e,t,n,o,r,i,s,a,c,l,u,p){"use strict";function d(t){var n=e.getFunctionOption(t,"filter");return _.isFunction(n)?n:e.getBooleanOption(t,"filter",!0)?b:M}var f=t.isPromise,g=n.ValueMap,h=o.Logger,O=c.OperationContext,m=l.resolveOperations,v=l.OperationGenerator,y=new h({enable:"office:log-ops",prefix:"OP"}),b=_.constant(!0),M=_.constant(!1);return i.extend({constructor:function(t,n){function o(n,o){var i=e.getBooleanOption(o,"async",!1);if(w.isProcessingActions())return e.error("EditModel.enterProcessActionsMode(): recursive call"),!!i&&w.createRejectedPromise({cause:"recursive"});j=r.createDeferred(t,"EditModel.enterProcessActionsMode").always(function(){var e=j?j.state().replace(/ed$/,"ing"):"destructed";y.log("EditModel.enterProcessActionsMode(): "+e+" promise...")});var s=n.call(w);return f(s)?(s.progress(j.notify.bind(j)),s.done(j.resolve.bind(j)),s.fail(j.reject.bind(j)),s):(!0===s?j.resolve():j.reject(),i?j.promise():s)}function c(n,o){return N?(e.error("EditModel.beginProcessOperations(): recursive call - currently processing operations."),!1):t.isInternalError()?(e.error("EditModel.beginProcessOperations(): illegal call - application is in error state."),!1):(w.trigger("operations:before",n,o),N=!0,!0)}function l(e,t,n){N=!1,w.trigger("operations:after",t,n),w.trigger(e?"operations:success":"operations:error",t,n)}function h(e){var t=e.getStr("name"),n=C.get(t,null);return e.ensure(n,"unknown operation %s",t),n}function b(n,o,r,i){function s(){var n="EditModel.applyOperation(): "+_.printf.apply(_,arguments);return e.error(n),t.sendLogMessage(n),!1}if(y.log("i="+B+", op=",n),!_.isObject(n))return s("Expecting operation object.");try{var c=new x(w,n,o,i),l=h(c);if(o&&c.has(a.OSN)){var u=c.getInt(a.OSN);if(c.ensure(u>=0,"invalid OSN: %d",u),-1===R&&w.setOperationStateNumber(u),R!==u)return s("Wrong operation state number. current=%d operation=%d",R,n.osn)}o||(n.osn=R,n.opl=1),R>=0&&w.setOperationStateNumber(R+c.getOptInt(a.OPL,1)),U.previous=U.current,U.current=n,F&&F.call(w,n),"filter"!==c.getOptStr("scope")&&!0===r.call(w,n)&&l.call(w,c)}catch(t){return s('Operation failed. name="%s" msg="%s" osn=%d source=%s op=%s',n.name,e.getStringOption(t,"message",""),B+1,o?"ext":"int",JSON.stringify(n))}return B+=1,!0}function M(e,n,o){var r=d(o),i=!w.isImportFinished(),s=!1;return e=m(e,o),!n&&!t.isEditable()||0===e.length||(!n&&_.isFunction(E)&&(e=E.call(w,e)),c(e,n)&&k.enterUndoGroup(function(){s=e.every(function(e){return b(e,n,r,i)})}),l(s,e,n),s)}function S(n,o,r){var i=d(r),s=!w.isImportFinished(),a=null,u=B;return 0===(n=m(n,r)).length?w.createResolvedPromise(null):(a=c(n,o)?k.enterUndoGroup(function(){var r=[];return w.iterateArraySliced(n,function(a){return o||t.isEditable()?b(a,o,i,s)?void r.push(a):w.createRejectedPromise({cause:"operation"}):(n=r,e.BREAK)},"EditModel.applyOperationsAsync")}):w.createRejectedPromise({cause:"recursive"}),w.waitForSuccess(a,function(){l(!0,n,o)}),w.waitForFailure(a,function(e){"abort"===e?l(!0,n.slice(0,B-u),o):l(!1,n,o)}),a)}var A=e.getFunctionOption(n,"generatorClass",v),x=e.getFunctionOption(n,"contextClass",O),w=this,k=null,P=e.getFunctionOption(n,"selectionStateHandler",null),E=e.getFunctionOption(n,"operationsFinalizer",null),F=e.getFunctionOption(n,"storageOperationCollector",null),j=null,C=new g,N=!1,B=0,R=-1,U={previous:null,current:null},I=e.getBooleanOption(n,"slideMode",!1),G=!1,H=I&&(e.IOS||e.CHROME_ON_ANDROID);i.call(this,t),this.registerContextOperationHandler=function(e,t){return C.insert(e,t),this},this.registerOperationHandler=function(e,t){return this.registerContextOperationHandler(e,function(e){var n=t.call(this,e.operation,e.external);e.ensure(!1!==n,"operation handler failed")})},this.getSelectionState=function(){return P?P.call(this):null},this.setSelectionState=function(e){return e&&P&&P.call(this,e),this},this.setBlockedGuiUpdate=function(e){G=e},this.isBlockedGuiUpdate=function(){return G},this.isProcessingActions=function(){return!!j&&"pending"===j.state()},this.waitForActionsProcessed=function(){return j?j.catch(_.noop):this.createResolvedPromise()},this.isProcessingOperations=function(){return N},this.sendOperations=y.profileMethod("EditModel.sendOperations()",function(e,t){return M(e,!1,_.extend({},t,{filter:!1}))}),this.applyOperations=y.profileMethod("EditModel.applyOperations()",function(t,n){return o(function(){return(e.getBooleanOption(n,"async",!1)?S:M)(t,!1,n)})}),this.applyActions=y.profileAsyncMethod("EditModel.applyActions()",function(n,i){var s=0;return n=_.getArray(n).filter(function(e){var t=_.isArray(e.operations)?e.operations.length:0;return s+=t,t>0}),0===s?$.when():(a.handleMinifiedActions(n,!0),o(function(){var o=e.getBooleanOption(i,"external",!1),a=r.createDeferred(t,"EditModel.applyActions"),c=0,l=null,u=w.iterateArraySliced(n,function(e){return(l=S(e.operations,o,i)).progress(function(t){var n=c+e.operations.length*t;a.notify(n/s)}),l.done(function(){c+=e.operations.length}),l.always(function(){l=null})},"EditModel.applyActions");return u.done(function(){a.notify(1).resolve()}),u.fail(a.reject.bind(a)),w.createAbortablePromise(a,function(){u.abort(),l&&l.abort()})},{async:!0}))}),this.invokeOperationHandler=function(e){var t=new x(this,e,!1),n=h(t);return k.disableUndoSync(n.bind(this,t)),this},this.createOperationGenerator=function(e){return new A(this,e)},this.createAndApplyOperations=y.profileAsyncMethod("EditModel.createAndApplyOperations()",function(t,n){var r=new(e.getFunctionOption(n,"generatorClass",A))(this,n),i=e.getBooleanOption(n,"storeSelection",!1)?_.noop:e.getFunctionOption(n,"storeSelection",null),s=r.isImmediateApplyMode();return o(function(){var o=i?w.getSelectionState():null,a=null;try{a=w.convertToPromise(t.call(w,r))}catch(e){a=w.createRejectedPromise(e)}return a=a.then(function(e){return s?w.sendOperations(r)?e:$.Deferred().reject({cause:"operation"}):S(r,!1).then(_.constant(e))}),a=a.then(function(t){var s=null;switch(i&&(i.call(w),s=w.getSelectionState()),e.getStringOption(n,"undoMode","generate")){case"generate":k.enterUndoGroup(function(){k.addUndo(r.getOperations({undo:!0}),r.getOperations(),o,s)},w,e.getObjectOption(n,"undoOptions",null));break;case"clear":k.clearUndoActions();break;case"skip":break;default:e.error("EditModel.createAndApplyOperations(): unknown undo mode")}return t})},{async:!0})}),this.getOperationsCount=function(){return B},this.getOperationStateNumber=function(){return R},this.setOperationStateNumber=function(e){return R!==e&&(R=e,this.trigger("change:osn",e)),this},this.getOperationsCache=function(){return U},this.getPreviousOperation=function(){return U.previous},this.getUndoManager=function(){return k},this.useSlideMode=function(){return I},this.getSlideTouchMode=function(){return H},k=new p(this,n),u.call(this,n),this.registerContextOperationHandler(s.NOOP,_.noop),this.registerDestructor(function(){k.destroy(),C.clear(),w=n=j=null,E=C=null,k=A=x=null})}})});