define("io.ox/office/spreadsheet/model/formula/funcs/textfuncs",["io.ox/office/tk/algorithms","io.ox/office/tk/locale/localedata","io.ox/office/spreadsheet/utils/errorcodes","io.ox/office/spreadsheet/model/formula/formulautils"],function(t,r,a,e){"use strict";function n(t,r){if(r<0){var a=g(r);t=a<Number.MIN_VALUE?0:Math.round(a*t)/a}return t}var s=t.replaceSubString,i=t.repeatString,o=t.capitalizeFirst,l=a.ErrorCode,m=e.Math,u=e.ScalarTypeId,v=e.getScalarType,g=m.pow10;return{ASC:{category:"text",hidden:!0,minParams:1,maxParams:1,type:"val:str"},BAHTTEXT:{category:"text",name:{odf:"COM.MICROSOFT.BAHTTEXT"},minParams:1,maxParams:1,type:"val:str",signature:"val:num",resolve:function(){function t(t,r,a){var e=Math.floor(t/r)%10;return e>0?n[e]+a:""}function r(r,g,c){var x="";x+=t(r,1e5,u),x+=t(r,1e4,m),x+=t(r,1e3,l),x+=t(r,100,o);var f=Math.floor(r/10)%10;if(1===f?x+=s:2===f?x+=i+s:f>=3&&(x+=n[f]+s),g&&1===r)x+=a;else{var h=r%10;1===h?x+=e:h>=2&&(x+=n[h])}return c?x+v:x}var a="หนึ่ง",e="เอ็ด",n=[null,a,"สอง","สาม","สี่","ห้า","หก","เจ็ด","แปด","เก้า"],s="สิบ",i="ยี่",o="ร้อย",l="พัน",m="หมื่น",u="แสน",v="ล้าน";return function(t){var a=t<0,e=Math.round(100*Math.abs(t)),n=Math.floor(e/100);if(e%=100,0===n&&0===e)return a?"ลบศูนย์บาทถ้":"ศูนย์บาทถ้วน";var s="";if(n>0){for(var i=!1;n>0;)s=r(n%1e6,n<1e6,i)+s,n=Math.floor(n/1e6),i=!0;s+="บาท"}return a&&(s="ลบ"+s),s+(e>0?r(e,!0,!1)+"สตางค์":"ถ้วน")}}()},CHAR:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val:int",resolve:function(t){if(t<1||t>255)throw l.VALUE;return String.fromCharCode(t)}},CLEAN:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val:str",resolve:function(t){return t.replace(/[\x00-\x1f\x81\x8d\x8f\x90\x9d]/g,"")}},CODE:{category:"text",minParams:1,maxParams:1,type:"val:num",signature:"val:str",resolve:function(t){if(0===t.length)throw l.VALUE;return t.charCodeAt(0)}},CONCAT:{category:"text",name:{ooxml:"_xlfn.CONCAT",odf:null},minParams:1,type:"val:str",signature:"any|mat:pass",resolve:function(){return this.aggregateStrings(arguments,"",function(t,r){return this.concatStrings(t,r)},_.identity)}},CONCATENATE:{category:"text",minParams:1,type:"val:str",signature:"val:str",resolve:function(){return this.concatStrings.apply(this,arguments)}},DBCS:{category:"text",name:{odf:"JIS"},hidden:!0,minParams:1,maxParams:1,type:"val:str"},DOLLAR:{category:"text",minParams:1,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:function(){var t=_.memoize(function(t){return t>0?"."+i("0",t):""});return function(r,a){if(this.isMissingOperand(1))a=2;else if(a>127)throw l.VALUE;r=n(r,a);var e=this.numberFormatter.getCurrencyCode();e=e.replace(/\.00/g,t(Math.max(0,a)));var s=this.numberFormatter.getParsedFormat(e);return this.numberFormatter.formatValue(s,r)}}()},EXACT:{category:"text",minParams:2,maxParams:2,type:"val:bool",signature:"val:str val:str",resolve:function(t,r){return t===r}},FIND:{category:"text",minParams:2,maxParams:3,type:"val:num",signature:"val:str val:str val:int",resolve:function(t,r,a){if(_.isUndefined(a)&&(a=1),this.checkStringIndex(a),(a-=1)>r.length-t.length)throw l.VALUE;if((a=r.indexOf(t,a))<0)throw l.VALUE;return a+1}},FINDB:{category:"text",hidden:!0,minParams:2,maxParams:3,type:"val:num",signature:"val:str val:str val:int",resolve:"FIND"},FIXED:{category:"text",minParams:1,maxParams:3,type:"val:str",signature:"val:num val:int val:bool",resolve:function(t,r,a){if(this.isMissingOperand(1))r=2;else if(r>127)throw l.VALUE;t=n(t,r);var e=a?"0":"#,##0",s=r>0?"."+i("0",r):"",o=this.numberFormatter.getParsedFormat(e+s);return this.numberFormatter.formatValue(o,t)}},LEFT:{category:"text",minParams:1,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:function(t,r){return _.isUndefined(r)&&(r=1),this.checkStringLength(r),0===r?t:t.substr(0,r)}},LEFTB:{category:"text",hidden:!0,minParams:1,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:"LEFT"},LEN:{category:"text",minParams:1,maxParams:1,type:"val:num",signature:"val:str",resolve:_.property("length")},LENB:{category:"text",hidden:!0,minParams:1,maxParams:1,type:"val:num",signature:"val:str",resolve:"LEN"},LOWER:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val:str",resolve:function(t){return t.toLowerCase()}},MID:{category:"text",minParams:3,maxParams:3,type:"val:str",signature:"val:str val:int val:int",resolve:function(t,r,a){return this.checkStringIndex(r),this.checkStringLength(a),t.substr(r-1,a)}},MIDB:{category:"text",hidden:!0,minParams:3,maxParams:3,type:"val:str",signature:"val:str val:int val:int",resolve:"MID"},NUMBERVALUE:{category:"text",name:{ooxml:"_xlfn.NUMBERVALUE"},minParams:1,maxParams:3,type:"val:num",signature:"val:str val:str val:str",resolve:function(t,a,e){if(0===t.length)return"0";if(this.isMissingOperand(1))a=r.DEC;else if(0===a.length)throw l.VALUE;if(this.isMissingOperand(2))e=r.GROUP;else if(0===e.length)throw l.VALUE;if(a=a[0],e=e[0],a===e)throw l.VALUE;var n=t.split(a);if(n.length>2)throw l.VALUE;var s=new RegExp(_.escapeRegExp(e),"g");if(2===n.length&&s.test(n[1]))throw l.VALUE;var i=(n=n.map(function(t){return t.replace(s,"")})).join(r.DEC),o=/%+/.exec(i);o&&(o=o[0],i=i.replace(o,"%"));var m=this.numberFormatter.parseFormattedValue(i).value;if(!_.isNumber(m))throw l.VALUE;return o&&o.length>1&&(m/=g(2*o.length-2)),m}},PHONETIC:{category:"text",name:{odf:null},hidden:!0,minParams:1,maxParams:1,type:"val:str",signature:"ref:single"},PROPER:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val:str",resolve:function(t){return t.replace(/[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02B8\u02BB-\u02C1\u02D0-\u02D1\u02E0-\u02E4\u02EE\u0370-\u0373\u0376-\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0523]+/g,o)}},REPLACE:{category:"text",minParams:4,maxParams:4,type:"val:str",signature:"val:str val:int val:int val:str",resolve:function(t,r,a,e){return this.checkStringIndex(r),this.checkStringLength(a),r-=1,s(t,r,r+a,e)}},REPLACEB:{category:"text",hidden:!0,minParams:4,maxParams:4,type:"val:str",signature:"val:str val:int val:int val:str",resolve:"REPLACE"},REPT:{category:"text",minParams:2,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:function(t,r){return this.repeatString(t,r)}},RIGHT:{category:"text",minParams:1,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:function(t,r){return _.isUndefined(r)&&(r=1),this.checkStringLength(r),0===r?t:t.substr(-r)}},RIGHTB:{category:"text",hidden:!0,minParams:1,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:"RIGHT"},ROT13:{category:"text",name:{ooxml:null,odf:"ORG.OPENOFFICE.ROT13"},minParams:1,maxParams:1,type:"val:str",signature:"val:str",resolve:function(t){return t.replace(/[a-zA-Z]/g,function(t){return String.fromCharCode(((t=t.charCodeAt())<91?78:110)>t?t+13:t-13)})}},SEARCH:{category:"text",minParams:2,maxParams:3,type:"val:num",signature:"val:str val:str val:int",resolve:function(t,r,a){if(_.isUndefined(a)&&(a=1),this.checkStringIndex(a),a-=1,/^\**$/.test(t)){if(r.length<=a)throw l.VALUE;return a+1}r=r.substr(a);var e=this.convertPatternToRegExp(t).exec(r);if(!_.isArray(e))throw l.VALUE;return e.index+a+1}},SEARCHB:{category:"text",hidden:!0,minParams:2,maxParams:3,type:"val:num",signature:"val:str val:str val:int",resolve:"SEARCH"},SUBSTITUTE:{category:"text",minParams:3,maxParams:4,type:"val:str",signature:"val:str val:str val:str val:int",resolve:function(t,r,a,e){if(_.isNumber(e)&&e<=0)throw l.VALUE;if(0===r.length)return t;var n=new RegExp(_.escapeRegExp(r),"g");if(_.isUndefined(e))return t.replace(n,a);var s=t.split(n);return e<s.length?(s[e-1]+=a+s[e],s.splice(e,1),s.join(r)):t}},T:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val",resolve:function(t){return _.isString(t)?t:""}},TEXT:{category:"text",minParams:2,maxParams:2,type:"val:str",recalc:"once",signature:"val:num val:str",resolve:function(t,r){var a=this.numberFormatter.getParsedFormat(r,{grammarId:"ui"}),e=this.numberFormatter.formatValue(a,t);if(null===e)throw l.VALUE;return e}},TEXTJOIN:{category:"text",name:{ooxml:"_xlfn.TEXTJOIN",odf:null},minParams:3,type:"val:str",signature:"val:str val:bool any|mat:pass",resolve:function(t,r){var a=0;return this.aggregateStrings(_.toArray(arguments).slice(2),"",function(e,n,s,i){if(0===n.length)return e;var o=r?a<i?1:0:i-a,l=o>0?this.repeatString(t,o):"";return a=i,this.concatStrings(e,l,n)},function(e,n,s){return r?e:e+this.repeatString(t,s-a-1)})}},TRIM:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val:str",resolve:function(t){return t.replace(/^ +| +$/g,"").replace(/ {2,}/g," ")}},UNICHAR:{category:"text",name:{ooxml:"_xlfn.UNICHAR"},minParams:1,maxParams:1,type:"val:str",signature:"val:int",resolve:function(t){if(t<1||t>65535)throw l.VALUE;if(t>=55296&&t<=57343)throw l.NA;if(t>=64976&&t<=65007)throw l.NA;if(t>=65534)throw l.NA;return String.fromCharCode(t)}},UNICODE:{category:"text",name:{ooxml:"_xlfn.UNICODE"},minParams:1,maxParams:1,type:"val:num",signature:"val:str",resolve:function(t){return 0===t.length?l.VALUE:t.charCodeAt(0)}},UPPER:{category:"text",minParams:1,maxParams:1,type:"val:str",signature:"val:str",resolve:function(t){return t.toUpperCase()}},USDOLLAR:{category:"text",name:{odf:null},hidden:!0,minParams:1,maxParams:2,type:"val:str",signature:"val:str val:int",resolve:"DOLLAR"},VALUE:{category:"text",minParams:1,maxParams:1,type:"val:num",signature:"val",resolve:function(t){switch(v(t)){case u.NUMBER:return t;case u.STRING:return this.convertToNumber(t);case u.NULL:return 0}throw l.VALUE}}}});