define("io.ox/office/spreadsheet/model/formula/interpret/formulacompiler",["io.ox/office/tk/algorithms","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,r,t,o,n){"use strict";function s(e,r){return _.isObject(e)&&e.isType("op")&&e.getValue()in g[r]}function i(e,r,t){this.token=e,this.operands=r||null,this.descriptor=t||null,this.recalc=null,this.relColRef=!1,this.relRowRef=!1,this.signature=null,this.error=null,this._initialize()}var a=e.floorp,l=e.createDict,c=t.ErrorCode,u=o.FormulaErrorCode,f=o.FormulaError,p=o.formulaLogger,h=n.LiteralToken,d=n.OperatorToken,m=n.SheetRefToken,g={cmp:l("eq ne lt le gt ge",!0),con:l("con",!0),upre:l("add sub",!0),upost:l("upct",!0),add:l("add sub",!0),mul:l("mul div",!0),pow:l("pow",!0),list:l("list",!0),isect:l("isect",!0),range:l("range",!0)};return i.prototype._ensure=function(e,r,t){return e||(this.error=new f(r,t)),!!e},i.prototype._initialize=function(){switch(this.token.getType()){case"ref":return this.relColRef=this.token.hasRelCol(),void(this.relRowRef=this.token.hasRelRow());case"table":return void(this.relRowRef="ROW"===this.token.getRegionKey())}if(this.descriptor){this.recalc=this.descriptor.recalc;var e=this.operands?this.operands.length:0;this.relColRef=!!this.descriptor.relColRef&&this.descriptor.relColRef(e),this.relRowRef=!!this.descriptor.relRowRef&&this.descriptor.relRowRef(e)}if(this.operands&&(this.recalc=this.operands.reduce(function(e,r){return o.getRecalcMode(e,r.recalc)},this.recalc),this.relColRef=this.relColRef||this.operands.some(function(e){return e.relColRef}),this.relRowRef=this.relRowRef||this.operands.some(function(e){return e.relRowRef})),this.operands&&this.descriptor){var r=this.descriptor.minParams,t=0,n=0;"maxParams"in this.descriptor?(t=this.descriptor.maxParams,n=1):(n="repeatParams"in this.descriptor?this.descriptor.repeatParams:1,t=r+a(o.MAX_PARAM_COUNT-r,n));var s=this.operands.length;if(this._ensure(r<=s,"not enough parameters",u.MISSING)&&this._ensure(s<=t,"too many parameters",u.UNEXPECTED)&&this._ensure((s-r)%n==0,"not enough parameters",u.MISSING)){var i=this.descriptor.signature;(0===this.operands.length||i.length>0)&&(this.signature=_.times(this.operands.length,function(e){return i.length<=e&&(e=i.length-n+(e-i.length)%n),i[e]}))}}},i.prototype.isOperator=function(){return!!this.operands},i.prototype.toString=function(){return this.token+(this.isOperator()?":"+this.operands.length:"")},r.extend({constructor:function(e){var t=e.getFormulaResource().getOperatorCollection(),o=e.getFormulaResource().getFunctionCollection();r.call(this,e),this.compileTokens=p.profileMethod("FormulaCompiler.compileTokens()",function(e){function r(){return e[M]||null}function n(){var e=r();return e&&(M+=1),e}function a(){for(var e=n();e&&e.isType("ws");)e=n();return e}function l(){var e=a();if(e)return e;throw new f("unexpected end of formula",u.MISSING)}function g(e,r){if(U.length<r)throw new f("invalid operand stack size",u.MISSING);var n=r>0?U.splice(-r):[],s=e.isType("op")?t.get(e.getValue()):e.isType("func")?o.get(e.getValue()):null;U.push(new i(e,n,s||null)),s&&!s.resolve&&e.isType("func")&&(F[s.key]=!0)}function w(e){U.push(new i(e))}function R(e,r,t){var o=e(a());return g(r,t),o}function T(e,r){var t=_;return _=r,e=E(e),_=t,e}function E(e){for(e=C(e);s(e,"cmp");)e=R(C,e,2);return e}function C(e){for(e=v(e);s(e,"con");)e=R(v,e,2);return e}function v(e){for(e=k(e);s(e,"add");)e=R(k,e,2);return e}function k(e){for(e=y(e);s(e,"mul");)e=R(y,e,2);return e}function y(e){for(e=x(e);s(e,"pow");)e=R(x,e,2);return e}function x(e){if(s(e,"upre")){switch(e.getValue()){case"add":e=new d("uplus");break;case"sub":e=new d("uminus")}e=R(x,e,1)}else e=N(e);for(;s(e,"upost");)g(e,1),e=a();return e}function N(e){for(e=S(e);e&&(s(e,"list")||!_&&e.isType("sep"));)e.isType("sep")&&(e=new d("list")),e=R(S,e,2);return e}function S(e){for(e=b(e);s(e,"isect");)e=R(b,e,2);return e}function b(e){for(e=P(e);s(e,"range");)e=R(P,e,2);return e}function P(e){if(!e)throw new f("unexpected end of formula",u.MISSING);if(e instanceof m&&e.hasSheetError())throw new f("invalid sheet name",u.UNEXPECTED);switch(e.getType()){case"lit":case"mat":case"ref":case"name":case"table":return w(e),a();case"open":return I();case"func":case"macro":return D(e)}throw new f("operand expected",u.UNEXPECTED)}function I(){var e=T(l());if(e){if(!e.isType("close"))throw new f("closing parenthesis expected",u.UNEXPECTED)}else X+=1;return a()}function D(e){for(var r=e,t="start",o=0;"end"!==t;)switch(t){case"start":if(!(e=l()).isType("open"))throw new f("opening parenthesis expected",u.UNEXPECTED);t="open";break;case"open":(e=a())||(X+=1),t=!e||e.isType("close")?"close":"param";break;case"param":if(o+=1,e||(X+=1),!e||e.matchesType(/^(sep|close)$/))w(new h(null));else if(e=T(e,!0)){if(!e.matchesType(/^(sep|close)$/))throw new f("parameter separator expected",u.UNEXPECTED)}else X+=1;t=e?e.getType():"close";break;case"sep":e=a(),t="param";break;case"close":g(r,o),t="end"}return a()}var M=0,_=!1,U=[],X=0,F={};try{p.logTokens("compiling",e);var O=T(l());if(0===U.length)throw new f("missing formula expression",u.MISSING);if(U.length>1)throw new f("invalid formula expression",u.UNEXPECTED);if(O||M<e.length)throw new f("unexpected garbage at end of formula",u.UNEXPECTED);p.withLogging(function(){var e=[];!function r(t){e.push(t),t.isOperator()&&t.operands.forEach(r)}(U[0]),p.logTokens("compiled",e)})}catch(e){if(e instanceof f)return p.warn("error: "+e.message+", index="+(M-1)),{root:new i(new h(c.NA)),error:e.code,missingClose:0,missingFuncs:null};throw e}return{root:U[0],error:null,missingClose:X,missingFuncs:F}}),this.registerDestructor(function(){e=t=o=null})}})});