define("io.ox/office/spreadsheet/model/formula/interpret/formulacontext",["io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/iterators","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/filteraggregator"],function(t,e,r,o,n,a,i,s,l,c){"use strict";function u(t){return t.forEach(s.throwErrorCode),t}function p(t,e){return t.forEach(function(t){if(s.throwErrorCode(t),!e(t))throw L.VALUE}),t}function h(t){if(t.empty())throw L.NULL;if(!t.singleSheet())throw L.VALUE;return t}function f(t){return t instanceof l?t.getType():t instanceof Y?"mat":t instanceof B||t instanceof P?"ref":"val"}function g(t){var e=t instanceof l?t.getRawValue():t;return e instanceof Y?e.size():e instanceof B||e instanceof P?e.cells():1}function d(e,r){return t.getStringOption(r,f(e)+"Mode","convert")}function m(t){var e=0;return new N(t,function(t,r){return null===t?null:(r.index=e,e+=1,r)})}function v(t){return null!==t}function y(t){return null===t}function S(t){return""===t||null===t}function E(e,r){this.app=e.getApp(),this.docModel=e,this.OOXML=this.app.isOOXML(),this.ODF=this.app.isODF(),this.formulaResource=e.getFormulaResource(),this.formulaGrammar=e.getFormulaGrammar("ui"),this.numberFormatter=e.getNumberFormatter(),this._formulaInterpreter=e.getFormulaInterpreter(),this._dependencyManager=e.getDependencyManager(),this._refSheet=t.getIntegerOption(r,"refSheet",null),this._refAddress=t.getOption(r,"targetAddress",D.A1).clone(),this._targetAddress=this._refAddress.clone(),this._detectCircular=t.getBooleanOption(r,"detectCircular",!1),this._recalcDirty=t.getOption(r,"recalcDirty",!1),this._standardFormat=e.getNumberFormatter().getStandardFormat(),this._MAX_STRING_LEN=this.ODF?65535:32767,this._END_EVAL_TIME=_.now()+s.MAX_EVAL_TIME,this._resolverStack=[],this._operandResolver=null,this._contextType="any",this._matDim=null,this._matRow=0,this._matCol=0}var w=e.isString,R=e.isNumber,A=e.isFiniteNumber,T=e.isBoolean,C=r.isZero,M=r.repeatString,x=o.makeArrayIterator,O=o.arrayCast,I=n.SingleIterator,N=n.TransformIterator,V=n.NestedIterator,b=n.ParallelIterator,F=n.EMPTY_ITERATOR,L=i.ErrorCode,k=i.isErrorCode,D=i.Address,U=i.Range,B=i.Range3D,P=i.Range3DArray,z=s.Dimension,G=s.ScalarTypeId,X=s.CompareResult,q=s.getScalarType,$=s.compareScalars,Q=s.Complex,H=s.getMatrixAddress,Y=s.Matrix,Z=s.FilterType,j=a.getDebugUrlFlag("spreadsheet:debug-formulas"),J=_.constant(!1);return E.prototype._getScalar=function(t){return"mat"===this._contextType?t.getScalar(this._matRow,this._matCol):t.getScalar(null,null)},E.prototype._getCellValue=function(t,e){if(!this._recalcDirty)return t.getCellCollection().getValue(e);var r=this._dependencyManager.getCellValue(t,e);return this._END_EVAL_TIME+=r.time,r.value},E.prototype._checkCircularReference=function(t){if(this._detectCircular&&R(this._refSheet)&&t.containsSheet(this._refSheet)&&t.containsAddress(this._refAddress))throw s.CIRCULAR_ERROR;return t},E.prototype._createOperandIterator=function(e,r,o){function n(t,e,o,n,a,i){return d||s.throwErrorCode(t),(S+=1)%50==0&&h.checkEvalTime(),t=r.call(h,t),!i&&m&&(i=h._standardFormat),{value:t,format:i,offset:e+o*a+n,col:n,row:a}}function a(t){return f||null!==t?new I(n(t,0,1,0,0,null)):F}function i(t){var e=t.cols();return new N(t.iterator(),function(t,r){return n(t,0,e,r.col,r.row,null)})}function c(t,e,r){var o=e.start[0],a=e.start[1],i=e.cols(),s=t.getCellCollection(),l=!!(v||y&&t.getTableCollection().hasFilteredTables())&&"rows",c=s.createAddressIterator(e,{type:g?"all":"value",covered:!0,visible:l});return new N(c,function(e){var l=m?s.getParsedFormat(e):null;return n(h._getCellValue(t,e),r,i,e[0]-o,e[1]-a,l)})}function u(t,e){var r=t.toRange(),o=r.cells(),n=h.docModel.createSheetIterator({first:t.sheet1,last:t.sheet2,cells:!0});return new V(n,function(t){var n=e;return e+=o,c(t,r,n)})}function p(e){if(t.getBooleanOption(o,"complexRef",!1)){var r=0;return new V(x(e),function(t){h._checkCircularReference(t);var e=r;return r+=t.cells(),u(t,e)})}return u(h.convertToValueRange(e),0)}var h=this,f=t.getBooleanOption(o,"emptyParam",!1),g=t.getBooleanOption(o,"emptyCells",!1),d=t.getBooleanOption(o,"acceptErrors",!1),m=t.getOption(o,"collectFormats",!1),v=t.getBooleanOption(o,"skipHiddenRows",!1),y=t.getBooleanOption(o,"skipFilteredRows",!1),S=0;if(e instanceof l){var E=e.getRawValue();switch(e.getType()){case"val":return a(E);case"mat":return i(E);case"ref":return p(E)}s.throwInternal("FormulaContext._createOperandIterator(): invalid operand type")}return e instanceof Y?i(e):e instanceof B||e instanceof P?p(e):_.isUndefined(e)?F:a(e)},E.prototype._iterateValues=function(t,e){var r=0;return t.forEach(function(t,o){e.call(this,t,r,o.offset,o.col,o.row,o.format),r+=1},this),r},E.prototype._aggregateValues=function(e,r,o,n,a,i){var l=r,c=0,u=0,p=t.getBooleanOption(i,"collectFormats",!0)?this._standardFormat:null;return _.each(e,function(t){c+=o.call(this,t,function(t,e,r,o,a,i){var h=c+e,f=u+r;l=n.call(this,l,t,h,f),p&&(p=s.combineParsedFormats(p,i))},i),u+=g(t)},this),l=s.throwErrorCode(a.call(this,l,c,u)),p?this.createOperand(l,{format:p}):l},E.prototype.setMatrixPosition=function(t,e){return this._targetAddress[0]+=e-this._matCol,this._targetAddress[1]+=t-this._matRow,this._matRow=t,this._matCol=e,this},E.prototype.pushOperandResolver=function(t,e,r){return this._resolverStack.push({resolver:this._operandResolver,contextType:this._contextType,matDim:this._matDim,matRow:this._matRow,matCol:this._matCol}),this._operandResolver=t,this._contextType=e,this._matDim=r,this.setMatrixPosition(null,null)},E.prototype.popOperandResolver=function(){var t=this._resolverStack.pop();return this._operandResolver=t.resolver,this._contextType=t.contextType,this._matDim=t.matDim,this.setMatrixPosition(t.matRow,t.matCol)},E.prototype.getContextType=function(){return this._contextType},E.prototype.convertToNumber=function(t,e){if(s.throwErrorCode(t),null===(t=this.numberFormatter.convertScalarToNumber(t,e)))throw L.VALUE;return t},E.prototype.convertToDate=function(t,e){if(s.throwErrorCode(t),null===(t=this.numberFormatter.convertScalarToDate(t,e)))throw L.VALUE;return t},E.prototype.convertToString=function(t){if(s.throwErrorCode(t),null===(t=this.numberFormatter.convertScalarToString(t,i.MAX_LENGTH_STANDARD_FORMULA)))throw L.VALUE;return t},E.prototype.convertToBoolean=function(t){if(s.throwErrorCode(t),null===(t=this.numberFormatter.convertScalarToBoolean(t)))throw L.VALUE;return t},E.prototype.convertToComplex=function(t){if(s.throwErrorCode(t),_.isBoolean(t))throw L.VALUE;if(t instanceof Date&&(t=this.convertToNumber(t)),A(t)?t=new Q(t,0):"string"==typeof t?t=this.numberFormatter.convertStringToComplex(t):null===t&&(t=new Q(0,0)),t instanceof Q)return t;throw L.NUM},E.prototype.convertToRange=function(e,r){if((e=O(P,e)).empty())throw L.NULL;if(e.length>1)throw t.getOption(r,"errorCode",L.REF);if(!t.getBooleanOption(r,"multiSheet",!1)&&!e[0].singleSheet())throw L.VALUE;return e[0]},E.prototype.convertToValueRange=function(t){return this._checkCircularReference(this.convertToRange(t,{errorCode:L.VALUE}))},E.prototype.convertOperandToValue=function(t,e){switch(e){case"any":case"any:lazy":return t;case"val":return s.throwErrorCode(this._getScalar(t));case"val:num":return this.convertToNumber(this._getScalar(t));case"val:int":return this.convertToNumber(this._getScalar(t),!0);case"val:date":return this.convertToDate(this._getScalar(t));case"val:day":return this.convertToDate(this._getScalar(t),!0);case"val:str":return this.convertToString(this._getScalar(t));case"val:bool":return this.convertToBoolean(this._getScalar(t));case"val:comp":return this.convertToComplex(this._getScalar(t));case"val:any":return this._getScalar(t);case"mat":return u(t.getMatrix());case"mat:num":return p(t.getMatrix(),R);case"mat:str":return p(t.getMatrix(),w);case"mat:bool":return p(t.getMatrix(),T);case"mat:any":return t.getMatrix();case"ref":return t.getRanges();case"ref:sheet":return h(t.getRanges());case"ref:single":return this.convertToRange(t.getRanges());case"ref:multi":return this.convertToRange(t.getRanges(),{multiSheet:!0});case"ref:val":return this.convertToValueRange(t.getRanges())}s.throwInternal('FormulaContext.convertOperandToValue(): unknown type specifier: "'+e+'"')},E.prototype.equalScalars=function(t,e){return this._formulaInterpreter.equalScalars(t,e)},E.prototype.compareScalars=function(t,e){return this._formulaInterpreter.compareScalars(t,e)},E.prototype.validateValue=function(t){if(t instanceof Date)return t=this.numberFormatter.convertDateToNumber(t),_.isNumber(t)?t:L.NUM;if(t instanceof Q){if(!isFinite(t.real)||!isFinite(t.imag))return L.NUM;C(t.real)&&(t.real=0),C(t.imag)&&(t.imag=0),t=this.numberFormatter.convertComplexToString(t,i.MAX_LENGTH_STANDARD_FORMULA)}var e=typeof t;return"number"===e?isFinite(t)?C(t)?0:t:L.NUM:"string"===e?t.length<=this._MAX_STRING_LEN?t:L.VALUE:t},E.prototype.checkStringLength=function(t){if(t<0||t>this._MAX_STRING_LEN)throw L.VALUE},E.prototype.checkStringIndex=function(t){if(t<1||t>this._MAX_STRING_LEN)throw L.VALUE},E.prototype.concatStrings=function(){var t=_.reduce(arguments,function(t,e){return t+e},"");return this.checkStringLength(t.length),t},E.prototype.repeatString=function(t,e){return this.checkStringLength(t.length*e),0===t.length?"":M(t,e)},E.prototype.checkCellRef=function(t){if(!this.docModel.isValidAddress(t.toAddress()))throw L.VALUE},E.prototype.checkRangeDims=function(t,e){if(!U.prototype.equalSize.call(t,e))throw L.VALUE},E.prototype.checkEvalTime=j?_.noop:function(){if(_.now()>this._END_EVAL_TIME)throw s.TIMEOUT_ERROR},E.prototype.getOperandCount=function(){return this._operandResolver.size()},E.prototype.getOperand=function(t,e){var r=this._operandResolver.resolve(t);if(!r)throw L.NA;return e?this.convertOperandToValue(r,e):r},E.prototype.getOperandValue=function(t){return this.getOperand(t).getRawValue()},E.prototype.isMissingOperand=function(t){return t>=this._operandResolver.size()},E.prototype.isEmptyOperand=function(t){var e=this._operandResolver.resolve(t);return!!e&&e.isEmpty()},E.prototype.isMissingOrEmptyOperand=function(t){return this.isMissingOperand(t)||this.isEmptyOperand(t)},E.prototype.getOperands=function(t,e){var r=this._operandResolver,o=r.size()-t;if(e&&(o=Math.min(o,e)),o<1)throw L.VALUE;return _.times(o,function(e){return r.resolve(t+e)})},E.prototype.iterateOperands=function(t,e){return this.getOperands(t).forEach(function(r,o){e.call(this,r,t+o)},this),this},E.prototype.createOperand=function(t,e){return new l(this,t,e)},E.prototype.isRefSheet=function(t){var e=this._refSheet;return null!==e&&e>=0&&e===t},E.prototype.getRefSheet=function(){if("number"!=typeof this._refSheet)throw L.REF;return this._refSheet},E.prototype.getRefSheetModel=function(){return this.docModel.getSheetModel(this.getRefSheet())},E.prototype.getRefAddress=function(){return this._refAddress.clone()},E.prototype.isTargetAddress=function(t){return this._targetAddress.equals(t)},E.prototype.getTargetAddress=function(){return this._targetAddress.clone()},E.prototype.getMatrixAddress=function(t){return H(t,this._matRow,this._matCol)},E.prototype.getCellValue=function(t,e){var r=this.docModel.getSheetModel(t);if(!r)throw L.REF;return this._getCellValue(r,e)},E.prototype.getCellMatrix=function(t,e){var r=this.docModel.getSheetModel(t);if(!r)throw L.REF;var o=z.createFromRange(e);s.ensureMatrixDim(o);var n=Y.create(o.rows,o.cols,null);return r.getCellCollection().createAddressIterator(e,{type:"value",covered:!0}).forEach(function(t){n.set(t[1]-e.start[1],t[0]-e.start[0],this._getCellValue(r,t))},this),n},E.prototype.getCellFormula=function(t,e){var r=this.docModel.getSheetModel(t);if(!r)throw L.REF;var o=r.getCellCollection().getTokenArray(e,{fullMatrix:!0,grammarId:"ui"});return o?{formula:o.formula,matrix:!!o.matrixRange}:null},E.prototype.getNearestCellValue=function(t,e,r,o,n){var a=this.docModel.getSheetModel(t);if(!a)throw L.REF;var i=e.addressAt(r),s=this._getCellValue(a,i);if(null!==s)return{value:s,offset:r};var l=a.getCellCollection(),c=l.findFirstCell(e,{startAddress:i,skipStart:!0,type:"value",covered:!0}),u=c?e.indexAt(c):n+1;if(u<=n)return{value:this._getCellValue(a,c),offset:u};var p=l.findFirstCell(e,{startAddress:i,skipStart:!0,type:"value",covered:!0,reverse:!0}),h=p?e.indexAt(p):o-1;return o<=h?{value:this._getCellValue(a,p),offset:h}:null},E.prototype.createParallelIteratorSome=function(t){return new b(t,function(t,e){return e.offset})},E.prototype.createParallelIteratorEvery=function(t){var e=this.createParallelIteratorSome(t);return new N(e,function(t,e){if(e.complete){var r=e.results[0];return{value:t,offset:e.offset,col:r.col,row:r.row,results:e.results}}})},E.prototype.createScalarIterator=function(t,e){return this._createOperandIterator(t,_.identity,e)},E.prototype.iterateScalars=function(t,e,r){var o=this.createScalarIterator(t,r);return this._iterateValues(o,e)},E.prototype.getScalarsAsArray=function(t,e){return this.createScalarIterator(t,e).toArray()},E.prototype.createNumberIterator=function(e,r){var o=d(e,r),n=t.getBooleanOption(r,"skipErrors",!1),a=t.getBooleanOption(r,"floor",!1),i=t.getBooleanOption(r,"dates",!1);return m(this._createOperandIterator(e,function(t){if(n&&k(t))return null;switch(o){case"convert":t=this.convertToNumber(t,a);break;case"rconvert":if(_.isBoolean(t))throw L.VALUE;t=this.convertToNumber(t,a);break;case"exact":if(_.isString(t)||_.isBoolean(t)||null===t)throw L.VALUE;t=this.convertToNumber(t,a);break;case"skip":_.isNumber(t)?a&&(t=Math.floor(t)):t=null;break;case"zero":t=_.isString(t)?0:this.convertToNumber(t,a);break;default:s.throwInternal('FormulaContext.createNumberIterator(): unknown conversion mode: "'+o+'"')}return i&&_.isNumber(t)?this.convertToDate(t):t},_.extend({},r,{emptyCells:!1,acceptErrors:n})))},E.prototype.iterateNumbers=function(t,e,r){var o=this.createNumberIterator(t,r);return this._iterateValues(o,e)},E.prototype.getNumbersAsArray=function(t,e){return this.createNumberIterator(t,e).toArray()},E.prototype.aggregateNumbers=function(t,e,r,o,n){return this._aggregateValues(t,e,this.iterateNumbers,r,o,n)},E.prototype.aggregateNumbersAsArray=function(t,e,r){var o=[];return this.aggregateNumbers(t,0,function(t,e){return o.push(e),t+e},function(t,r){return e.call(this,o,t,r)},r)},E.prototype.aggregateNumbersParallel=function(e,r,o,n,a){e=_.map(e,function(t){return t instanceof l?t:this.createOperand(t)},this);var i=t.getStringOption(a,"checkSize","exact");if(e.length>1&&"none"!==i){var c="size"!==i,u=e[0].getDimension({errorCode:L.VALUE}),p=u.size();e.forEach(function(e,r){if(0!==r){var o=e.getDimension({errorCode:L.VALUE});if(c?!u.equals(o):p!==o.size())throw t.getOption(a,"sizeMismatchError",L.VALUE)}})}var h=e.map(function(t){return this.createNumberIterator(t,a)},this),f=r,g=0;return this.createParallelIteratorEvery(h).forEach(function(t){f=o.call(this,f,t,g),g+=1}),s.throwErrorCode(n.call(this,f,g))},E.prototype.aggregateNumbersParallelAsArrays=function(t,e,r){var o=[],n=_.times(t.length,_.constant(0));return this.aggregateNumbersParallel(t,n,function(t,e){return o.push(e),e.forEach(function(e,r){t[r]+=e}),t},function(t,r){return e.call(this,o,t,r)},r)},E.prototype.createStringIterator=function(t,e){var r=d(t,e);return m(this._createOperandIterator(t,function(t){switch(r){case"convert":return this.convertToString(t);case"skip":return"string"==typeof t?t:null;default:s.throwInternal('FormulaContext.createStringIterator(): unknown conversion mode: "'+r+'"')}},_.extend({},e,{emptyCells:!1,acceptErrors:!1})))},E.prototype.iterateStrings=function(t,e,r){var o=this.createStringIterator(t,r);return this._iterateValues(o,e)},E.prototype.aggregateStrings=function(t,e,r,o,n){return this._aggregateValues(t,e,this.iterateStrings,r,o,n)},E.prototype.createBooleanIterator=function(t,e){var r=d(t,e);return m(this._createOperandIterator(t,function(t){switch(r){case"convert":return this.convertToBoolean(t);case"skip":return _.isString(t)?null:this.convertToBoolean(t);default:s.throwInternal('FormulaContext.createBooleanIterator(): unknown conversion mode: "'+r+'"')}},_.extend({},e,{emptyCells:!1,acceptErrors:!1})))},E.prototype.iterateBooleans=function(t,e,r){var o=this.createBooleanIterator(t,r);return this._iterateValues(o,e)},E.prototype.aggregateBooleans=function(t,e,r,o,n){return this._aggregateValues(t,e,this.iterateBooleans,r,o,n)},E.prototype.isMatrixMode=function(){return"mat"===this._contextType&&!!this._matDim},E.prototype.getMatrixDim=function(){return this._matDim},E.prototype.aggregateMatrix=function(t,e){try{return this.pushOperandResolver(this._operandResolver,"mat",t),Y.generate(t.rows,t.cols,function(t,r){this.checkEvalTime(),this.setMatrixPosition(t,r);try{return e.call(this,t,r)}catch(t){if(k(t))return t;throw t}},this)}finally{this.popOperandResolver()}},E.prototype.countBlankCells=function(e,r){var o=0,n=t.getBooleanOption(r,"emptyStr",!1)?function(t){""!==t&&(o+=1)}:function(){o+=1};return this.iterateScalars(e,n,{acceptErrors:!0,complexRef:!0}),e.cells()-o},E.prototype.convertPatternToRegExp=function(t,e){return t=_.escapeRegExp(t).replace(/(^|[^~])\\\*/g,"$1.*").replace(/(^|[^~])\\\?/g,"$1.").replace(/~(\\[*?])/g,"$1"),e&&(t="^"+t+"$"),new RegExp(t,"i")},E.prototype.createScalarMatcher=function(t){if(null===t&&(t=0),"string"==typeof t&&/[*?]/.test(t)){var e=this.convertPatternToRegExp(t,!0);return function(t){return"string"==typeof t&&e.test(t)}}return this.equalScalars.bind(this,t)},E.prototype.createFilterMatcher=function(t){var e=this.numberFormatter,r=null,o=null,n=null;if("string"==typeof t){var a=/^(<=|>=|<>|<|>|=)?(.*)$/.exec(t);r=a[1]||"",o=e.parseValue(a[2],{keepApos:!0})}else r="",o=t;if(n=""===r||"="===r,null===o)return function(t){return 0===("string"==typeof t?e.parseValue(t):t)};if(""===o)switch(r){case"":return S;case"=":return y;case"<>":return v;default:return J}var i=q(o);if(i===G.STRING&&/[*?]/.test(o)&&(n||"<>"===r)){var l=this.convertPatternToRegExp(o,!0);return function(t){return n===("string"==typeof t&&l.test(t))}}i===G.STRING&&(o=o.toUpperCase());var c=n&&i===G.NUMBER;return function(t){if(c&&"string"==typeof t){var n=e.parseValue(t);"number"==typeof n&&(t=n)}var a=null!==t&&i===q(t)?$(t,o):X.NA;switch(r){case"":case"=":return a===X.EQUAL;case"<>":return a!==X.EQUAL;case"<":return a===X.LESS;case"<=":return a<=X.EQUAL;case">":return a===X.GREATER;case">=":return a>=X.EQUAL}s.throwInternal("FormulaContext.comparisonMatcher(): invalid operator")}},E.prototype.countFilteredCells=function(){return new c(this,0).countMatches()},E.prototype.aggregateFilteredCells=function(t,e,r,o){var n=t===Z.MULTI,a=new c(this,n?1:0),i=a.getFilterRange(0),s=n?this.getOperand(0,"ref:val"):this.isMissingOperand(2)?null:this.getOperand(2,"ref:val");return n||(s?(s.end[0]=Math.min(s.start[0]+i.cols()-1,this.docModel.getMaxCol()),s.end[1]=Math.min(s.start[1]+i.rows()-1,this.docModel.getMaxRow()),i.end[0]=i.start[0]+s.cols()-1,i.end[1]=i.start[1]+s.rows()-1):s=i.clone()),a.aggregateNumbers(s,e,r,o)},E});