define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/presetformattable","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(e,r,t,a,n,o,i,l){"use strict";function u(){this._operands=[]}var s=a.ErrorCode,c=a.isErrorCode,f=a.Address,p=a.Range,d=a.Range3DArray,m=o.Dimension,g=o.CompareNullMode,v=o.equalScalars,h=o.compareScalars,y=o.scalarToString,R=o.isValidMatrixDim,w=o.Matrix,E=o.FormulaErrorCode,k=o.FormulaError,x=o.formulaLogger;u.prototype.push=function(e){this._operands.push({operand:null,resolve:_.once(e)})},u.prototype.size=function(){return this._operands.length},u.prototype.get=function(e){var r=this._operands[e];return r&&r.operand||null},u.prototype.resolve=function(e){var r=this._operands[e];return r?r.operand=r.resolve():null};var S=r.extend({constructor:function(t,a,g){function v(e){var r=e.getRange3D(g);return r?new d(r):s.REF}function h(e,r,t){var a=e.resolveNameModel(N);if(!a)return s.NAME;var n={refSheet:N,refAddress:f.A1,targetAddress:V.getRefAddress(),recalcDirty:P};return t&&(n.matrixRange=p.createFromAddressAndSize(n.targetAddress,t.cols,t.rows)),"mat"!==r||t||(r="any"),a.getTokenArray().interpretFormula(r,n).value}function y(e){var r=e.getRange3D(C);return r?new d(r):s.REF}function S(e,r){if("ref"===r&&"ref"!==e&&"any"!==e)throw new k("expected reference token",E.REFERENCE)}function T(e,r){return!r&&e instanceof i?e:V.createOperand(e,r)}function b(e,r,t){var a=e.token,n=null,i=null;switch(x.log("> resolving operand token "+a+" with context type "+r),a.getType()){case"lit":n=(i=a.getValue())===s.REF?"ref":"val";break;case"mat":i=a.getMatrix(),n="mat";break;case"ref":i=v(a),n="ref";break;case"name":i=h(a,r,t),n="any";break;case"table":i=y(a),n="ref";break;default:o.throwInternal('InterpreterInstance.resolveOperandNode(): unknown token type: "'+a.getType()+'"')}return S(n,r),T(i)}function I(e,r){if("combine"===r){for(var t=M,a=0;t&&a<e.size();a+=1){var i=e.get(a),l=i&&i.getFormat()||M;t=o.combineParsedFormats(t,l)}return t}var u=null;switch(r){case"percent":u=n.getPercentId(!0);break;case"currency":u=D.getCurrencyCode({red:!0});break;case"fraction":u=n.getFractionId(!0);break;case"date":u=n.SYSTEM_DATE_ID;break;case"time":u=n.getTimeId(null,!0);break;case"datetime":u=n.SYSTEM_DATETIME_ID}return null===u?null:D.getParsedFormat(u)}function F(e,r,t,a,n){return V.checkEvalTime(),T(function(){try{V.setMatrixPosition(a,n);var o=t.map(function(e,t){return e?V.convertOperandToValue(e,r[t].typeSpec):null});return x.logTokens("  resolving with parameters",o),e.resolve.apply(V,o)}catch(e){if(c(e))return e;throw e}}())}function O(e,r,t){if(e.error)throw e.error;var a=e.token;x.log("> processing operator "+a+" with "+e.operands.length+" parameters and context type "+r);var n=e.descriptor;if(!n)return T(s.NAME);if(S(n.type,r),!_.isFunction(n.resolve))return x.warn('InterpreterInstance.resolveOperatorNode(): unsupported operator or function "'+a+'"'),T(o.UNSUPPORTED_ERROR);if(t&&!R(t))return T(o.UNSUPPORTED_ERROR);var i=new u,l=e.signature;l.forEach(function(a,o){var l=a.baseType,u=a.matSpec,s=e.operands[o],c="val"===l&&"val"===n.type,f="force"===u?"mat":l;"mat"!==r||!c&&"pass"!==u&&"forward"!==u||(f="mat");var p="mat"===f&&(c||"forward"===u);i.push(A.bind(null,s,f,p?t:null))});var f=l.map(function(e,r){return"any:lazy"===e.typeSpec?null:i.resolve(r)});if(!t&&"val"===n.type){var p="mat"===r;if(p||l.every(function(e){return"val"===e.baseType})){try{f.forEach(function(e,r){if(e&&(p?"val"===l[r].baseType&&!e.isScalar():e.isMatrix())){var a=e.getDimension({errorCode:s.VALUE});t=m.boundary(t,a)}})}catch(e){if(c(e))return T(e);throw e}if(t){if(!R(t))return T(o.UNSUPPORTED_ERROR);r="mat"}}}var d=x.takeTime(n.key,function(){try{V.pushOperandResolver(i,r,t);var e=F(n,l,f,0,0);if("mat"===n.type&&e.isScalar()&&(e=T(w.create(1,1,e.getRawValue()))),"any"===n.type||n.type===e.getType()||"ref"===n.type&&e.isScalar()&&c(e.getRawValue())||"val"===n.type&&"mat"===r&&e.isMatrix()||o.throwInternal("InterpreterInstance.resolveOperatorNode(): "+n.key+": operator result type does not match operator return type"),t&&e.isScalar()){x.info("  expand scalar result to "+t+" matrix");var a=w.generate(t.rows,t.cols,function(r,t){if(0===r&&0===t)return e.getRawValue();var a=F(n,l,f,r,t);if(a.isScalar())return a.getRawValue();o.throwInternal("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")});e=T(a)}return e}finally{V.popOperandResolver()}}),g=n.format&&"mat"!==r?I(i,n.format):null;return g?T(d,{format:g}):d}function A(e,r,t){var a=e.isOperator()?O(e,r,t):b(e,r,t);return x.log("< result of "+e+": "+a),a}var D=t.getNumberFormatter(),M=D.getStandardFormat(),N=e.getIntegerOption(g,"refSheet",null),C=e.getOption(g,"targetAddress",f.A1),P=e.getOption(g,"recalcDirty",!1),V=new l(t,g);r.call(this,t),this.getResult=function(e,r){var t=function(){try{return A(a,e,r)}catch(e){if(c(e))return T(e);throw e}}();e="any"===e?t.getType():e;var n={value:function(){try{switch(e){case"val":return t.getScalar(null,null);case"mat":return t.getMatrix();case"ref":return t.getRanges();default:o.throwInternal('InterpreterInstance.getResult(): unknown context type: "'+e+'"')}}catch(e){if(c(e))return e;throw e}}()},i=t.getFormat();i&&!i.isStandard()&&(n.format=i);var l=t.getURL();return null!==l&&(n.url=l),n},this.registerDestructor(function(){t=a=g=D=V=null})}});return t.extend({constructor:function(r){function a(e,r,t,a){var n="mat"===e?w.create(1,1,a):a;return x.withLogging(function(){x.info("result: type="+r+" code="+t+" value="+y(n))}),{type:r,code:t,value:n}}var n={withCase:"odf"===r.getApp().getFileFormat(),nullMode:g.CONVERT};t.call(this,r),this.equalScalars=function(e,r){return v(e,r,n)},this.compareScalars=function(e,r){return h(e,r,n)},this.createWarnResult=function(e,r){return a(e,"warn",r.key,"value"in r?r.value:r)},this.createErrorResult=function(e,r){return a(e,"error",r,s.NA)},this.interpretTokens=x.profileMethod("FormulaInterpreter.interpretTokens()",function(t,a,n){x.log("contextType="+t);var i=new S(r,a,n);try{var l="mat"===t?e.getOption(n,"matrixRange",null):null,u=l?m.createFromRange(l):null,s=i.getResult(t,u);return o.isInternalError(s.value)?this.createWarnResult(t,s.value):(s.type="valid",x.withLogging(function(){x.info("result: type=valid value="+y(s.value)+" format="+s.format+" url="+s.url)}),s)}catch(e){if(c(e))return this.createWarnResult(t,e);if(e instanceof k)return x.warn("  error: "+e.message),this.createErrorResult(t,e.code);throw e}finally{i.destroy()}}),this.registerDestructor(function(){r=null})}})});