define("io.ox/office/spreadsheet/model/formula/parser/expressionparser",["io.ox/office/tk/utils","io.ox/office/tk/containers","io.ox/office/tk/utils/class","io.ox/office/tk/locale/parser","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,n,a,s,c){"use strict";function o(e,t){this.token=e,this.index=-1,this.text=t,this.start=0,this.end=0}var i=t.arrayForEachReverse,R=a.Address,h=s.Matrix,l=s.SheetRef,f=s.formulaLogger;o.prototype.toString=function(){return this.token.toString()};var u=r.extendable(function(e,t){this.docModel=e,this.grammar=t,this.RE=t.RE,this.refGrammar=t.refGrammar});u.prototype._initOptions=function(t){this.refAddress=e.getOption(t,"refAddress",R.A1),this.refSheet=e.getIntegerOption(t,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.wrapReferences=e.getBooleanOption(t,"wrapReferences",!1),this.autoCorrect=e.getBooleanOption(t,"autoCorrect",!1),this.extendSheet=e.getBooleanOption(t,"extendSheet",!1),this.unqualifiedTables=e.getBooleanOption(t,"unqualifiedTables",!1)},u.prototype._parseNextToken=function(e){var t=this.RE,r=null,a=null;return(r=t.STRING_LIT.exec(e))?this.createLiteralToken(r[0].slice(1,r[0].length-1).replace(/""/g,'"'),r[0]):(r=t.BOOLEAN_LIT.exec(e))?this.createLiteralToken(this.grammar.getBooleanValue(r[0]),r[0]):(r=t.ERROR_LIT.exec(e))?this.createLiteralToken(this.grammar.getErrorCode(r[0]),r[0]):(r=t.FRACTION_LIT.exec(e))?this.createLiteralToken(parseInt(r[1],10)+parseInt(r[2],10)/parseInt(r[3],10),r[0]):(r=t.WHITESPACE.exec(e))?this.createFixedToken("ws",r[0]):(r=t.SEPARATOR.exec(e))?this.createToken(new c.SeparatorToken,r[0]):(r=t.OPERATOR.exec(e))?this.createToken(new c.OperatorToken(this.grammar.getOperatorKey(r[0])),r[0]):(r=t.OPEN.exec(e))?this.createToken(new c.ParenthesisToken(!0),r[0]):(r=t.CLOSE.exec(e))?this.createToken(new c.ParenthesisToken(!1),r[0]):(r=t.MATRIX_OPEN.exec(e))?this._parseMatrixLit(e):(a=this.parseNextRefToken(e))?a:(r=n.parseLeadingNumber(e,{dec:this.grammar.DEC}))?this.createLiteralToken(r.number,r.text):(a=this.parseNextNameToken(e))?a:void 0},u.prototype._parseMatrixLit=function(e){function t(){return i.every(function(e,t){return 0===t||e.length===i[t-1].length})}for(var r=e,a="start",s=this.RE,o=null,i=[],R=null;"end"!==a;){switch(a){case"start":(o=s.MATRIX_OPEN.exec(e))&&(i.push(R=[]),a="open");break;case"open":case"sep":(o=s.WHITESPACE.exec(e))||((o=s.FRACTION_LIT.exec(e))?(R.push(parseInt(o[1],10)+parseInt(o[2],10)/parseInt(o[3],10)),a="lit"):(o=n.parseLeadingNumber(e,{dec:this.grammar.DEC,sign:!0}))?(R.push(o.number),o=[o.text],a="lit"):(o=s.STRING_LIT.exec(e))?(R.push(o[0].slice(1,o[0].length-1).replace(/""/g,'"')),a="lit"):(o=s.BOOLEAN_LIT.exec(e))?(R.push(this.grammar.getBooleanValue(o[0])),a="lit"):(o=s.ERROR_LIT.exec(e))&&(R.push(this.grammar.getErrorCode(o[0])),a="lit"));break;case"lit":0===e.length?(o=this.autoCorrect&&t()?[""]:null,a="end"):(o=s.WHITESPACE.exec(e))||((o=s.MATRIX_ROW_SEPARATOR.exec(e))?(i.push(R=[]),a="sep"):(o=s.MATRIX_COL_SEPARATOR.exec(e))?a="sep":(o=s.MATRIX_CLOSE.exec(e))&&(t()||(o=null),a="end"))}if(!o)return null;e=e.substr(o[0].length)}var l=r.substr(0,r.length-e.length);return this.createToken(new c.MatrixToken(new h(i)),l)},u.prototype.createToken=function(e,t){return new o(e,t)},u.prototype.createFixedToken=function(e,t){return this.createToken(new c.FixedToken(e,t),t)},u.prototype.createLiteralToken=function(e,t){return this.createToken(new c.LiteralToken(e),t)},u.prototype.createReferenceToken=function(e,t,r){return!e&&this.extendSheet&&this.refSheetModel&&(e={r1:new l(this.refSheet,!0),r2:null}),this.createToken(new c.ReferenceToken(this.docModel,t?t.r1:null,t?t.r2:null,e?e.r1:null,e?e.r2:null),r)},u.prototype.createNameToken=function(t,r,n,a){!t&&this.extendSheet&&this.refSheetModel&&this.refSheetModel.getNameCollection().hasName(r)&&(t=new l(this.refSheet,!0));var s=!t&&/^\[0\]!/.test(n),o=new c.NameToken(this.docModel,r,t,s?0:null);return(e.getBooleanOption(a,"resolveTable",!1)?o.resolveTableModel():null)&&(o=new c.TableToken(this.docModel,r)),this.createToken(o,n)},u.prototype.createFunctionToken=function(e,t,r){var n=e?null:this.grammar.getFunctionKey(t);return this.createToken(n?new c.FunctionToken(n):new c.MacroToken(this.docModel,t,e),r)},u.prototype.createSheetRef=function(e,t){return this.refGrammar.createSheetRef(this.docModel,e,t)},u.prototype.createSheetRefs=function(e,t,r){return this.refGrammar.createSheetRefs(this.docModel,e,t,r)},u.prototype.createCellRangeRefs=function(e,t,r){return this.refGrammar.createCellRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},u.prototype.createColRangeRefs=function(e,t,r){return this.refGrammar.createColRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},u.prototype.createRowRangeRefs=function(e,t,r){return this.refGrammar.createRowRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},u.prototype.parseNextRefToken=function(){return e.error("ExpressionParserBase.parseNextRefToken(): missing implementation"),null},u.prototype.parseNextNameToken=function(){return e.error("ExpressionParserBase.parseNextNameToken(): missing implementation"),null},u.prototype.parseFormula=function(e,t){this._initOptions(t);for(var r=[];e.length>0;){var n=this._parseNextToken(e)||this.createFixedToken("bad",e);r.push(n),e=e.substr(n.text.length)}f.logTokens("tokenize",r);var a=this.grammar.isSpaceIntersection();return i(r,function(e,t){var n=e.token,s=r[t-1],o=r[t+1];if(n.isType("op")&&"sub"===n.getValue()&&o&&o.token.isType("lit")){var i=o.token.getValue();if("number"==typeof i&&i>0){var R=s&&s.token.isType("ws")?r[t-2]:s;R&&!R.token.matchesType(/^(op|sep|open)$/)||(e.token=new c.LiteralToken(-i),e.text+=o.text,r.splice(t+1,1))}}if(a&&n.isType("ws")){var h=h=e.text.indexOf(" ");if(h>=0&&s&&s.token.matchesType(/^(ref|name|close)$/)&&o&&o.token.matchesType(/^(ref|name|open|func)$/)){if(h+1<e.text.length){var l=e.text.slice(h+1);r.splice(t+1,0,this.createFixedToken("ws",l))}r.splice(t+1,0,this.createToken(new c.OperatorToken("isect")," ")),h>0?(n.setValue(e.text.slice(0,h)),e.text=n.getValue()):r.splice(t,1)}}},this),f.logTokens("postprocess",r),r.forEach(function(e,t){e.index=t,e.start=0===t?0:r[t-1].end,e.end=e.start+e.text.length}),r},u.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var T=u.extend(function(e,t){u.call(this,e,t)});T.prototype._parseTableRef=function(e,t){function r(){x[f.getTableRegionKey(E[1])]=!0,T="ref"}function n(e,t){"col1Name"in p?(E=null,T="end"):(p.col1Name=f.decodeTableColumn(e),p.col2Name=t?f.decodeTableColumn(t):null,T="ref")}function a(){n(E[1],E[2])}function s(e){e&&E[1]&&(p.openWs=!0),n(E[2]||E[3],E[4]||E[5])}function o(){E[1]&&(p.closeWs=!0),u||0!==E[2].length||(E=null),T="end"}var i=this.RE,R=e;t&&(e=e.substr(t.text.length));var h=i.TABLE_OPEN.test(e),l=t?t.token.resolveTableModel():null;if(t&&h&&!l)return null;if(t&&!h&&l)return this.createToken(new c.TableToken(this.docModel,t.token.getValue()),t.text);if(!h)return t;if(!t&&this.grammar.UI&&this.unqualifiedTables&&this.refSheetModel&&(l=this.refSheetModel.getTableCollection().findTable(this.refAddress)),!l)return null;for(var f=this.grammar,u=this.autoCorrect,T="start",E=null,p={},x={};"end"!==T;){switch(T){case"start":(E=i.TABLE_OPEN.exec(e))&&(E[1]&&(p.openWs=!0),T="open");break;case"open":(E=i.TABLE_CLOSE.exec(e))?o():(E=i.TABLE_SINGLE_REGION_NAME.exec(e))?r():(E=i.TABLE_SINGLE_COLUMN_NAME.exec(e))?a():(E=i.TABLE_REGION_REF.exec(e))?r():!this.grammar.UI&&(E=i.TABLE_COLUMN_RANGE_REF.exec(e))?a():!this.grammar.UI&&(E=i.TABLE_COLUMN_REF.exec(e))?a():this.grammar.UI&&(E=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?s(!0):this.grammar.UI&&(E=i.TABLE_MIXED_COLUMN_REF.exec(e))?s(!0):this.grammar.UI&&(E=i.TABLE_THISROW_REF.exec(e))&&(x.ROW=!0,T="row");break;case"ref":(E=i.TABLE_CLOSE.exec(e))?o():(E=i.TABLE_SEPARATOR.exec(e))&&(E[2]&&(p.sepWs=!0),T="sep");break;case"sep":(E=i.TABLE_REGION_REF.exec(e))?r():!this.grammar.UI&&(E=i.TABLE_COLUMN_RANGE_REF.exec(e))?a():!this.grammar.UI&&(E=i.TABLE_COLUMN_REF.exec(e))?a():this.grammar.UI&&(E=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?s():this.grammar.UI&&(E=i.TABLE_MIXED_COLUMN_REF.exec(e))&&s();break;case"row":(E=i.TABLE_CLOSE.exec(e))?(o(),p.closeWs&&(E=null)):(E=i.WHITESPACE.exec(e))||((E=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?s():(E=i.TABLE_MIXED_COLUMN_REF.exec(e))&&s())}if(!E)return null;e=e.substr(E[0].length)}switch((x=_.keys(x)).length){case 0:break;case 1:p.regionKey=x[0];break;case 2:if("HEADERS,DATA"===(x=x.join(","))||"DATA,HEADERS"===x)p.regionKey="HEADERS,DATA";else{if("DATA,TOTALS"!==x&&"TOTALS,DATA"!==x)return null;p.regionKey="DATA,TOTALS"}break;default:return null}var k=R.substr(0,R.length-e.length);return this.createToken(new c.TableToken(this.docModel,l.getName(),p),k)},T.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,n=null;return(r=t.RANGE_REF.exec(e))&&(n=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(null,n,r[0]):(r=t.RANGE_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,4,8))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.RANGE_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.CELL_REF.exec(e))&&(n=this.createCellRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.CELL_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.CELL_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.COLS_REF.exec(e))&&(n=this.createColRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.COLS_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,4,6))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COLS_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.COL_REF.exec(e))&&(n=this.createColRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.COL_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COL_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ROWS_REF.exec(e))&&(n=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.ROWS_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,4,6))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROWS_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ROW_REF.exec(e))&&(n=this.createRowRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.ROW_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROW_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),null,r[0]):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1,!0),null,r[0]):void 0},T.prototype.parseNextNameToken=function(e){var t=this.RE,r=this.refGrammar.RE,n=null;return(n=r.FUNCTION_REF.exec(e))?this.createFunctionToken(null,n[1],n[0]):(n=r.FUNCTION_3D_REF.exec(e))?this.createFunctionToken(this.createSheetRef(n,1),n[4],n[0]):(n=r.NAME_3D_REF.exec(e))?this._parseTableRef(e,this.createNameToken(this.createSheetRef(n,1),n[4],n[0])):(n=r.NAME_REF.exec(e))?this._parseTableRef(e,this.createNameToken(null,n[1],n[0])):this.grammar.UI&&(n=t.TABLE_OPEN.exec(e))?this._parseTableRef(e,null):void 0};var E=u.extend(function(e,t){u.call(this,e,t)});E.prototype.createSheetRangeData=function(e,t){return{r1:l.create(this.docModel,e[t+1],e[t+2],null,!!e[t]),r2:l.create(this.docModel,e[t+4],e[t+5],null,!!e[t+3])}},E.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,n=null;return(r=t.RANGE_REF.exec(e))&&(n=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(null,n,r[0]):(r=t.RANGE_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.RANGE_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,7,11))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.CELL_REF.exec(e))&&(n=this.createCellRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.CELL_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.CELL_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.COLS_REF.exec(e))&&(n=this.createColRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.COLS_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COLS_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,7,9))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.COL_REF.exec(e))&&(n=this.createColRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.COL_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COL_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ROWS_REF.exec(e))&&(n=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.ROWS_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROWS_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,7,9))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ROW_REF.exec(e))&&(n=this.createRowRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.ROW_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROW_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),null,r[0]):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRangeData(r,1),null,r[0]):void 0},E.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(null,r[1],r[0]):(r=t.NAME_REF.exec(e))?this.createNameToken(null,r[1],r[0],{resolveTable:!0}):void 0};var p=u.extend(function(e,t){u.call(this,e,t)});p.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.CELL_REF.exec(e))?this.createReferenceToken(null,this.createCellRangeRefs(r,1),r[0]):(r=t.CELL_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),this.createCellRangeRefs(r,5),r[0]):(r=t.RANGE_REF.exec(e))?this.createReferenceToken(null,this.createCellRangeRefs(r,1,5),r[0]):(r=t.RANGE_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),this.createCellRangeRefs(r,5,9),r[0]):(r=t.RANGE_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1,9),this.createCellRangeRefs(r,5,13),r[0]):void 0},p.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(null,r[1],r[0]):(r=t.NAME_REF.exec(e))?this.createNameToken(null,r[1],r[0],{resolveTable:!0}):void 0};var x={};return x.create=function(t,r){var n=t.getFormulaGrammar(r);switch(n.REF_SYNTAX){case"ooxml":return new T(t,n);case"odfui":return new E(t,n);case"of":return new p(t,n)}e.error('ExpressionParser.create(): invalid reference syntax: "'+n.REF_SYNTAX+'"')},x});