define("io.ox/office/spreadsheet/model/formula/parser/formulagrammar",["io.ox/office/tk/utils","io.ox/office/tk/algorithms","io.ox/office/tk/locale/localedata","io.ox/office/tk/locale/formatter","io.ox/office/tk/object/baseobject","io.ox/office/spreadsheet/utils/errorcodes","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/referencegrammar"],function(e,t,r,n,o,i,a,l,s,u){"use strict";function f(e,t,r){if(0===r.length)return!1;var n=d(t).exec(r);if(!n)return!1;var o=n[1]?parseInt(n[1],10)-1:0,i=n[2]?parseInt(n[2],10)-1:0;return e.isValidAddress(new g(i,o))}var c=t.isZero,E=i.ErrorCode,R=i.createErrorCode,g=a.Address,x=a.Range,m=l.ScalarTypeId,h=l.getScalarType,p=l.CellRef,A=l.encodeComplexSheetName,T=l.formulaLogger,N={op:{localized:!1,locale:r.LOCALE},ui:{localized:!0,locale:r.LOCALE},en:{localized:!0,locale:"en_US"}},d=_.memoize(function(e){return new RegExp("^(?:"+e[0]+"(\\d*))?(?:"+e[1]+"(\\d*))?$","i")}),C=o.extend({constructor:function(t,r,i){function l(e){return null!==b.getKey(e,I)}function d(e,t){var r=g.parse(t);if(r&&e.isValidAddress(r))return!0;var n=v.getRCPrefixChars(!1);return!!f(e,n,t)||!(n===H||!f(e,H,t))}function C(e,t,r){return t&&!O.isSimpleSheetName(e,t)&&(t=A(t)),(r&&t?"$":"")+t}function S(e,t,r,n){var o=null!==t?"["+t+"]":"";if(r){var i=r.resolve(e,t);if(null===i)return null;var a=n&&!r.equals(n)?n.resolve(e,t):"";if(null===a)return null;o+=w?C(e,i,r.abs):i,a&&(o+=":"+(w?C(e,a,n.abs):a)),w||O.isSimpleSheetName(e,i)&&(!a||O.isSimpleSheetName(e,a))||(o=A(o))}return o?o+"!":""}function L(e,t){if(!t)return"";var r=t.resolve(e,null);return r?C(e,r,t.abs)+".":null}var O=this,w="odf"===r,M=N[t],v=s.create(r,M.locale),I=M.localized,b=v.getBooleanCollection(),B=v.getErrorCollection(),F=v.getRegionCollection(),P=v.getOperatorCollection(),G=v.getFunctionCollection(),y=v.getDec(I),X=v.getGroup(I),D=v.getSeparator(I),U=D,K=B.getName(E.REF.key,I),k=B.getName(E.NA.key,I),$=new n(o.SINGLETON,{dec:y,group:X}),z=w?I?"odfui":"of":"ooxml",H=v.getRCPrefixChars(I),W=u.create(v,I,i),Y=W.sheetConfig,V=Y.PATTERNS,j="\\[\\]'#"+(I?"@":""),q="\\x00-\\x2B\\x2D-\\x2F\\x3A-\\x40\\x5B-\\x60\\x7B\\x7D\\x7E"+(","===D?",":""),Z="([^"+q+"]+)",J="((?:[^"+j+"]|'.)+)",Q="(?:"+Z+"|\\["+J+"\\])",ee="(?:([\\s\\x00-\\x1f\\x80-\\x9f]+)(?=\\[|\\]|"+_.escapeRegExp(U)+(I?"|@":"")+"|$))?",te=new RegExp("^"+V.DEFINED_NAME+"$","i"),re=new RegExp("["+j+"]","g"),ne=new RegExp("^[^"+q+"]+$","i");o.call(this,o.SINGLETON),this.GRAMMAR=t,this.UI=I,this.REF_SYNTAX=z,this.RC_STYLE=i,this.refGrammar=W,this.DEC=y,this.SEP=D,this.MAT_OPEN="{",this.MAT_ROW=w||I?"|":";",this.MAT_COL=w||I?";":",",this.MAT_CLOSE="}",this.TABLE_SEP=U,this.PREFIX_CHARS=H,this.RE={WHITESPACE:new RegExp("^[\\s\\x00-\\x1f\\x80-\\x9f]+"),STRING_LIT:/^(".*?")+/,BOOLEAN_LIT:new RegExp("^"+b.getAllPattern(I)+V.TERMINATE_REF,"i"),ERROR_LIT:new RegExp("^"+B.getAllPattern(I)+"(?!"+V.NAME_INNER_CHAR_CLASS+")","i"),FRACTION_LIT:/^(\d+) (\d+)\/(0*[1-9]\d*)/,MATRIX_OPEN:new RegExp("^"+_.escapeRegExp(this.MAT_OPEN)),MATRIX_COL_SEPARATOR:new RegExp("^"+_.escapeRegExp(this.MAT_COL)),MATRIX_ROW_SEPARATOR:new RegExp("^"+_.escapeRegExp(this.MAT_ROW)),MATRIX_CLOSE:new RegExp("^"+_.escapeRegExp(this.MAT_CLOSE)),SEPARATOR:new RegExp("^"+_.escapeRegExp(D)),OPERATOR:new RegExp("^"+P.getAllPattern(I)),OPEN:/^\(/,CLOSE:/^\)/,TABLE_OPEN:new RegExp("^\\["+ee),TABLE_CLOSE:new RegExp("^([\\s\\x00-\\x1f\\x80-\\x9f]*)(\\]|$)"),TABLE_SEPARATOR:new RegExp("^([\\s\\x00-\\x1f\\x80-\\x9f]*)"+_.escapeRegExp(U)+ee),TABLE_SINGLE_REGION_NAME:new RegExp("^"+F.getAllPattern(I)+"(?=\\])","i"),TABLE_SINGLE_COLUMN_NAME:new RegExp("^"+J+"(?=\\])","i"),TABLE_SIMPLE_COLUMN_NAME:new RegExp("^"+Z,"i"),TABLE_REGION_REF:new RegExp("^\\["+F.getAllPattern(I)+"\\]","i"),TABLE_COLUMN_REF:new RegExp("^\\["+J+"\\]","i"),TABLE_MIXED_COLUMN_REF:new RegExp("^([\\s\\x00-\\x1f\\x80-\\x9f]*)"+Q,"i"),TABLE_COLUMN_RANGE_REF:new RegExp("^\\["+J+"\\]:\\["+J+"\\]","i"),TABLE_MIXED_COLUMN_RANGE_REF:new RegExp("^([\\s\\x00-\\x1f\\x80-\\x9f]*)"+Q+":"+Q,"i"),TABLE_THISROW_REF:/^@/},T.info("FormulaGrammar(): grammar="+t+" config=",this),this.isReservedSymbol=function(e,t){return l(t)||d(e,t)},this.isSimpleSheetName=function(t,r,n){var o=Y.RE.SIMPLE_EXT_SHEET_NAME.exec(r);return!!o&&(!(o[1]&&!e.getBooleanOption(n,"external",!1))&&(!(o[3]&&!e.getBooleanOption(n,"range",!1))&&(!this.isReservedSymbol(t,o[2])&&(!o[3]||!this.isReservedSymbol(t,o[3])))))},this.validateNameLabel=function(e,t){return 0===t.length?"name:empty":te.test(t)?!w&&l(t)?"name:invalid":d(e,t)?"name:address":"":"name:invalid"},this.formatScalar=function(t){switch(h(t)){case m.NUMBER:return isFinite(t)?c(t)?"0":$.formatStandardNumber(t,a.MAX_LENGTH_STANDARD_EDIT):this.getErrorName(E.NUM);case m.STRING:return'"'+t.replace(/"/g,'""')+'"';case m.BOOLEAN:return this.getBooleanName(t);case m.ERROR:return this.getErrorName(t);case m.NULL:return""}return e.warn("FormulaGrammar.formatScalar(): unsupported scalar value type"),""},this.formatGenericRange=function(e,t,r,n,o){if("of"===this.REF_SYNTAX){var i=L(e,t);if(null===i)return K;var a=r?L(e,r):"";if(null===a)return K;var l=i+n;return(a||o)&&(l+=":"+a+(o||n)),l}var s=S(e,null,t,r);return null===s?K:s+n+(o?":"+o:"")},this.formatReference=function(t,r,n,o,a,l){if(!I&&i)return e.error("FormulaGrammar.formatReference(): R1C1 notation not supported in native grammar"),k;var s=a?x.createFromAddresses(a.toAddress(),l&&l.toAddress()):null,u=null,f=null;return"of"===this.REF_SYNTAX?s?(u=a.refText(),n||(u="."+u),l&&(f=l.refText(),o||(f="."+f)),"["+this.formatGenericRange(t,n,o,u,f)+"]"):"["+K+"]":s?(a.absCol&&l&&l.absCol&&t.isRowRange(s)?(u=i?a.rowTextRC(H,r):a.rowText(),i&&s.singleRow()&&a.absRow===l.absRow||(f=i?l.rowTextRC(H,r):l.rowText())):a.absRow&&l&&l.absRow&&t.isColRange(s)?(u=i?a.colTextRC(H,r):a.colText(),i&&s.singleCol()&&a.absCol===l.absCol||(f=i?l.colTextRC(H,r):l.colText())):(u=i?a.refTextRC(H,r):a.refText(),l&&(f=i?l.refTextRC(H,r):l.refText())),this.formatGenericRange(t,n,o,u,f)):w?K:this.formatGenericRange(t,n,o,K)},this.formatName=function(e,t,r,n){if(w&&(t||r))return k;var o=S(e,t,r);return null===o&&(o="["+(t||0)+"]!"),o+n},this.formatMacro=function(e,t,r,n){if(w)return t||r?k:n;var o="_xludf.".length<n.length&&"_xludf."===n.substr(0,"_xludf.".length).toLowerCase();return I&&o?n=n.substr("_xludf.".length):I||o||!G.getKey(n,!1)||(n="_xludf."+n),this.formatName(e,t,r,n)},this.getBooleanName=function(e){return b.getName(e?"t":"f",I)},this.getBooleanValue=function(e){var t=b.getKey(e,I);return t?"t"===t:null},this.getErrorName=function(e){return B.getName(e.key,I)},this.getErrorCode=function(e){var t=B.getKey(e,I);return t?R(t):null},this.getOperatorName=function(e){return P.getName(e,I)},this.getOperatorKey=function(e){return P.getKey(e,I)},this.getFunctionName=function(e){return G.getName(e,I)},this.getFunctionKey=function(e){return G.getKey(e,I)},this.getTableRegionName=function(e){return F.getName(e,I)},this.getTableRegionKey=function(e){return F.getKey(e,I)},this.isSimpleTableColumn=function(e){return ne.test(e)},this.decodeTableColumn=function(e){return e.replace(/'(.)/g,"$1")},this.encodeTableColumn=function(e){return e.replace(re,"'$&")},this.isSpaceIntersection=function(){return" "===this.getOperatorName("isect")},this.generateAutoFormula=function(e,t,r,n){var o=this.getFunctionName(t)+"(";if(r){var i=new p(r.start[0],r.start[1],!1,!1),a=r.single()?null:new p(r.end[0],r.end[1],!1,!1);o+=this.formatReference(e,n,null,null,i,a)}return o+")"}}});return C.create=function(){return _.memoize(function(e,t,r){return new C(e,t,r)},function(e,t,r){return e+":"+t+"!"+(r?"rc":"a1")})}(),C});