define("io.ox/office/spreadsheet/model/formula/tokenarray",["io.ox/office/tk/utils","io.ox/office/tk/containers","io.ox/office/editframework/utils/attributeutils","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,n,s,o,i){"use strict";function a(t){var r=e.getIntegerOption(t,"sheet"),n=!e.getBooleanOption(t,"relSheet",!1);return"number"==typeof r?new v(r,n):null}function l(e,t){this._docModel=e.getDocModel(),this._sheetModel=e===this._docModel?null:e,this._changeHandlers=null,this._allTokens=[],this._sheet3dTokens=[],this._refTokens=[],this._nameTokens=[],this._tokenTypeSet={},this._wrapReferences=t===y.NAME,this._freezeRelRefs=t===y.NAME,this._detectCircular=t===y.CELL,this._unqualifiedTables=t===y.CELL,this._compileDesc=null,this._resultCache=null,this._interpreting=null}var h=t.arrayCast,u=t.KeySet,c=t.UidSet,p=t.ValueMap,f=s.UpdateMode,d=s.Address,g=n.rangeKeyFromIndexes,k=s.RangeArray,m=s.Range3DArray,T=o.CellRef,v=o.SheetRef,y=o.FormulaType,R=i.SeparatorToken,S=i.ParenthesisToken,w=i.ReferenceToken,C=i.NameToken;return l.prototype._registerToken=function(e){this._tokenTypeSet[e.getType()]=!0,e.hasSheetRef&&e.hasSheetRef()&&this._sheet3dTokens.push(e),e instanceof w&&this._refTokens.push(e),e instanceof C&&this._nameTokens.push(e)},l.prototype._invokeChangeHandlers=function(e,t){this._compileDesc=null,this.clearResultCache(),this._changeHandlers&&this._changeHandlers.forEach(function(r){r.call(this,e,t)},this)},l.prototype._resolveChangedFormula=function(e,t){var r=this._docModel.getFormulaGrammar(e),n="",s="";return this._allTokens.forEach(function(e){var o=e.getText(r),i=t.call(this,e,r);n+=o,s+=null===i?o:i},this),n===s?null:{old:n,new:s}},l.prototype._resolveRefSheet=function(t){return this._sheetModel?this._sheetModel.getIndex():e.getIntegerOption(t,"refSheet",null)},l.prototype._extendWithOwnOptions=function(e){return _.extend({wrapReferences:this._wrapReferences},e,{refSheet:this._resolveRefSheet(e),detectCircular:this._detectCircular,unqualifiedTables:this._unqualifiedTables})},l.prototype._compileTokens=function(e){return this._docModel.getFormulaCompiler().compileTokens(e)},l.prototype._isInterpreting=function(e){return!!this._interpreting&&this._interpreting.has(e)},l.prototype._lockInterpreting=function(e,t){var r=this._interpreting||(this._interpreting=new u);try{return r.insert(e),t.call(this)}finally{r.remove(e)}},l.prototype.getDocModel=function(){return this._docModel},l.prototype.getSheetModel=function(){return this._sheetModel},l.prototype.empty=function(){return 0===this._allTokens.length},l.prototype.hasToken=function(e){return e in this._tokenTypeSet},l.prototype.hasRefTokens=function(){return this.hasToken("ref")||this.hasToken("name")||this.hasToken("table")},l.prototype.hasSheet3dTokens=function(){return this._sheet3dTokens.length>0},l.prototype.getFormula=function(e,t){var r=this._docModel.getFormulaGrammar(e),n=this._extendWithOwnOptions(t);return this._allTokens.reduce(function(e,t){return e+t.getText(r,n)},"")},l.prototype.resolveStringList=function(){var e=[],t="";return this._allTokens.every(function(r){switch(r.getType()){case"lit":return t+="L",e.push(r.getValue()),_.isString(_.last(e));case"sep":return t+=",",!0;case"ws":return!0;default:return t+="I",!1}}),/^L(,L)*$/.test(t)?e:null},l.prototype.resolveRangeList=function(t){var r=e.getOption(t,"targetAddress",d.A1),n=new m;if(this._isInterpreting(r))return n;var s=e.getStringOption(t,"resolveNames",null);if(!(s?this.hasRefTokens():this.hasToken("ref")))return n;t=this._extendWithOwnOptions(t);var o="";return this._allTokens.every(function(e){switch(e.getType()){case"ref":var i=e.getRange3D(t);return!(!i||!i.singleSheet())&&(n.push(i),o+="R",!0);case"name":var a=s?e.resolveNameModel(t.refSheet):null;if(!a)return!1;var l=_.clone(t);l.refAddress=d.A1;var h=this._lockInterpreting(r,function(){var e=a.getTokenArray();switch(s){case"simple":return e.resolveRangeList(l);case"interpret":var t=e.interpretFormula("ref",l);return t.value instanceof m?t.value:null;default:return null}});return!(!h||h.empty())&&(n.append(h),o+="R",!0);case"table":var u=s?e.getRange3D(r):null;return!!u&&(n.push(u),o+="R",!0);case"open":return o+="<",!0;case"close":return o+=">",!0;case"sep":return o+=",",!0;case"ws":return!0;default:return!1}},this)&&/^(R(,R)*|<R(,R)*>)$/.test(o)?n:n.clear()},l.prototype.extractRanges=function(t){var r=e.getOption(t,"targetAddress",d.A1),n=[];if(n.circular=!1,this._isInterpreting(r))return n.circular=!0,n;var s=e.getBooleanOption(t,"resolveNames",!1);return(s?this.hasRefTokens():this.hasToken("ref"))?(t=this._extendWithOwnOptions(t),this._allTokens.forEach(function(e,o){switch(e.getType()){case"ref":var i=e.getRange3D(t);i&&n.push({range:i,index:o,type:"ref"});break;case"name":var a=s?e.resolveNameModel(t.refSheet):null;if(!a)return;var l=_.clone(t);l.refAddress=d.A1;var h=this._lockInterpreting(r,function(){return a.getTokenArray().extractRanges(l)});h.forEach(function(e){n.push({range:e.range,index:o,type:"name"})}),n.circular=n.circular||h.circular;break;case"table":var u=s?e.getRange3D(r):null;u&&n.push({range:u,index:o,type:"table"})}},this),n):n},l.prototype.resolveOperation=function(t,r,n,s){var o=this._resolveRefSheet(),i=function(){switch(r.type){case f.DELETE_SHEET:return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(t,function(e,t){return e.resolveDeletedSheet(t,r.sheet,o)}):null;case f.RENAME_SHEET:return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(t,function(e,t){return e.resolveRenamedSheet(t,r.sheet,r.sheetName,r.tableNames)}):null;case f.RELABEL_NAME:return 0===this._nameTokens.length?null:this._resolveChangedFormula(t,function(e,t){return e.resolveRelabeledName(t,r.sheet,r.oldLabel,r.newLabel,o)});case f.MOVE_CELLS:if(!this.hasToken("ref")&&!this.hasToken("table"))return null;var n={refSheet:o,freezeRelRefs:this._freezeRelRefs};return r.relocate&&(n.refAddress=r.relocate.from,n.targetAddress=r.relocate.to),this._resolveChangedFormula(t,function(e,t){return e.resolveMovedCells(t,r.sheet,r.transformer,n)});case f.CUT_PASTE:if(!this.hasToken("ref"))return null;var s={refSheet:o,sheet:r.sourceSheet};return this._resolveChangedFormula(t,function(e,t){return e.resolveCutPasteCells(t,r.sourceRange,r.targetRange,s)})}return e.error('TokenArray.resolveOperation(): unknown operation type "'+r.type+'"'),null}.call(this);return i&&n.call(s,i.new,i.old),this},l.prototype.resolveOperationProperty=function(e,t,r,n,s){return this.resolveOperation(e,t,function(e,t){n[r]=e,s&&(s[r]=t)})},l.prototype.resolveOperationAttribute=function(e,t,n,s,o,i){return this.resolveOperation(e,t,function(e,t){r.insertAttribute(o,n,s,e),i&&r.insertAttribute(i,n,s,t)})},l.prototype.registerChangeHandler=function(e){return(this._changeHandlers||(this._changeHandlers=[])).push(e),this},l.prototype.unregisterChangeHandler=function(e){return this._changeHandlers&&(this._changeHandlers=_.without(this._changeHandlers,e)),this},l.prototype.setTokens=function(e){return this.empty()&&0===e.length?this:(this._allTokens=e.slice(),this._refTokens=[],this._sheet3dTokens=[],this._tokenTypeSet={},this._allTokens.forEach(this._registerToken,this),this._invokeChangeHandlers(null),this)},l.prototype.clearTokens=function(){return this.setTokens([])},l.prototype.parseFormula=function(t,r,n){n=this._extendWithOwnOptions(n);var s=this._docModel.getFormulaParser().parseFormula(t,r,n),o=_.pluck(s,"token");if(e.getBooleanOption(n,"autoCorrect",!1)){var i=this._compileTokens(o);if(!i.error)for(var a=0;a<i.missingClose;a+=1)o.push(new S(!1))}return this.setTokens(o),s},l.prototype.refreshAfterImport=function(e){return this.hasToken("bad")||this.hasToken("name")?this.parseFormula("op",this.getFormula("op"),e):this._sheet3dTokens.length>0&&(this._sheet3dTokens.forEach(function(e){e.refreshSheets()}),this._compileDesc=null,this.clearResultCache()),this},l.prototype.modifyToken=function(e,t,r,n){var s=this._allTokens[e];return s&&s.isType(t)&&r.call(n,s,e)&&this._invokeChangeHandlers(s,e),this},l.prototype.appendToken=function(e){return this._allTokens.push(e),this._registerToken(e),this._invokeChangeHandlers(e,this._allTokens.length-1),this},l.prototype.appendAddress=function(t,r){var n=e.getBooleanOption(r,"abs",!1),s=T.create(t,n,n),o=a(r);return this.appendToken(new w(this._docModel,s,null,o))},l.prototype.appendRange=function(t,r){var n=this._docModel.isColRange(t),s=this._docModel.isRowRange(t),o=e.getBooleanOption(r,"abs",!1),i=T.create(t.start,o||s,o||n&&!s),l=t.single()?null:T.create(t.end,o||s,o||n&&!s),h=a(r);return this.appendToken(new w(this._docModel,i,l,h))},l.prototype.appendRangeList=function(t,r){var n=t.length>1&&e.getBooleanOption(r,"parentheses",!1);return n&&this.appendToken(new S(!0)),t.forEach(function(e,t){t>0&&this.appendToken(new R),this.appendRange(e,r)},this),n&&this.appendToken(new S(!1)),this},l.prototype.relocateRanges=function(e,t){if(e.equals(t))return!1;var r=!1;return this._refTokens.forEach(function(n){n.relocateRange(e,t,this._wrapReferences)&&(r=!0)},this),r&&this._invokeChangeHandlers(null),r},l.prototype.transformSheet=function(e,t){if(t===e)return!1;var r=!1;return this._sheet3dTokens.forEach(function(n){n.transformSheet(e,t)&&(r=!0)},this),r&&this._invokeChangeHandlers(null),r},l.prototype.compileFormula=function(){return this._compileDesc||(this._compileDesc=this._compileTokens(this._allTokens))},l.prototype.getDependencies=function(e,t,r){var n={depRanges:new m,rootRanges:new m,nameSet:new c,tableSet:new c,missingNames:{},missingFuncs:{},recalc:null,circular:!1},i=this.compileFormula();if(i.error)return n;var a=t instanceof d?t:null;if(this._isInterpreting(a||e))return n.circular=!0,n;_.extend(n.missingFuncs,i.missingFuncs),n.recalc=i.root.recalc,r=this._extendWithOwnOptions(r);var l=a?_.extend({},r,{refAddress:e,targetAddress:a}):null,u=a?null:h(k,t),p=function i(h){var c=h.token;if(c.isType("ref")){if(l){var p=c.getRange3D(l);return p?new m(p):null}return c.getExpandedRanges(e,u,r)}if(c.isType("name")){var f=c.resolveNameModel(r.refSheet);if(!f)return n.missingNames[s.getNameKey(c.getValue())]=!0,null;var g=this._lockInterpreting(a||e,function(){return f.getTokenArray().getDependencies(d.A1,t,r)});return n.depRanges.append(g.depRanges),n.nameSet.insert(f),n.nameSet.merge(g.nameSet),n.tableSet.merge(g.tableSet),_.extend(n.missingNames,g.missingNames),_.extend(n.missingFuncs,g.missingFuncs),n.recalc=o.getRecalcMode(n.recalc,g.recalc),n.circular=n.circular||g.circular,g.rootRanges}if(c.isType("table")){var k=c.resolveTableModel();if(!k)return null;n.tableSet.insert(k);var T=c.getRange3D(a);return T?new m(T):null}if(h.operands&&h.signature){var v=new m;return h.signature.forEach(function(e,t){var r=i.call(this,h.operands[t]);switch(e.depSpec){case"pass":v.append(r);break;case"skip":break;default:n.depRanges.append(r)}},this),v}return null}.call(this,i.root);return n.rootRanges.append(p),n},l.prototype.interpretFormula=function(t,r){function n(){return i.interpretTokens(t,s.root,r)}var s=this.compileFormula(),i=this._docModel.getFormulaInterpreter();if(s.error)return i.createErrorResult(t,s.error);var a=e.getOption(r,"targetAddress",d.A1);if(this._isInterpreting(a))return i.createWarnResult(t,o.CIRCULAR_ERROR);var l=(r=this._extendWithOwnOptions(r)).cacheResult&&"always"!==s.root.recalc?this._resultCache||(this._resultCache=new p):null,h=function(){if(!l)return null;var e=this.hasToken("name"),t=e||s.root.relColRef,n=t&&r.refAddress?r.refAddress[0]:0,o=t?a[0]:0,i=e||s.root.relRowRef,h=i&&r.refAddress?r.refAddress[1]:0,u=i?a[1]:0;return g(n,h,o,u)}.call(this);return this._lockInterpreting(a,function(){return l?l.getOrCreate(h,n):n()})},l.prototype.clearResultCache=function(){return this._resultCache=null,this},l});