define("io.ox/office/spreadsheet/model/formula/utils/matrix",["require","exports","io.ox/office/tk/types","io.ox/office/tk/iterators","io.ox/office/spreadsheet/utils/errorcodes","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/model/formula/utils/dimension"],function(t,r,e,o,n,i,a,s){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var u=Math.floor;r.MAX_MATRIX_SIZE=1e4,r.isValidMatrixDim=function(t,o){var n=e.isNumber(t)?t*o:t.size();return n>0&&n<=r.MAX_MATRIX_SIZE},r.getMatrixAddress=function(t,r,e){if(t.singleCol()&&(e=0),t.singleRow()&&(r=0),e>=t.cols()||r>=t.rows())throw n.ErrorCode.NA;return new a.Address(t.start[0]+e,t.start[1]+r)};var c=function(){function t(t){this._array=t}return t.create=function(r,e,o){return t.generate(r,e,function(){return o})},t.generate=function(r,e,o,n){return new t(_.times(r,function(t){return _.times(e,function(r){return o.call(n,t,r)})}))},t.identity=function(r){return t.generate(r,r,function(t,r){return t===r?1:0})},t.createRowVector=function(r){return new t([r])},t.createColVector=function(r){return t.generate(r.length,1,function(t){return r[t]})},t.prototype.clone=function(){return new t(this._array.map(function(t){return t.slice()}))},t.prototype.values=function(){return this._array},t.prototype.rows=function(){return this._array.length},t.prototype.cols=function(){return this._array[0].length},t.prototype.dim=function(){return new s.Dimension(this.rows(),this.cols())},t.prototype.size=function(){return this.rows()*this.cols()},t.prototype.get=function(t,r){var e=this.rows(),o=this.cols();return 1===e&&(t=0),1===o&&(r=0),t<e&&r<o?this._array[t][r]:n.ErrorCode.NA},t.prototype.getByIndex=function(t){var r=this.cols();return this._array[u(t/r)][t%r]},t.prototype.getRowVector=function(r){return t.createRowVector(this._array[r])},t.prototype.getColVector=function(r){var e=this._array;return t.generate(this.rows(),1,function(t){return e[t][r]})},t.prototype.set=function(t,r,e){return this._array[t][r]=e,this},t.prototype.setByIndex=function(t,r){var e=this.cols();return this._array[u(t/e)][t%e]=r,this},t.prototype.update=function(t,r,e,o){return this._array[t][r]=e.call(o,this._array[t][r]),this},t.prototype.updateByIndex=function(t,r,e){var o=this.cols();return this.update(u(t/o),t%o,r,e)},t.prototype.add=function(t,r,e){return this._array[t][r]+=e,this},t.prototype.addByIndex=function(t,r){var e=this.cols();return this._array[u(t/e)][t%e]+=r,this},t.prototype.fill=function(t,r,e,o,n){for(var i=this._array,a=t;a<=e;a+=1)for(var s=r;s<=o;s+=1)i[a][s]=n;return this},t.prototype.iterator=function(){return new o.NestedIterator(new o.ArrayIterator(this._array),function(t){return new o.ArrayIterator(t)},function(t,r){return{done:!1,value:r.value,row:t.index,col:r.index}})},t.prototype.forEach=function(t,r){return this._array.forEach(function(e,o){return e.forEach(function(e,n){t.call(r,e,o,n)})}),this},t.prototype.map=function(r,e){var o=this._array;return t.generate(this.rows(),this.cols(),function(t,n){return r.call(e,o[t][n],t,n)})},t.prototype.reduce=function(t,r,e){return this.forEach(function(o,n,i){t=r.call(e,t,o,n,i)}),t},t.prototype.transform=function(t,r){var e=this;return this.forEach(function(o,n,i){return e.set(n,i,t.call(r,o,n,i))}),this},t.prototype.swapRows=function(t,r){var e=this._array[t];return this._array[t]=this._array[r],this._array[r]=e,this},t.prototype.scaleRow=function(t,r){return this._array[t].forEach(function(t,e,o){o[e]*=r}),this},t.prototype.addScaledRow=function(t,r,e){var o=this._array,n=o[t];return o[r].forEach(function(t,r){n[r]+=e*t}),this},t.prototype.transpose=function(){var r=this._array;return t.generate(this.cols(),this.rows(),function(t,e){return r[e][t]})},t.prototype.toString=function(){return"{"+this._array.map(function(t){return t.map(i.scalarToString).join(";")}).join("|")+"}"},t}();r.Matrix=c});