define("io.ox/office/spreadsheet/model/model",["io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/iterators","io.ox/office/tk/locale/localedata","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/textframework/utils/dom","io.ox/office/textframework/model/editor","io.ox/office/textframework/model/listhandlermixin","io.ox/office/textframework/model/updatelistsmixin","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/operationcontext","io.ox/office/spreadsheet/model/operationgenerator","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/listcollection","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/interpret/formulacompiler","io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(e,t,n,r,i,o,a,s,l,u,h,c,p,g,d,f,S,E,m,O,C,v,T,A,y,R,I){"use strict";var N=t.isFiniteNumber,M=n.clamp,x=n.createDict,w=r.arrayForEachReverse,b=r.arraySome,D=r.arrayGroup,L=r.ValueSet,H=r.UidSet,k=r.ValueMap,F=i.ArrayIterator,V=i.TransformIterator,B=g.SheetType,U=g.UpdateMode,G=g.Address,P=g.Interval,K=g.Range,W=g.RangeArray,j=g.Range3DArray,J=g.modelLogger,X=d.SheetOperationContext,Y=f.resolveOperations,q=f.SheetOperationGenerator,z={activeSheet:{def:-1,validate:function(t){return t>=-1&&t<this.getSheetCount()?t:e.BREAK}},rcStyle:{def:!1}},Q={"change:attributes":"change:sheet:attributes","change:viewattributes":"change:sheet:viewattributes"},Z=x([p.SET_ATTRIBUTES,p.DELETE,p.MOVE,p.TEXT_INSERT,p.TAB_INSERT,p.HARDBREAK_INSERT,p.PARA_INSERT,p.PARA_SPLIT,p.PARA_MERGE,p.INSERT_LIST,p.DELETE_LIST],!0),ee=c.getDebugUrlFlag("spreadsheet:failing-import");return l.extend({constructor:function(t){function r(e,t){Te=e-1,Ae=t-1}function i(e){return(e=_.isNumber(e)?e:_.isString(e)?ue.getSheetIndex(e):-1)>=0&&e<ce.length?ce[e]:null}function d(e,t){var n=ue.getSheetModel(e),r=_.isNumber(t)?ue.getSheetModel(t):null;return 0===e.length?"sheet:name:empty":/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]|'$/.test(e)?"sheet:name:invalid":!_.isObject(n)||_.isObject(r)&&n===r?null:"sheet:name:used"}function f(e,t){return null===d(e,t)}function x(e,t){var n=d(e,t);return null===n?$.when():g.makeRejected(n)}function te(e,t,n,r){if(!ue.canInsertSheet())return null;ue.trigger("insert:sheet:before",e);var i=ue.getActiveSheet();(i=e<=i?i+1:-1)>=0&&ue.setActiveSheet(-1);var o=new O(ue,t,r),a=o.uid,s=o.getDrawingCollection().getContainerNode();return ce.splice(e,0,{model:o,uid:a,name:n,node:s}),_e.insertBefore(s,_e.childNodes.item(e)),e===ce.length?pe.insert(a,e):pe.clear(),i>=0&&ue.setActiveSheet(i),ue.trigger("insert:sheet:after",e,o),ue.trigger("transform:sheet",null,e),ue.listenTo(o,"triggered",function(e,t){var n=Q[t]||t;ue.trigger.apply(ue,[n,o.getIndex()].concat(_.toArray(arguments).slice(2)))}),o}function ne(e){if(0===arguments.length){var t=ue.getActiveSheet(),n=ue.getSheetModel(t);return n?{sheet:t,selection:n.getViewAttribute("selection")}:null}var r=ue.getSheetModel(e.sheet);r&&(ue.setActiveSheet(e.sheet),r.setViewAttribute("selection",e.selection))}function re(e,t,n){ue.registerContextOperationHandler(e,function(e){t[n](e)})}function ie(t,n,r){var i=e.getBooleanOption(r,"allowDoc",!1);return ue.registerContextOperationHandler(t,function(e){var t=i&&!e.has("sheet"),r=t?null:e.getInt("sheet"),o=t?ue:ue.getSheetModel(r);return e.ensure(o,"missing sheet"),n.call(ue,e,o,r)})}function oe(e,t,n,r){ie(e,function(e,r){r[t]()[n](e)},r)}function ae(e,t){return ue.registerContextOperationHandler(e,function(e){var n=e.getPos("start");e.ensure(n.length>=2,"invalid drawing start position");var r=ue.getSheetModel(n[0]);return e.ensure(r,"invalid sheet index"),t.call(ue,e,r.getDrawingCollection(),n.slice(1))})}function se(e,t){ae(e,function(e,n,r){n[t](e,r)})}function le(t,n,r){var i=e.getStringOption(r,"type",null);ae(t,function(e,t,r){var o=t.getModelDescriptor(r);e.ensure(o,"invalid drawing position"),e.ensure(!i||i===o.model.getType(),"invalid drawing type"),e.ensure(0===o.remaining.length,"invalid drawing start position"),o.model[n](e)})}var ue=this,he=t.getFileFormat(),ce=[],pe=new k,ge=new L(function(e){return e.getKey()}),de=new k,fe=null,Se=null,Ee=null,me=null,Oe=null,Ce=null,ve=null,Te=0,Ae=0,ye=[],Re=null,_e=null;l.call(this,t,{contextClass:X,selectionStateHandler:ne,defaultStyleFamily:"cell",slideMode:!0}),a.call(this,z),u.call(this,t),h.call(this,t);var Ie=this.createDebouncedMethod("SpreadsheetModel.sendActiveSelectionDebounced",null,function(){var e=ne();e&&t.updateUserData({sheet:e.sheet,ranges:Ee.formatRangeList("op",e.selection.ranges),drawings:e.selection.drawings})},{delay:250});this.postProcessImport=function(){return 0===ce.length?$.Deferred().reject():(this.getCellStyles().createMissingStyles(),this.iterateArraySliced(ce,function(e){return e.model.postProcessImport()},"SpreadsheetModel.postProcessImport"))},this._registerTableModel=function(e){e.isAutoFilter()||ge.insert(e)},this._unregisterTableModel=function(e){e.isAutoFilter()||ge.remove(e)},this.getNumberFormatter=function(){return fe},this.getFormulaResource=function(){return v.create(he,o.LOCALE)},this.getFormulaGrammar=function(e){return de.getOrCreate(e,function(){var t=e.split("!"),n=t[1]?"rc"===t[1]:this.getViewAttribute("rcStyle"),r=t[0].split(":"),i=r[1]||he;return T.create(r[0],i,n)},this)},this.getFormulaParser=function(){return Ee},this.getFormulaCompiler=function(){return me},this.getFormulaInterpreter=function(){return Oe},this.getNameCollection=function(){return Ce},this.getListCollection=function(){return ve},this.getDependencyManager=function(){return Se},this.getMaxCol=function(){return Te},this.getMaxRow=function(){return Ae},this.getMaxIndex=function(e){return e?Te:Ae},this.getMaxAddress=function(){return new G(Te,Ae)},this.getSheetRange=function(){return K.create(0,0,Te,Ae)},this.isColRange=function(e){return 0===e.start[1]&&e.end[1]===Ae},this.makeColRange=function(e){var t="number"==typeof e;return K.create(t?e:e.first,0,t?e:e.last,Ae)},this.makeColRanges=function(e){return W.map(e,this.makeColRange.bind(this))},this.isRowRange=function(e){return 0===e.start[0]&&e.end[0]===Te},this.makeRowRange=function(e){var t="number"==typeof e;return K.create(0,t?e:e.first,Te,t?e:e.last)},this.makeRowRanges=function(e){return W.map(e,this.makeRowRange.bind(this))},this.isFullRange=function(e,t){return t?this.isColRange(e):this.isRowRange(e)},this.makeFullRange=function(e,t){return t?this.makeColRange(e):this.makeRowRange(e)},this.makeFullRanges=function(e,t){return t?this.makeColRanges(e):this.makeRowRanges(e)},this.getRangeGroups=function(e){return D(W,e,function(e){return this.isColRange(e)?"colRanges":this.isRowRange(e)?"rowRanges":"cellRanges"},this)},this.isValidAddress=function(e){return e[0]>=0&&e[0]<=Te&&e[1]>=0&&e[1]<=Ae},this.isValidRange=function(e){return e.start[0]>=0&&e.start[0]<=e.end[0]&&e.end[0]<=Te&&e.start[1]>=0&&e.start[1]<=e.end[1]&&e.end[1]<=Ae},this.parseJSONInterval=function(e,t,n){if(!_.isObject(e))return null;var r=n?"start":"first",i=n?"end":"last",o=this.getMaxIndex(t),a=e[r];if(!N(a)||a<0||a>o)return null;if(!(i in e))return new P(a);var s=e[i];return!N(s)||s<a||s>o?null:new P(Math.floor(a),Math.floor(s))},this.parseJSONAddress=function(e){return _.isArray(e)&&2===e.length?!N(e[0])||e[0]<0||e[0]>Te?null:!N(e[1])||e[1]<0||e[1]>Ae?null:new G(Math.floor(e[0]),Math.floor(e[1])):null},this.parseJSONRange=function(e){if(!_.isObject(e))return null;var t=this.parseJSONAddress(e.start);if(!t)return null;if(!("end"in e))return new K(t);var n=this.parseJSONAddress(e.end);return!n||n[0]<t[0]||n[1]<t[1]?null:new K(t,n)},this.parseJSONRanges=function(e){if(!_.isArray(e)||0===e.length)return null;var t=new W;return e.every(function(e){if(e=this.parseJSONRange(e))return t.push(e),!0},this),e.length===t.length?t:null},this.getBoundedMovedRange=function(e,t,n){return t=M(t,-e.start[0],Te-e.end[0]),n=M(n,-e.start[1],Ae-e.end[1]),K.create(e.start[0]+t,e.start[1]+n,e.end[0]+t,e.end[1]+n)},this.getCroppedMovedRange=function(e,t,n){var r=Math.max(0,e.start[0]+t),i=Math.max(0,e.start[1]+n),o=Math.min(Te,e.end[0]+t),a=Math.min(Ae,e.end[1]+n);return r<=o&&i<=a?K.create(r,i,o,a):null},this.getMaxSheetNameLength=function(){return t.isOOXML()?31:65535},this.hasSheet=function(e){return null!==i(e)},this.getSheetName=function(e){var t=i(e);return t?t.name:null},this.getSheetIndex=function(e){return e=e.toLowerCase(),_.findIndex(ce,function(t){return t.name.toLowerCase()===e})},this.getSheetIndexOfModel=function(e){var t=_.isString(e)?e:e.uid;return pe.getOrCreate(t,function(){return _.findIndex(ce,function(e){return e.uid===t})})},this.getSheetModel=function(e){var t=i(e);return t?t.model:null},this.getSheetCount=function(t){var n=e.getBooleanOption(t,"supported",!1),r=e.getBooleanOption(t,"cells",!1),i=e.getBooleanOption(t,"visible",null);return n||r||null!==i?this.createSheetIterator({supported:n,cells:r,visible:i}).reduce(0,function(e){return e+1}):ce.length},this.createSheetIterator=function(t){var n=e.getIntegerOption(t,"first",0),r=e.getIntegerOption(t,"last",ce.length-1),i=e.getBooleanOption(t,"reverse",!1),o=new F(ce,{begin:i?r:n,end:i?n-1:r+1,reverse:i}),a=e.getBooleanOption(t,"supported",!1),s=e.getBooleanOption(t,"cells",!1),l=e.getBooleanOption(t,"visible",null),u=0;return new V(o,function(e,t){var n=e.model;return a&&!n.isSupportedType()?null:s&&!n.isCellType()?null:null!==l&&l!==n.isVisible()?null:(t={value:n,name:e.name,sheet:t.index,index:u},u+=1,t)})},this.findVisibleSheet=function(e,t){var n=function(){switch(t){case"next":return{first:e,supported:!0,visible:!0};case"prev":return{last:e,reverse:!0,supported:!0,visible:!0}}return null}();if(n){var r=this.createSheetIterator(n).next();return r.done?-1:r.sheet}var i=this.findVisibleSheet(e,"next");return i<0?this.findVisibleSheet(e,"prev"):i},this.getActiveSheet=function(){return this.getViewAttribute("activeSheet")},this.setActiveSheet=function(e){return this.setViewAttribute("activeSheet",e)},this.canInsertSheet=function(){return c.MAX_SHEET_COUNT<1||ce.length<c.MAX_SHEET_COUNT},this.generateUnusedSheetName=function(){for(var e="",t=ce.length;0===e.length||this.hasSheet(e);)e=g.getSheetName(t),t+=1;return e},this.hasName=function(e){return Ce.hasName(e)||ce.some(function(t){return t.model.getNameCollection().hasName(e)})},this.getAllNames=function(t){var n=Ce.getAllNames(t);return e.getBooleanOption(t,"skipLocal",!1)||ce.forEach(function(e){n=n.concat(e.model.getNameCollection().getAllNames(t))}),n},this.hasTable=function(e){return ge.hasKey(g.getTableKey(e))},this.getTable=function(e){return ge.get(g.getTableKey(e),null)},this.getAllTables=function(e){return ce.reduce(function(t,n){return t.concat(n.model.getTableCollection().getAllTables(e))},[])},this.getRangeContents=function(t,n){var r=e.getIntegerOption(n,"maxCount",null,1),i=[],o=0;return t=j.filter(t,function(t){return!(!this.hasSheet(t.sheet1)||!t.singleSheet())||(e.warn("SpreadsheetModel.getRangeContents(): invalid sheet index in range address"),!1)},this),n=_.clone(n),b(t,function(e){var t=this.getSheetModel(e.sheet1).getCellCollection(),a=e.toRange(),s=t.getRangeContents(a,n);if(i=i.concat(s),o+=s.count,r===o)return!0;r&&(n.maxCount-=s.count)},this),i.count=o,i},this.sendOperations=_.wrap(this.sendOperations,function(t,n,r){return e.getBooleanOption(r,"defer",!1)?(ye=ye.concat(Y(n,r)),!0):t.call(this,n,r)}),this.createAndApplyOperations=_.wrap(this.createAndApplyOperations,function(e,t,n){return ye.length>0&&(this.sendOperations(ye),ye=[]),e.call(this,t,n)}),this.createSheetOperationGenerator=function(e){return new q(this,e)},this.createAndApplySheetOperations=J.profileAsyncMethod("SpreadsheetModel.createAndApplySheetOperations()",function(e,t){return t=_.extend({applyImmediately:!0,undoOptions:{preventSelectionChange:!0}},t,{generatorClass:q}),this.createAndApplyOperations(function(t){return this.setBlockKeyboardEvent(!0),ue.convertToPromise(e.call(this,t)).always(function(){ue.setBlockKeyboardEvent(!1)})},t)}),this.generateOperationsForSheets=function(e,t,n){var r=e.getSheetIndex();return this.iterateArraySliced(t,function(t){return e.setSheetIndex(t),n.call(ue,ue.getSheetModel(t),t)},"SpreadsheetModel.generateOperationsForSheets").always(function(){e.setSheetIndex(r)})},this.generateOperationsForAllSheets=function(t,n,r){var i=t.getSheetIndex(),o=e.getIntegerOption(r,"skipSheet",null);return this.iterateSliced(this.createSheetIterator(r),function(e,r){if(r.sheet!==o)return t.setSheetIndex(r.sheet),n.call(ue,e,r.sheet)},"SpreadsheetModel.generateOperationsForAllSheets").always(function(){t.setSheetIndex(i)})},this.generateUpdateFormulaOperations=J.profileAsyncMethod("SpreadsheetModel.generateUpdateFormulaOperations()",function(t,n,r){var i=e.getStringOption(r,"drawingMode",null);return e.invokeChainedAsync("only"===i?null:function(){return Ce.generateUpdateFormulaOperations(t,n)},function(){return ue.generateOperationsForAllSheets(t,function(e){return e.generateUpdateFormulaOperations(t,n,i)},r)})}),this.generateInsertSheetOperations=function(e,t,n,r,i){return x(r).then(function(){var o={sheetName:r};n!==B.WORKSHEET&&(o.type=n),_.isObject(i)&&(o.attrs=i),e.setSheetIndex(t),e.generateSheetOperation(p.DELETE_SHEET,null,{undo:!0}),e.generateSheetOperation(p.INSERT_SHEET,o)})},this.generateDeleteSheetOperations=function(e,t){var n={type:U.DELETE_SHEET,sheet:t},r=this.generateUpdateFormulaOperations(e,n,{skipSheet:t});return(r=r.then(function(){return e.setSheetIndex(t),ue.getSheetModel(t).generateRestoreOperations(e)})).done(function(){e.setSheetIndex(t),e.generateSheetOperation(p.DELETE_SHEET)})},this.generateMoveSheetOperations=function(e,t,n){return e.generateOperation(p.MOVE_SHEET,{sheet:n,to:t},{undo:!0,prepend:!0}),e.generateOperation(p.MOVE_SHEET,{sheet:t,to:n}),this.createResolvedPromise()},this.generateMoveSheetsOperations=function(e,t){var r=n.longestSubsequence(t),i=t.reduce(function(e,t,n){return t===r[0]?(r.shift(),e):(e.forEach(function(e){e.to=g.transformIndex(e.to,n,t)}),e.forEach(function(e){t=g.transformIndex(t,e.from,e.to)}),e.push({from:t,to:n}),e)},[]);return this.iterateArraySliced(i,function(t){return ue.generateMoveSheetOperations(e,t.from,t.to)},"SpreadsheetModel.generateMoveSheetsOperations")},this.generateCopySheetOperations=function(e,t,n,r){return x(r).then(function(){var i={};ue.getAllTables().forEach(function(e){i[e.getKey()]=!0});var o=ue.getSheetModel(t),a={};o.getTableCollection().getAllTables().forEach(function(e){for(var t=e.getName(),n=/^(.*?)(\d+)$/.exec(t),r=n?n[1]:g.getTableName(),o=n?parseInt(n[2],10)+1:1;g.getTableKey(r+o)in i;)o+=1;var s=r+o;i[g.getTableKey(s)]=!0,a[t]=s});var s={to:n,sheetName:r};_.isEmpty(a)||(s.tableNames=a),e.setSheetIndex(t).generateSheetOperation(p.COPY_SHEET,s);var l=ue.getSheetModel(n),u={type:U.RENAME_SHEET,sheet:t,sheetName:r,tableNames:a};e.setSheetIndex(n);var h=o.getDrawingCollection().createModelIterator({deep:!0,reverse:!0}),c=ue.iterateSliced(h,function(t){"chart"!==t.getType()||t.isRestorable()||e.generateDrawingOperation(p.DELETE_DRAWING,t.getPosition())},"SpreadsheetModel.generateCopySheetOperations");return(c=c.then(function(){return l.generateUpdateFormulaOperations(e,u)})).done(function(){e.clearOperations({undo:!0}),e.generateSheetOperation(p.DELETE_SHEET,null,{undo:!0})})})},this.generateRenameSheetOperations=function(e,t,n){var r=this.getSheetName(t);return r===n?this.createResolvedPromise():x(n,t).then(function(){var i=new q(ue),o={type:U.RENAME_SHEET,sheet:t,sheetName:n};return ue.generateUpdateFormulaOperations(i,o).done(function(){e.setSheetIndex(t),e.generateSheetOperation(p.RENAME_SHEET,{sheetName:r},{undo:!0}),e.generateSheetOperation(p.RENAME_SHEET,{sheetName:n}),e.appendOperations(i,{undo:!0}),e.appendOperations(i)})})},this.generateChangedViewAttributeOperations=function(e){var t=this.getActiveSheet();return t!==this.getDocumentAttribute("activeSheet")&&e.generateDocAttrsOperation({activeSheet:t}),this.createSheetIterator().forEach(function(t,n){var r=t.getChangedViewAttributes();_.isEmpty(r)||(e.setSheetIndex(n.sheet),t.generateChangeSheetOperations(e,{sheet:r}))}),this},fe=new S(this),Se=new I(this),Ee=new A(this),me=new y(this),Oe=new R(this),Ce=new E(this),ve=new m(this),C.call(this),Re=this.getNode()[0],(_e=s.getPageContentNode(Re)[0]).innerHTML="","ooxml"===he&&(re(p.INSERT_NUMBER_FORMAT,fe,"applyInsertOperation"),re(p.DELETE_NUMBER_FORMAT,fe,"applyDeleteOperation")),this.registerContextOperationHandler(p.INSERT_SHEET,function(e){var t=e.getInt("sheet"),n=e.getStr("sheetName"),r=e.getOptEnum("type",B,B.WORKSHEET),i=e.getOptObj("attrs");e.ensure(!ee,"debug mode: insert sheet fails"),e.ensure(t>=0&&t<=ce.length,"invalid sheet index"),e.ensure(f(n),"invalid sheet name");var o=te(t,r,n,i);e.ensure(o,"cannot create sheet")}),ie(p.DELETE_SHEET,function(e,t,n){e.ensure(ce.length>1,"cannot delete last sheet"),ue.trigger("delete:sheet:before",n,t);var r=ue.getActiveSheet();n<r||n===r&&r+1===ce.length?r-=1:r<n&&(r=-1),r>=0&&ue.setActiveSheet(-1),n+1===ce.length?pe.remove(t.uid):pe.clear(),_e.removeChild(ce[n].node),ce.splice(n,1),t.destroy(),r>=0&&ue.setActiveSheet(ue.findVisibleSheet(r)),ue.trigger("delete:sheet:after",n),ue.trigger("transform:sheet",n,null)}),ie(p.RENAME_SHEET,function(e,t,n){var r=i(n),o=e.getStr("sheetName");e.ensure(f(o,n),"invalid sheet name"),r.name!==o&&(r.name=o,ue.trigger("rename:sheet",n,o,t))}),ie(p.MOVE_SHEET,function(e,t,n){var r=e.getInt("to");e.ensure(r>=0&&r<=ce.length,"invalid target index"),ue.trigger("move:sheet:before",n,r,t);var i=ue.getActiveSheet(),o=g.transformIndex(i,n,r);i!==o&&ue.setActiveSheet(-1);var a=ce[n];ce.splice(n,1),ce.splice(r,0,a),_e.removeChild(a.node),_e.insertBefore(a.node,_e.childNodes.item(r)),pe.clear(),i!==o&&ue.setActiveSheet(o),ue.trigger("move:sheet:after",n,r,t),ue.trigger("transform:sheet",n,r)}),ie(p.COPY_SHEET,function(e,t){var n=e.getInt("to");e.ensure(n>=0&&n<=ce.length,"invalid target index");var r=e.getStr("sheetName");e.ensure(f(r),"invalid sheet name");var i=te(n,t.getType(),r);e.ensure(i,"cannot create sheet"),i.applyCopySheetOperation(e,t)}),function(e,t,n){ie(e,function(e,n){n[t](e)},n)}(p.CHANGE_SHEET,"applyChangeSheetOperation"),oe(p.CHANGE_CELLS,"getCellCollection","applyChangeCellsOperation"),oe(p.INSERT_CELLS,"getCellCollection","applyInsertCellsOperation"),oe(p.DELETE_CELLS,"getCellCollection","applyDeleteCellsOperation"),oe(p.INSERT_HYPERLINK,"getHyperlinkCollection","applyInsertHyperlinkOperation"),oe(p.DELETE_HYPERLINK,"getHyperlinkCollection","applyDeleteHyperlinkOperation"),oe(p.MERGE_CELLS,"getMergeCollection","applyMergeCellsOperation"),oe(p.INSERT_COLUMNS,"getColCollection","applyInsertOperation"),oe(p.DELETE_COLUMNS,"getColCollection","applyDeleteOperation"),oe(p.CHANGE_COLUMNS,"getColCollection","applyChangeOperation"),oe(p.INSERT_ROWS,"getRowCollection","applyInsertOperation"),oe(p.DELETE_ROWS,"getRowCollection","applyDeleteOperation"),oe(p.CHANGE_ROWS,"getRowCollection","applyChangeOperation"),oe(p.INSERT_NAME,"getNameCollection","applyInsertOperation",{allowDoc:!0}),oe(p.DELETE_NAME,"getNameCollection","applyDeleteOperation",{allowDoc:!0}),oe(p.CHANGE_NAME,"getNameCollection","applyChangeOperation",{allowDoc:!0}),oe(p.INSERT_TABLE,"getTableCollection","applyInsertOperation"),oe(p.DELETE_TABLE,"getTableCollection","applyDeleteOperation"),oe(p.CHANGE_TABLE,"getTableCollection","applyChangeOperation"),oe(p.CHANGE_TABLE_COLUMN,"getTableCollection","applyChangeColumnOperation"),oe(p.INSERT_VALIDATION,"getValidationCollection","applyInsertOperation"),oe(p.DELETE_VALIDATION,"getValidationCollection","applyDeleteOperation"),oe(p.CHANGE_VALIDATION,"getValidationCollection","applyChangeOperation"),oe(p.INSERT_CFRULE,"getCondFormatCollection","applyInsertOperation"),oe(p.DELETE_CFRULE,"getCondFormatCollection","applyDeleteOperation"),oe(p.CHANGE_CFRULE,"getCondFormatCollection","applyChangeOperation"),oe(p.INSERT_COMMENT,"getCommentCollection","applyInsertCommentOperation"),oe(p.DELETE_COMMENT,"getCommentCollection","applyDeleteCommentOperation"),oe(p.CHANGE_COMMENT,"getCommentCollection","applyChangeCommentOperation"),oe(p.MOVE_COMMENTS,"getCommentCollection","applyMoveCommentsOperation"),se(p.INSERT_DRAWING,"applyInsertDrawingOperation"),se(p.DELETE_DRAWING,"applyDeleteDrawingOperation"),se(p.MOVE_DRAWING,"applyMoveDrawingOperation"),le(p.CHANGE_DRAWING,"applyChangeOperation"),le(p.INSERT_CHART_DATASERIES,"applyInsertSeriesOperation",{type:"chart"}),le(p.DELETE_CHART_DATASERIES,"applyDeleteSeriesOperation",{type:"chart"}),le(p.SET_CHART_DATASERIES_ATTRIBUTES,"applyChangeSeriesOperation",{type:"chart"}),le(p.SET_CHART_AXIS_ATTRIBUTES,"applyChangeAxisOperation",{type:"chart"}),le(p.SET_CHART_GRIDLINE_ATTRIBUTES,"applyChangeGridOperation",{type:"chart"}),le(p.SET_CHART_TITLE_ATTRIBUTES,"applyChangeTitleOperation",{type:"chart"}),le(p.SET_CHART_LEGEND_ATTRIBUTES,"applyChangeLegendOperation",{type:"chart"}),le(p.DELETE_CHART_AXIS,"applyDeleteAxisOperation",{type:"chart"}),this.waitForImport(function(){if(0!==ce.length){ce.forEach(function(e){e.model.initializeViewAttributes()});var e=M(this.getDocumentAttribute("activeSheet"),0,ce.length-1),t=this.findVisibleSheet(e);t>=0&&this.setActiveSheet(t)}},this),this.listenTo(Ce,"triggered",function(e,t){ue.trigger.apply(ue,[t,null].concat(_.toArray(arguments).slice(2)))}),r(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(e,t){r(t.cols,t.rows)}),this.on("change:sheet:attributes",function(e,t){var n=ue.getActiveSheet();if(t===n&&!ue.getSheetModel(t).isVisible()){var r=ue.findVisibleSheet(n);r>=0&&ue.setActiveSheet(r)}}),this.on("change:viewattributes",function(e,t){"activeSheet"in t&&Ie()}),this.on("change:sheet:viewattributes",function(e,t,n){"selection"in n&&t===ue.getActiveSheet()&&Ie()}),this.on("operations:success",function(e,t){if(t.some(function(e){return e.name in Z})){var n=_.pluck(ce,"model"),r=new H;w(t,function(e){if(e.name in Z){var t=e.start;if(!_.isArray(t)||t.length<3)return;var i=n[t[0]];if(!i)return;var o=i.getDrawingCollection().getModelDescriptor(t.slice(1));if(!o||0===o.remaining.length)return;r.insert(o.model)}else switch(e.name){case p.INSERT_SHEET:n.splice(e.sheet,1);break;case p.DELETE_SHEET:n.splice(e.sheet,0,null);break;case p.MOVE_SHEET:n.splice(e.sheet,0,n.splice(e.to,1)[0]);break;case p.COPY_SHEET:n.splice(e.to,1)}}),r.forEach(function(e){e.getParentCollection().trigger("change:drawing:text",e)})}}),this.listenTo(Re,"mousedown touchstart",function(){ue.setActiveMouseDownEvent(!0)}),this.registerDestructor(function(){Se.disconnect(),ce.forEach(function(e){e.model.destroy()}),Ce.destroy(),ve.destroy(),Oe.destroy(),me.destroy(),Ee.destroy(),Se.destroy(),fe.destroy(),ge.clear(),de.clear(),t=ue=ce=pe=ge=de=null,Ee=me=Oe=Se=null,fe=Ce=ve=null,Re=_e=null})}})});