define("io.ox/office/spreadsheet/model/sheetmodel",["io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/render/rectangle","io.ox/office/editframework/utils/color","io.ox/office/editframework/model/attributedmodel","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/paneutils","io.ox/office/spreadsheet/utils/sheetselection","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/colrowcollection","io.ox/office/spreadsheet/model/mergecollection","io.ox/office/spreadsheet/model/cellcollection","io.ox/office/spreadsheet/model/hyperlinkcollection","io.ox/office/spreadsheet/model/tablecollection","io.ox/office/spreadsheet/model/validationcollection","io.ox/office/spreadsheet/model/condformatcollection","io.ox/office/spreadsheet/model/drawing/drawingcollection","io.ox/office/spreadsheet/model/drawing/commentcollection","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/tokenarray"],function(e,t,n,i,r,o,s,l,a,c,h,u,g,d,f,p,m,v,w,S,R,C,y,b){"use strict";function x(e,t){return e&&t?e.boundary(t):e||t||null}var A=t.isEmpty,O=t.enumCast,T=n.compareNumberArrays,H=i.arrayForEachReverse,I=i.arrayEvery,P=r.Rectangle,E=c.SheetType,M=c.SplitMode,V=c.Address,z=c.Interval,B=c.Range,L=c.RangeArray,F=c.mergeRanges,N=c.modelLogger,k=u.SheetSelection,W=y.FormulaType,D=e.TOUCHDEVICE?1.25:1,U={selection:{def:k.createFromAddress(V.A1),validate:function(t){return t instanceof k?t:e.BREAK},equals:function(e,t){return e.equals(t)}},zoom:{def:1,validate:function(t){return _.isNumber(t)?h.getValidZoom(t):e.BREAK}},showGrid:{def:!0,validate:function(e){return!!e}},splitMode:{def:M.SPLIT,validate:function(t){return t||e.BREAK}},splitWidth:{def:0,validate:function(e){return _.isNumber(e)?Math.max(e,0):0}},splitHeight:{def:0,validate:function(e){return _.isNumber(e)?Math.max(e,0):0}},activePane:{def:"bottomRight",validate:/^(top|bottom)(Left|Right)$/},activePaneSide:{def:null,validate:function(e){return/^(left|right|top|bottom)$/.test(e)?e:null}},anchorLeft:{def:0,validate:function(e){return _.isNumber(e)?e:null}},anchorRight:{def:0,validate:function(e){return _.isNumber(e)?e:null}},anchorTop:{def:0,validate:function(e){return _.isNumber(e)?e:null}},anchorBottom:{def:0,validate:function(e){return _.isNumber(e)?e:null}},activeSelection:{def:null,validate:function(e){return e instanceof k?e:null},equals:function(e,t){return!e&&!t||e&&t&&e.equals(t)}},autoFillData:{def:null,validate:function(e){return _.isObject(e)?e:null}}};return s.extend({constructor:function(t,n,i){function r(e){return L.map(e,function(e){return t.isColRange(e)||t.isRowRange(e)?e:$.expandRangeToMergedRanges(e)})}function u(e){return K.isCellType()?K.getViewAttribute(e?"splitWidth":"splitHeight"):0}function y(e){var t=u(e);if(0===t)return null;var n=K.getViewAttribute(e?"anchorLeft":"anchorTop"),i=new z(Math.floor(n));if(K.hasFrozenSplit())return i.last=i.first+t-1,i;var r=e?J:j,o=r.getScrollAnchorByOffset(r.convertScrollAnchorToHmm(n)+t);return i.last=Math.floor(o),!i.single()&&o%1<.5&&(i.last-=1),!i.single()&&n%1>.5&&(i.first+=1),i}function G(e,t){if(K.hasFrozenSplit()){var n=y(e),i=e?J:j;return n?i.getIntervalPosition(n)[t?"size":"sizeHmm"]:0}var r=u(e);return t?K.convertHmmToPixel(r):r}function Z(e,t,n,i){var r=i?"anchorLeft":"anchorTop",o=i?"anchorRight":"anchorBottom",s=i?"splitWidth":"splitHeight",l=K.hasFrozenSplit()?y(i):null;if(l){var a={};if(n){var c=t.size();t.first<l.first?(a[r]=l.first+c,a[o]=l.last+1+c):t.first<=l.last&&(a[s]=l.size()+c,a[o]=l.last+1+c)}else{var u=t.intersect(l);u&&(a[s]=l.size()-u.size(),0===a[s]&&(a[s]=1)),t.first<l.first&&(a[r]=t.first),t.first<=l.last&&(a[o]=t.first,0===a[o]&&(a[o]=1))}if(0===a[s]){var g=K.getViewAttribute("activePane"),d=h.getNextPanePos(g,i?"right":"bottom");g!==d&&(a.activePane=d),y(!i)||(a.splitMode=M.SPLIT)}K.setViewAttributes(a)}K.trigger(e,t)}var K=this,q=null,J=null,j=null,$=null,Q=null,X=null,Y=null,ee=null,te=null,ne=null,ie=null,re=0,oe=0;s.call(this,t,i,{trigger:"always",families:"sheet column row"}),l.call(this,U,{changeHandler:function(e){"zoom"in e&&(re=e.zoom,oe=re*D)}}),this.postProcessImport=function(){return X.postProcessCells()},this.applyCopySheetOperation=function(e,t){this.setAttributes(t.getExplicitAttributeSet(!0)),q.applyCopySheetOperation(e,t.getNameCollection()),J.applyCopySheetOperation(e,t.getColCollection()),j.applyCopySheetOperation(e,t.getRowCollection()),$.applyCopySheetOperation(e,t.getMergeCollection()),Q.applyCopySheetOperation(e,t.getHyperlinkCollection()),X.applyCopySheetOperation(e,t.getCellCollection()),Y.applyCopySheetOperation(e,t.getTableCollection()),ee.applyCopySheetOperation(e,t.getValidationCollection()),te.applyCopySheetOperation(e,t.getCondFormatCollection()),ne.applyCopySheetOperation(e,t.getDrawingCollection()),ie.applyCopySheetOperation(e,t.getCommentCollection()),this.setViewAttributes(t.getViewAttributes())},this.applyChangeSheetOperation=function(e){this.setAttributes(e.getObj("attrs"))},this.getType=function(){return n},this.isSupportedType=function(){return n===E.WORKSHEET||n===E.CHARTSHEET},this.isWorksheet=function(){return n===E.WORKSHEET},this.isChartsheet=function(){return n===E.CHARTSHEET},this.isCellType=function(){return n===E.WORKSHEET||n===E.MACROSHEET},this.getIndex=function(){return t.getSheetIndexOfModel(this)},this.isActive=function(){return this.getIndex()===t.getActiveSheet()},this.getName=function(){return t.getSheetName(this.getIndex())},this.getNameCollection=function(){return q},this.getColCollection=function(){return J},this.getRowCollection=function(){return j},this.getMergeCollection=function(){return $},this.getCellCollection=function(){return X},this.getHyperlinkCollection=function(){return Q},this.getTableCollection=function(){return Y},this.getValidationCollection=function(){return ee},this.getCondFormatCollection=function(){return te},this.getDrawingCollection=function(){return ne},this.getCommentCollection=function(){return ie},this.createCellTokenArray=function(){return new b(this,W.CELL)},this.convertPixelToHmm=function(t){return e.convertLengthToHmm(t/oe,"px")},this.convertHmmToPixel=function(t){return e.convertHmmToLength(t*oe,"px",1)},this.getEffectiveZoom=function(){return oe},this.getDefaultDigitWidth=function(){return t.getDefaultDigitWidth(oe)},this.getTextPadding=function(e){return t.getTextPadding(e,oe)},this.getTotalCellPadding=function(e){return t.getTotalCellPadding(e,oe)},this.getRowHeight=function(e){return t.getRowHeight(e,oe)},this.getSheetRectangle=function(t){var n=e.getBooleanOption(t,"pixel",!1);return new P(0,0,n?J.getTotalSize():J.getTotalSizeHmm(),n?j.getTotalSize():j.getTotalSizeHmm())},this.getRangeRectangle=function(t,n){var i=e.getBooleanOption(n,"pixel",!1),r=J.getIntervalPosition(t.colInterval()),o=j.getIntervalPosition(t.rowInterval());return new P(i?r.offset:r.offsetHmm,i?o.offset:o.offset.Hmm,i?r.size:r.sizeHmm,i?o.size:o.sizeHmm)},this.getCellRectangle=function(t,n){var i=e.getBooleanOption(n,"expandMerged",!1)?$.getMergedRange(t,"all"):null;if(i)return this.getRangeRectangle(i,n);var r=e.getBooleanOption(n,"pixel",!1),o=J.getEntry(t[0]),s=j.getEntry(t[1]);return new P(r?o.offset:o.offsetHmm,r?s.offset:s.offsetHmm,r?o.size:o.sizeHmm,r?s.size:s.sizeHmm)},this.getAnchorRectangle=function(e){return this.getCellRectangle(e,{pixel:!0,expandMerged:!0})},this.getRangeFromRectangle=function(e,t){var n=J.getEntryByOffset(e.left,t),i=j.getEntryByOffset(e.top,t),r=J.getEntryByOffset(e.right()-1,t),o=j.getEntryByOffset(e.bottom()-1,t);return B.create(n.index,i.index,r.index,o.index)},this.getUsedRange=function(){var e=X.getUsedRange();return e=x(e,$.getUsedRange())},this.isSingleCellInRange=function(e){return e.single()||!!$.getBoundingMergedRange(e)},this.getContentRangeForCell=function(e){return this.isSingleCellInRange(e)?X.findContentRange(e):e},this.areRangesHidden=function(e){return I(e,function(e){return J.isIntervalHidden(e.colInterval())&&j.isIntervalHidden(e.rowInterval())})},this.getVisibleRanges=function(e){return L.map(e,function(e){var t=J.getVisibleIntervals(e.colInterval()),n=j.getVisibleIntervals(e.rowInterval());return L.createFromIntervals(t,n)})},this.getVisibleCell=function(e,t){var n=J.getVisibleEntry(e[0],t),i=j.getVisibleEntry(e[1],t);return n&&i?new V(n.index,i.index):null},this.shrinkRangeToVisible=function(e,t){var n="rows"!==t?J.shrinkIntervalToVisible(e.colInterval()):e.colInterval(),i=n?"columns"!==t?j.shrinkIntervalToVisible(e.rowInterval()):e.rowInterval():null;return i?B.createFromIntervals(n,i):null},this.expandRangeToHidden=function(e){var t=J.expandIntervalToHidden(e.colInterval()),n=j.expandIntervalToHidden(e.rowInterval());return B.createFromIntervals(t,n)},this.mergeAndShrinkRanges=function(e){return e=L.map(e,this.expandRangeToHidden,this).merge(),L.map(e,this.shrinkRangeToVisible,this)},this.hasColSplit=function(){return u(!0)>0},this.hasRowSplit=function(){return u(!1)>0},this.hasSplit=function(){return this.hasColSplit()||this.hasRowSplit()},this.getSplitMode=function(){return this.hasSplit()?this.getViewAttribute("splitMode"):null},this.hasDynamicSplit=function(){var e=this.getSplitMode();return e===M.SPLIT||e===M.FROZEN_SPLIT},this.hasFrozenSplit=function(){var e=this.getSplitMode();return e===M.FROZEN||e===M.FROZEN_SPLIT},this.getSplitWidthHmm=function(){return G(!0,!1)},this.getSplitHeightHmm=function(){return G(!1,!1)},this.getSplitWidth=function(){return G(!0,!0)},this.getSplitHeight=function(){return G(!1,!0)},this.getSplitColInterval=function(){return y(!0)},this.getSplitRowInterval=function(){return y(!1)},this.setDynamicSplit=function(e,t,n){var i=this.getSplitWidthHmm(),r=this.getSplitHeightHmm();return n=_.isObject(n)?_.clone(n):{},_.extend(n,{splitMode:M.SPLIT,splitWidth:e,splitHeight:t}),i>0&&0===n.splitWidth?n.anchorRight=this.getViewAttribute("anchorLeft"):0===i&&n.splitWidth>0&&(n.anchorLeft=this.getViewAttribute("anchorRight")),r>0&&0===n.splitHeight?n.anchorBottom=this.getViewAttribute("anchorTop"):0===r&&n.splitHeight>0&&(n.anchorTop=this.getViewAttribute("anchorBottom")),this.setViewAttributes(n),this},this.setFrozenSplit=function(e,t,n){return n=_.isObject(n)?_.clone(n):{},n.splitMode=this.hasDynamicSplit()?M.FROZEN_SPLIT:M.FROZEN,e?(n.splitWidth=e.size(),n.anchorLeft=e.first,n.anchorRight=e.last+1):n.splitWidth=0,t?(n.splitHeight=t.size(),n.anchorTop=t.first,n.anchorBottom=t.last+1):n.splitHeight=0,this.setViewAttributes(n),this},this.clearSplit=function(){return this.setDynamicSplit(0,0)},this.isVisible=function(){return this.getMergedAttributeSet(!0).sheet.visible},this.isLocked=function(){return!this.isWorksheet()||this.getMergedAttributeSet(!0).sheet.locked},this.getZoom=function(){return re},this.setZoom=function(e){return this.setViewAttribute("zoom",e),this},this.isGridVisible=function(){return this.isCellType()&&this.getViewAttribute("showGrid")},this.toggleGridVisibility=function(e){return this.isCellType()&&this.setViewAttribute("showGrid",e),this},this.getGridColor=function(){return o.parseJSON(this.getMergedAttributeSet(!0).sheet.gridColor)||new o("auto")},this.initializeViewAttributes=_.once(_.bind(function(){var n=K.getMergedAttributeSet(!0).sheet,i=t.parseJSONRanges(n.selectedRanges),o=e.getIntegerOption(n,"activeIndex",0),s=t.parseJSONAddress(n.activeCell),l=e.getArrayOption(n,"selectedDrawings",[]),a=A(i)?null:new k(r(i),o,s,l),c={zoom:n.zoom,showGrid:n.showGrid,splitMode:O(M,n.splitMode,M.SPLIT),splitWidth:n.splitWidth,splitHeight:n.splitHeight,activePane:n.activePane,anchorLeft:n.scrollLeft,anchorRight:n.scrollRight,anchorTop:n.scrollTop,anchorBottom:n.scrollBottom};return a?(a.active!==n.activeIndex&&e.warn("SheetModel.initializeViewAttributes(): sheet="+this.getIndex()+", invalid range index in selection"),a.activeRange().containsAddress(a.address)||(e.warn("SheetModel.initializeViewAttributes(): sheet="+this.getIndex()+", invalid active cell in selection"),a.address=a.activeRange().start.clone())):(e.warn("SheetModel.initializeViewAttributes(): sheet="+this.getIndex()+", invalid selection"),(a=k.createFromAddress(V.A1)).ranges=r(a.ranges)),c.selection=a,0===n.splitWidth&&(c.activePane=h.getNextPanePos(c.activePane,"right"),c.anchorRight=c.anchorLeft,delete c.anchorLeft),0===n.splitHeight&&(c.activePane=h.getNextPanePos(c.activePane,"bottom"),c.anchorBottom=c.anchorTop,delete c.anchorTop),this.setViewAttributes(c),this},this)),this.getChangedViewAttributes=function(){function e(e,n){return Math.min(Math.round(e),t.getMaxIndex(n))}var n=this.getMergedAttributeSet(!0).sheet,i=this.getViewAttributes(),r={selectedRanges:i.selection.ranges.toJSON(),activeIndex:i.selection.active,activeCell:i.selection.address.toJSON(),selectedDrawings:i.selection.drawings,zoom:i.zoom,showGrid:i.showGrid,splitWidth:i.splitWidth,splitHeight:i.splitHeight,activePane:i.activePane,scrollLeft:e(i.anchorLeft,!0),scrollRight:e(i.anchorRight,!0),scrollTop:e(i.anchorTop,!1),scrollBottom:e(i.anchorBottom,!1)},o=i.splitWidth>0,s=i.splitHeight>0;o||(r.activePane=h.getNextPanePos(r.activePane,"left"),r.scrollLeft=r.scrollRight,delete r.scrollRight),s||(r.activePane=h.getNextPanePos(r.activePane,"top"),r.scrollTop=r.scrollBottom,delete r.scrollBottom);var l=o||s?i.splitMode:M.SPLIT;return r.splitMode=l,l!==M.SPLIT&&(r.activePane=o?s?"bottomRight":"topRight":"bottomLeft"),_.each(r,function(e,t){_.isEqual(n[t],e)&&delete r[t]}),r},this.hasChangedViewAttributes=function(){var e=this.getChangedViewAttributes();return delete e.selectedRanges,delete e.activeIndex,delete e.activeCell,delete e.selectedDrawings,delete e.activePane,delete e.scrollLeft,delete e.scrollRight,delete e.scrollTop,delete e.scrollBottom,!_.isEmpty(e)},this.refreshRanges=function(e){return(e=F(e)).empty()||this.trigger("refresh:ranges",e),this},this.canRestoreDeletedRanges=function(e){return Y.canRestoreDeletedRanges(e)&&ne.canRestoreDeletedRanges(e)},this.createOperationGenerator=function(e){var n=t.createSheetOperationGenerator(e);return n.setSheetIndex(this.getIndex()),n},this.createAndApplyOperations=function(e,n){return t.createAndApplySheetOperations(function(t){return t.setSheetIndex(K.getIndex()),e.call(K,t)},n)},this.generateChangeSheetOperations=function(e,t){return e.generateSheetOperation(a.CHANGE_SHEET,{attrs:this.getUndoAttributeSet(t)},{undo:!0}),e.generateSheetOperation(a.CHANGE_SHEET,{attrs:t}),this},this.generateRestoreOperations=function(){return this.createResolvedPromise()},this.generateBeforeMoveCellsOperations=N.profileAsyncMethod("SheetModel.generateBeforeMoveCellsOperations()",function(t,n){return e.invokeChainedAsync(function(){return $.generateBeforeMoveCellsOperations(t,n)},function(){return Q.generateBeforeMoveCellsOperations(t,n)},function(){return Y.generateBeforeMoveCellsOperations(t,n)},function(){return ne.generateBeforeMoveCellsOperations(t,n)},function(){return ie.generateBeforeMoveCellsOperations(t,n)})}),this.generateUpdateFormulaOperations=N.profileAsyncMethod("SheetModel.generateUpdateFormulaOperations()",function(t,n,i){var r="only"===i,o="skip"===i;return e.invokeChainedAsync(r?null:function(){return X.generateUpdateFormulaOperations(t,n)},r?null:function(){return q.generateUpdateFormulaOperations(t,n)},r?null:function(){return ee.generateUpdateFormulaOperations(t,n)},r?null:function(){return te.generateUpdateFormulaOperations(t,n)},o?null:function(){return ne.generateUpdateFormulaOperations(t,n)},o?null:function(){return ie.generateUpdateFormulaOperations(t,n)})}),this.generateRefreshAnchorOperations=N.profileAsyncMethod("SheetModel.generateRefreshAnchorOperations()",function(t){return e.invokeChainedAsync(function(){return ne.generateRefreshAnchorOperations(t)},function(){return ie.generateRefreshAnchorOperations(t)})}),q=new g(this),J=new d(this,!0),j=new d(this,!1),$=new f(this),X=new p(this),Q=new m(this),Y=new v(this),ee=new w(this),te=new S(this),ne=new R(this),ie=new C(this),J.on({"insert:entries":function(e,t){Z("insert:columns",t,!0,!0)},"delete:entries":function(e,t){Z("delete:columns",t,!1,!0)},"change:entries":function(e,t,n){K.trigger("change:columns",t,n)}}),j.on({"insert:entries":function(e,t){Z("insert:rows",t,!0,!1)},"delete:entries":function(e,t){Z("delete:rows",t,!1,!1)},"change:entries":function(e,t,n){K.trigger("change:rows",t,n)}}),$.on("triggered",function(){var e=K.getViewAttribute("selection").clone();e.ranges=r(e.ranges),K.setViewAttribute("selection",e)}),X.on("change:usedrange",function(){K.trigger("change:usedrange",K.getUsedRange())}),$.on("change:usedrange",function(){K.trigger("change:usedrange",K.getUsedRange())}),ne.on({"insert:drawing":function(e,t){var n=K.getViewAttribute("selection");if(0!==n.drawings.length){var i=t.getPosition(),r=i.length,o=_.last(i);(n=n.clone()).drawings.forEach(function(e){e.length<r||0===T(i,e,r-1)&&o<=e[r-1]&&(e[r-1]+=1)}),K.setViewAttribute("selection",n)}},"delete:drawing":function(e,t){var n=K.getViewAttribute("selection");if(0!==n.drawings.length){var i=t.getPosition(),r=i.length,o=_.last(i);n=n.clone(),H(n.drawings,function(e,t){e.length<r||0===T(i,e,r-1)&&(o===e[r-1]?n.drawings.splice(t,1):o<e[r-1]&&(e[r-1]-=1))}),K.setViewAttribute("selection",n)}},"move:drawing":function(e,t,n){var i=K.getViewAttribute("selection");if(0!==i.drawings.length){var r=t.getPosition(),o=r.length,s=_.last(r);(i=i.clone()).drawings.forEach(function(e){e.length<o||0===T(r,e,o-1)&&(e[o-1]=c.transformIndex(e[o-1],n,s))}),K.setViewAttribute("selection",i)}}}),this.forwardEvents(q),this.forwardEvents($,{except:"change:usedrange"}),this.forwardEvents(X,{except:"change:usedrange"}),this.forwardEvents(Q),this.forwardEvents(te),this.forwardEvents(Y),this.forwardEvents(ne),ie.on({"insert:drawing":function(e,t){K.trigger("insert:comment",t)},"delete:drawing":function(e,t){K.trigger("delete:comment",t)},"change:drawing":function(e,t){K.trigger("change:comment",t)},"change:drawing:text":function(e,t){K.trigger("change:comment:text",t)},"move:drawing":function(e,t,n){K.trigger("move:comment",t,n)}}),this.registerDestructor(function(){ie.destroy(),ne.destroy(),te.destroy(),ee.destroy(),Y.destroy(),X.destroy(),Q.destroy(),$.destroy(),J.destroy(),j.destroy(),q.destroy(),K=t=null,q=J=j=$=X=Q=null,Y=ee=te=ne=ie=null})}})});