define("io.ox/office/spreadsheet/utils/sheetutils",["require","exports","io.ox/office/tk/types","io.ox/office/tk/utils/device","io.ox/office/tk/utils/logger","io.ox/office/tk/locale/localedata","io.ox/office/tk/render/font","gettext!io.ox/office/spreadsheet/main","io.ox/office/spreadsheet/utils/errorcodes","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/range3d","io.ox/office/spreadsheet/utils/intervalarray","io.ox/office/spreadsheet/utils/addressarray","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/utils/range3darray","io.ox/office/spreadsheet/utils/intervalset","io.ox/office/spreadsheet/utils/addressset","io.ox/office/spreadsheet/utils/rangeset"],function(e,t,r,o,i,n,s,a,f,u,c,E,l,d,T,L,g,A,O,N){"use strict";function M(e){for(var r in e)t.hasOwnProperty(r)||(t[r]=e[r])}function p(e){return"rtl"===e?"right":"left"}function h(e,t){return e?t?"l":"r":t?"t":"b"}function C(e){return e?"v":"h"}function R(e){return x(e/4)}function I(e){return e===D.UP||e===D.DOWN}function S(e){return e===D.LEFT||e===D.UP}Object.defineProperty(t,"__esModule",{value:!0});var x=Math.ceil;M(f),M(u),M(c),M(E),M(l),M(d),M(T),M(L),M(g),M(A),M(O),M(N);!function(e){e.WORKSHEET="worksheet",e.CHARTSHEET="chartsheet",e.MACROSHEET="macrosheet",e.DIALOGSHEET="dialogsheet"}(t.SheetType||(t.SheetType={}));!function(e){e.SPLIT="split",e.FROZEN="frozen",e.FROZEN_SPLIT="frozenSplit"}(t.SplitMode||(t.SplitMode={}));var D;!function(e){e.LEFT="left",e.RIGHT="right",e.UP="up",e.DOWN="down"}(D=t.Direction||(t.Direction={}));var H;!function(e){e.MERGE="merge",e.HORIZONTAL="horizontal",e.VERTICAL="vertical",e.UNMERGE="unmerge"}(H=t.MergeMode||(t.MergeMode={}));!function(e){e[e.DELETE_SHEET=0]="DELETE_SHEET",e[e.RENAME_SHEET=1]="RENAME_SHEET",e[e.RELABEL_NAME=2]="RELABEL_NAME",e[e.MOVE_CELLS=3]="MOVE_CELLS",e[e.CUT_PASTE=4]="CUT_PASTE"}(t.UpdateMode||(t.UpdateMode={}));!function(e){e[e.VERTICAL=0]="VERTICAL",e[e.HORIZONTAL=1]="HORIZONTAL"}(t.SortDirection||(t.SortDirection={}));!function(e){e.ABSOLUTE="absolute",e.ONE_CELL="oneCell",e.TWO_CELL="twoCell"}(t.AnchorMode||(t.AnchorMode={}));var U={l:"borderLeft",r:"borderRight",t:"borderTop",b:"borderBottom",d:"borderDown",u:"borderUp",v:"borderInsideVert",h:"borderInsideHor"},b={left:"left",center:"center",right:"right",justify:"justify",distribute:"justify",fillAcross:"left",centerAcross:"center"};t.CELL_POOL_ID="cell",t.MAX_NAME_LENGTH=255,t.MAX_FILL_CELL_COUNT=2e4,t.MAX_AUTOFILL_COL_ROW_COUNT=100,t.MAX_MERGED_RANGES_COUNT=1e3,t.MAX_UNMERGE_CELL_COUNT=5e3,t.MAX_CHANGE_COLS_COUNT=2e4,t.MAX_CHANGE_ROWS_COUNT=5e3,t.MAX_SORT_LINES_COUNT=5e3,t.MAX_SORT_LINE_LENGTH=100,t.MAX_LENGTH_STANDARD_CELL=11,t.MAX_LENGTH_STANDARD_EDIT=21,t.MAX_LENGTH_STANDARD_FORMULA=20,t.MIN_CELL_SIZE=5,t.MAX_BORDER_WIDTH=t.MIN_CELL_SIZE,t.MULTI_SELECTION=!o.TOUCH_DEVICE,t.modelLogger=new i.Logger({enable:"spreadsheet:log-models",prefix:"MODEL"}),t.makeRejected=function(e){return r.newDeferred().reject({cause:e}).promise()},t.getNameKey=function(e){return e.toUpperCase()},t.getTableKey=function(e){return e.toUpperCase()},t.getSheetName=function(e){return _.noI18n.fix(a("Sheet%1$d",_.noI18n(String(e))))},t.getTableName=function(){return _.noI18n.fix(a.pgettext("filter","Table"))},t.getTableColName=function(){return _.noI18n.fix(a.pgettext("filter","Column"))},t.hasWrappingAttributes=function(e){var t=e.cell;return!!t.wrapText||"justify"===t.alignHor||"justify"===t.alignVert},t.getTextOrientation=function(e,t,o){var i=r.isString(o)?s.getTextDirection(o):n.DIR,a=b[t];if(!a)switch(typeof e){case"string":a=p(e===o?i:s.getTextDirection(e));break;case"number":a="right";break;default:a=null===e?p(n.DIR):"center"}return{textDir:i,cssTextAlign:a,baseBoxAlign:"justify"===a?p(i):a}},t.getOuterBorderKey=h,t.getInnerBorderKey=C,t.getBorderName=function(e){return U[e]},t.getOuterBorderName=function(e,t){return U[h(e,t)]},t.getInnerBorderName=function(e){return U[C(e)]},t.getTextPadding=R,t.getTotalCellPadding=function(e){return 2*R(e)+1},t.isVerticalDir=I,t.isLeadingDir=S,t.getDirection=function(e,t){return e?t?D.UP:D.DOWN:t?D.LEFT:D.RIGHT},t.transformIndex=function(e,t,r){return e===t?r:t<e&&e<=r?e-1:r<=e&&e<t?e+1:e},t.getAdjacentRange=function(e,t,r){var o=!I(t),i=e.clone();return S(t)?(i.start.move(-r,o),i.end.set(e.start.get(o)-1,o)):(i.start.set(e.end.get(o)+1,o),i.end.move(r,o)),i},t.isOriginCell=function(e,t,r){switch(r){case H.MERGE:return t.startsAt(e);case H.HORIZONTAL:return t.start[0]===e[0];case H.VERTICAL:return t.start[1]===e[1]}return!1}});